/* chess-view.c generated by valac 0.56.14, the Vala compiler
 * generated from chess-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <librsvg/rsvg.h>
#include <gio/gio.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;
typedef struct _ChessViewPrivate ChessViewPrivate;

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
enum  {
	CHESS_VIEW_0_PROPERTY,
	CHESS_VIEW_SCENE_PROPERTY,
	CHESS_VIEW_NUM_PROPERTIES
};
static GParamSpec* chess_view_properties[CHESS_VIEW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _ChessScenePrivate ChessScenePrivate;

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;

struct _ChessView {
	GtkDrawingArea parent_instance;
	ChessViewPrivate * priv;
};

struct _ChessViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ChessViewPrivate {
	gint border;
	gint square_size;
	gint selected_square_size;
	cairo_surface_t* model_surface;
	cairo_surface_t* selected_model_surface;
	gchar* loaded_theme_name;
	ChessScene* _scene;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};

static gint ChessView_private_offset;
static gpointer chess_view_parent_class = NULL;

VALA_EXTERN GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
VALA_EXTERN ChessView* chess_view_new (ChessScene* scene);
VALA_EXTERN ChessView* chess_view_construct (GType object_type,
                                 ChessScene* scene);
static void chess_view_on_click (ChessView* self,
                          GtkGestureClick* _click_controller,
                          gint n_press,
                          gdouble event_x,
                          gdouble event_y);
static void _chess_view_on_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                     gint n_press,
                                                     gdouble x,
                                                     gdouble y,
                                                     gpointer self);
VALA_EXTERN void chess_view_draw (ChessView* self,
                      GtkDrawingArea* _self_,
                      cairo_t* c,
                      gint width,
                      gint height);
static void _chess_view_draw_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                  cairo_t* cr,
                                                  gint width,
                                                  gint height,
                                                  gpointer self);
static void chess_view_real_resize (GtkDrawingArea* base,
                             gint width,
                             gint height);
static void chess_view_render_piece (ChessView* self,
                              cairo_t* c1,
                              cairo_t* c2,
                              const gchar* name,
                              gint offset);
VALA_EXTERN ChessScene* chess_view_get_scene (ChessView* self);
VALA_EXTERN const gchar* chess_scene_get_theme_name (ChessScene* self);
static void chess_view_load_theme (ChessView* self,
                            cairo_t* c);
VALA_EXTERN gdouble chess_scene_get_board_angle (ChessScene* self);
static gdouble chess_view_get_border_size (ChessView* self);
VALA_EXTERN gboolean chess_scene_get_show_numbering (ChessScene* self);
VALA_EXTERN ChessGame* chess_scene_get_game (ChessScene* self);
VALA_EXTERN void chess_view_draw_paused_overlay (ChessView* self,
                                     cairo_t* c);
VALA_EXTERN GType chess_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessModel, g_object_unref)
VALA_EXTERN gboolean chess_scene_get_show_move_hints (ChessScene* self);
static void chess_view_draw_piece (ChessView* self,
                            cairo_t* c,
                            cairo_surface_t* surface,
                            gint size,
                            ChessPiece* piece,
                            gdouble alpha);
VALA_EXTERN gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
VALA_EXTERN ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
VALA_EXTERN void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static void chess_view_scene_changed_cb (ChessView* self,
                                  ChessScene* scene);
VALA_EXTERN void chess_view_set_scene (ChessView* self,
                           ChessScene* value);
static void _chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                       gpointer self);
static void chess_view_finalize (GObject * obj);
static GType chess_view_get_type_once (void);
static void _vala_chess_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_chess_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
chess_view_get_instance_private (ChessView* self)
{
	return G_STRUCT_MEMBER_P (self, ChessView_private_offset);
}

static void
_chess_view_on_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y,
                                                gpointer self)
{
#line 44 "../src/chess-view.vala"
	chess_view_on_click ((ChessView*) self, _sender, n_press, x, y);
#line 240 "chess-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/chess-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 248 "chess-view.c"
}

static void
_chess_view_draw_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                             cairo_t* cr,
                                             gint width,
                                             gint height,
                                             gpointer self)
{
#line 47 "../src/chess-view.vala"
	chess_view_draw ((ChessView*) self, drawing_area, cr, width, height);
#line 260 "chess-view.c"
}

ChessView*
chess_view_construct (GType object_type,
                      ChessScene* scene)
{
	ChessView * self = NULL;
	GtkGestureClick* click_controller = NULL;
	GtkGestureClick* _tmp0_;
	GtkEventController* _tmp1_;
#line 39 "../src/chess-view.vala"
	g_return_val_if_fail (scene != NULL, NULL);
#line 41 "../src/chess-view.vala"
	self = (ChessView*) g_object_new (object_type, "scene", scene, NULL);
#line 43 "../src/chess-view.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 43 "../src/chess-view.vala"
	click_controller = _tmp0_;
#line 44 "../src/chess-view.vala"
	g_signal_connect_object (click_controller, "pressed", (GCallback) _chess_view_on_click_gtk_gesture_click_pressed, self, 0);
#line 45 "../src/chess-view.vala"
	_tmp1_ = _g_object_ref0 ((GtkEventController*) click_controller);
#line 45 "../src/chess-view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp1_);
#line 47 "../src/chess-view.vala"
	gtk_drawing_area_set_draw_func ((GtkDrawingArea*) self, _chess_view_draw_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 49 "../src/chess-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 50 "../src/chess-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 51 "../src/chess-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 100, 100);
#line 39 "../src/chess-view.vala"
	_g_object_unref0 (click_controller);
#line 39 "../src/chess-view.vala"
	return self;
#line 297 "chess-view.c"
}

ChessView*
chess_view_new (ChessScene* scene)
{
#line 39 "../src/chess-view.vala"
	return chess_view_construct (TYPE_CHESS_VIEW, scene);
#line 305 "chess-view.c"
}

static void
chess_view_real_resize (GtkDrawingArea* base,
                        gint width,
                        gint height)
{
	ChessView * self;
	gint short_edge = 0;
	gdouble extra = 0.0;
#line 54 "../src/chess-view.vala"
	self = (ChessView*) base;
#line 56 "../src/chess-view.vala"
	short_edge = MIN (width, height);
#line 58 "../src/chess-view.vala"
	self->priv->square_size = (gint) floor ((short_edge - (2 * self->priv->border)) / 9.0);
#line 59 "../src/chess-view.vala"
	extra = self->priv->square_size * 0.1;
#line 60 "../src/chess-view.vala"
	if (extra < ((gdouble) 3)) {
#line 61 "../src/chess-view.vala"
		extra = (gdouble) 3;
#line 328 "chess-view.c"
	}
#line 62 "../src/chess-view.vala"
	self->priv->selected_square_size = self->priv->square_size + (2 * ((gint) (extra + 0.5)));
#line 332 "chess-view.c"
}

static void
chess_view_render_piece (ChessView* self,
                         cairo_t* c1,
                         cairo_t* c2,
                         const gchar* name,
                         gint offset)
{
	RsvgHandle* handle = NULL;
	GError* _inner_error0_ = NULL;
#line 65 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/chess-view.vala"
	g_return_if_fail (c1 != NULL);
#line 65 "../src/chess-view.vala"
	g_return_if_fail (c2 != NULL);
#line 65 "../src/chess-view.vala"
	g_return_if_fail (name != NULL);
#line 352 "chess-view.c"
	{
		GInputStream* stream = NULL;
		ChessScene* _tmp0_;
		ChessScene* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GInputStream* _tmp8_;
		GInputStream* _tmp9_;
		RsvgHandle* _tmp10_ = NULL;
		GInputStream* _tmp11_;
		RsvgHandle* _tmp12_;
		RsvgHandle* _tmp13_;
#line 70 "../src/chess-view.vala"
		_tmp0_ = chess_view_get_scene (self);
#line 70 "../src/chess-view.vala"
		_tmp1_ = _tmp0_;
#line 70 "../src/chess-view.vala"
		_tmp2_ = chess_scene_get_theme_name (_tmp1_);
#line 70 "../src/chess-view.vala"
		_tmp3_ = _tmp2_;
#line 70 "../src/chess-view.vala"
		_tmp4_ = g_strconcat (name, ".svg", NULL);
#line 70 "../src/chess-view.vala"
		_tmp5_ = _tmp4_;
#line 70 "../src/chess-view.vala"
		_tmp6_ = g_build_path ("/", "/org/gnome/Chess/pieces", _tmp3_, _tmp5_, NULL);
#line 70 "../src/chess-view.vala"
		_tmp7_ = _tmp6_;
#line 70 "../src/chess-view.vala"
		_tmp8_ = g_resources_open_stream (_tmp7_, G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 70 "../src/chess-view.vala"
		_tmp9_ = _tmp8_;
#line 70 "../src/chess-view.vala"
		_g_free0 (_tmp7_);
#line 70 "../src/chess-view.vala"
		_g_free0 (_tmp5_);
#line 70 "../src/chess-view.vala"
		stream = _tmp9_;
#line 70 "../src/chess-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 397 "chess-view.c"
			goto __catch0_g_error;
		}
#line 71 "../src/chess-view.vala"
		_tmp11_ = stream;
#line 71 "../src/chess-view.vala"
		_tmp12_ = rsvg_handle_new_from_stream_sync (_tmp11_, NULL, RSVG_HANDLE_FLAGS_NONE, NULL, &_inner_error0_);
#line 71 "../src/chess-view.vala"
		_tmp10_ = _tmp12_;
#line 71 "../src/chess-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 71 "../src/chess-view.vala"
			_g_object_unref0 (stream);
#line 410 "chess-view.c"
			goto __catch0_g_error;
		}
#line 71 "../src/chess-view.vala"
		_tmp13_ = _tmp10_;
#line 71 "../src/chess-view.vala"
		_tmp10_ = NULL;
#line 71 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 71 "../src/chess-view.vala"
		handle = _tmp13_;
#line 68 "../src/chess-view.vala"
		_g_object_unref0 (_tmp10_);
#line 68 "../src/chess-view.vala"
		_g_object_unref0 (stream);
#line 425 "chess-view.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
#line 68 "../src/chess-view.vala"
		e = _inner_error0_;
#line 68 "../src/chess-view.vala"
		_inner_error0_ = NULL;
#line 75 "../src/chess-view.vala"
		_tmp14_ = e;
#line 75 "../src/chess-view.vala"
		_tmp15_ = _tmp14_->message;
#line 75 "../src/chess-view.vala"
		g_warning ("chess-view.vala:75: Failed to load piece SVG: %s", _tmp15_);
#line 76 "../src/chess-view.vala"
		_g_error_free0 (e);
#line 76 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 76 "../src/chess-view.vala"
		return;
#line 449 "chess-view.c"
	}
	__finally0:
#line 68 "../src/chess-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 68 "../src/chess-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 68 "../src/chess-view.vala"
		g_clear_error (&_inner_error0_);
#line 68 "../src/chess-view.vala"
		return;
#line 462 "chess-view.c"
	}
	{
		RsvgHandle* _tmp16_;
		RsvgRectangle _tmp17_ = {0};
		RsvgHandle* _tmp18_;
		RsvgRectangle _tmp19_ = {0};
#line 81 "../src/chess-view.vala"
		_tmp16_ = handle;
#line 81 "../src/chess-view.vala"
		memset (&_tmp17_, 0, sizeof (RsvgRectangle));
#line 81 "../src/chess-view.vala"
		_tmp17_.height = (gdouble) self->priv->square_size;
#line 81 "../src/chess-view.vala"
		_tmp17_.width = (gdouble) self->priv->square_size;
#line 81 "../src/chess-view.vala"
		_tmp17_.x = (gdouble) (self->priv->square_size * offset);
#line 81 "../src/chess-view.vala"
		_tmp17_.y = (gdouble) 0;
#line 81 "../src/chess-view.vala"
		rsvg_handle_render_document (_tmp16_, c1, &_tmp17_, &_inner_error0_);
#line 81 "../src/chess-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 485 "chess-view.c"
			goto __catch1_g_error;
		}
#line 82 "../src/chess-view.vala"
		_tmp18_ = handle;
#line 82 "../src/chess-view.vala"
		memset (&_tmp19_, 0, sizeof (RsvgRectangle));
#line 82 "../src/chess-view.vala"
		_tmp19_.height = (gdouble) self->priv->selected_square_size;
#line 82 "../src/chess-view.vala"
		_tmp19_.width = (gdouble) self->priv->selected_square_size;
#line 82 "../src/chess-view.vala"
		_tmp19_.x = (gdouble) (self->priv->selected_square_size * offset);
#line 82 "../src/chess-view.vala"
		_tmp19_.y = (gdouble) 0;
#line 82 "../src/chess-view.vala"
		rsvg_handle_render_document (_tmp18_, c2, &_tmp19_, &_inner_error0_);
#line 82 "../src/chess-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 504 "chess-view.c"
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
#line 79 "../src/chess-view.vala"
		e = _inner_error0_;
#line 79 "../src/chess-view.vala"
		_inner_error0_ = NULL;
#line 86 "../src/chess-view.vala"
		_tmp20_ = e;
#line 86 "../src/chess-view.vala"
		_tmp21_ = _tmp20_->message;
#line 86 "../src/chess-view.vala"
		g_warning ("chess-view.vala:86: Failed to render piece SVG: %s", _tmp21_);
#line 79 "../src/chess-view.vala"
		_g_error_free0 (e);
#line 526 "chess-view.c"
	}
	__finally1:
#line 79 "../src/chess-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 79 "../src/chess-view.vala"
		_g_object_unref0 (handle);
#line 79 "../src/chess-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 79 "../src/chess-view.vala"
		g_clear_error (&_inner_error0_);
#line 79 "../src/chess-view.vala"
		return;
#line 539 "chess-view.c"
	}
#line 65 "../src/chess-view.vala"
	_g_object_unref0 (handle);
#line 543 "chess-view.c"
}

static void
chess_view_load_theme (ChessView* self,
                       cairo_t* c)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	cairo_surface_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	cairo_surface_t* _tmp11_;
	cairo_t* c1 = NULL;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* c2 = NULL;
	cairo_surface_t* _tmp14_;
	cairo_t* _tmp15_;
	cairo_t* _tmp16_;
	cairo_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	ChessScene* _tmp40_;
	ChessScene* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gchar* _tmp44_;
#line 90 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 93 "../src/chess-view.vala"
	_tmp2_ = chess_view_get_scene (self);
#line 93 "../src/chess-view.vala"
	_tmp3_ = _tmp2_;
#line 93 "../src/chess-view.vala"
	_tmp4_ = chess_scene_get_theme_name (_tmp3_);
#line 93 "../src/chess-view.vala"
	_tmp5_ = _tmp4_;
#line 93 "../src/chess-view.vala"
	_tmp6_ = self->priv->loaded_theme_name;
#line 93 "../src/chess-view.vala"
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
#line 611 "chess-view.c"
		cairo_surface_t* _tmp7_;
#line 93 "../src/chess-view.vala"
		_tmp7_ = self->priv->model_surface;
#line 93 "../src/chess-view.vala"
		_tmp1_ = _tmp7_ != NULL;
#line 617 "chess-view.c"
	} else {
#line 93 "../src/chess-view.vala"
		_tmp1_ = FALSE;
#line 621 "chess-view.c"
	}
#line 93 "../src/chess-view.vala"
	if (_tmp1_) {
#line 625 "chess-view.c"
		cairo_surface_t* _tmp8_;
#line 93 "../src/chess-view.vala"
		_tmp8_ = self->priv->model_surface;
#line 93 "../src/chess-view.vala"
		_tmp0_ = self->priv->square_size == cairo_image_surface_get_height (_tmp8_);
#line 631 "chess-view.c"
	} else {
#line 93 "../src/chess-view.vala"
		_tmp0_ = FALSE;
#line 635 "chess-view.c"
	}
#line 93 "../src/chess-view.vala"
	if (_tmp0_) {
#line 94 "../src/chess-view.vala"
		return;
#line 641 "chess-view.c"
	}
#line 96 "../src/chess-view.vala"
	_tmp9_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 12 * self->priv->square_size, self->priv->square_size);
#line 96 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->model_surface);
#line 96 "../src/chess-view.vala"
	self->priv->model_surface = _tmp9_;
#line 97 "../src/chess-view.vala"
	_tmp10_ = cairo_get_target (c);
#line 97 "../src/chess-view.vala"
	_tmp11_ = cairo_surface_create_similar (_tmp10_, CAIRO_CONTENT_COLOR_ALPHA, 12 * self->priv->selected_square_size, self->priv->selected_square_size);
#line 97 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
#line 97 "../src/chess-view.vala"
	self->priv->selected_model_surface = _tmp11_;
#line 99 "../src/chess-view.vala"
	_tmp12_ = self->priv->model_surface;
#line 99 "../src/chess-view.vala"
	_tmp13_ = cairo_create (_tmp12_);
#line 99 "../src/chess-view.vala"
	c1 = _tmp13_;
#line 100 "../src/chess-view.vala"
	_tmp14_ = self->priv->selected_model_surface;
#line 100 "../src/chess-view.vala"
	_tmp15_ = cairo_create (_tmp14_);
#line 100 "../src/chess-view.vala"
	c2 = _tmp15_;
#line 101 "../src/chess-view.vala"
	_tmp16_ = c1;
#line 101 "../src/chess-view.vala"
	_tmp17_ = c2;
#line 101 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp16_, _tmp17_, "whitePawn", 0);
#line 102 "../src/chess-view.vala"
	_tmp18_ = c1;
#line 102 "../src/chess-view.vala"
	_tmp19_ = c2;
#line 102 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp18_, _tmp19_, "whiteRook", 1);
#line 103 "../src/chess-view.vala"
	_tmp20_ = c1;
#line 103 "../src/chess-view.vala"
	_tmp21_ = c2;
#line 103 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp20_, _tmp21_, "whiteKnight", 2);
#line 104 "../src/chess-view.vala"
	_tmp22_ = c1;
#line 104 "../src/chess-view.vala"
	_tmp23_ = c2;
#line 104 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp22_, _tmp23_, "whiteBishop", 3);
#line 105 "../src/chess-view.vala"
	_tmp24_ = c1;
#line 105 "../src/chess-view.vala"
	_tmp25_ = c2;
#line 105 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp24_, _tmp25_, "whiteQueen", 4);
#line 106 "../src/chess-view.vala"
	_tmp26_ = c1;
#line 106 "../src/chess-view.vala"
	_tmp27_ = c2;
#line 106 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp26_, _tmp27_, "whiteKing", 5);
#line 107 "../src/chess-view.vala"
	_tmp28_ = c1;
#line 107 "../src/chess-view.vala"
	_tmp29_ = c2;
#line 107 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp28_, _tmp29_, "blackPawn", 6);
#line 108 "../src/chess-view.vala"
	_tmp30_ = c1;
#line 108 "../src/chess-view.vala"
	_tmp31_ = c2;
#line 108 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp30_, _tmp31_, "blackRook", 7);
#line 109 "../src/chess-view.vala"
	_tmp32_ = c1;
#line 109 "../src/chess-view.vala"
	_tmp33_ = c2;
#line 109 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp32_, _tmp33_, "blackKnight", 8);
#line 110 "../src/chess-view.vala"
	_tmp34_ = c1;
#line 110 "../src/chess-view.vala"
	_tmp35_ = c2;
#line 110 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp34_, _tmp35_, "blackBishop", 9);
#line 111 "../src/chess-view.vala"
	_tmp36_ = c1;
#line 111 "../src/chess-view.vala"
	_tmp37_ = c2;
#line 111 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp36_, _tmp37_, "blackQueen", 10);
#line 112 "../src/chess-view.vala"
	_tmp38_ = c1;
#line 112 "../src/chess-view.vala"
	_tmp39_ = c2;
#line 112 "../src/chess-view.vala"
	chess_view_render_piece (self, _tmp38_, _tmp39_, "blackKing", 11);
#line 114 "../src/chess-view.vala"
	_tmp40_ = chess_view_get_scene (self);
#line 114 "../src/chess-view.vala"
	_tmp41_ = _tmp40_;
#line 114 "../src/chess-view.vala"
	_tmp42_ = chess_scene_get_theme_name (_tmp41_);
#line 114 "../src/chess-view.vala"
	_tmp43_ = _tmp42_;
#line 114 "../src/chess-view.vala"
	_tmp44_ = g_strdup (_tmp43_);
#line 114 "../src/chess-view.vala"
	_g_free0 (self->priv->loaded_theme_name);
#line 114 "../src/chess-view.vala"
	self->priv->loaded_theme_name = _tmp44_;
#line 90 "../src/chess-view.vala"
	_cairo_destroy0 (c2);
#line 90 "../src/chess-view.vala"
	_cairo_destroy0 (c1);
#line 759 "chess-view.c"
}

void
chess_view_draw (ChessView* self,
                 GtkDrawingArea* _self_,
                 cairo_t* c,
                 gint width,
                 gint height)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint board_size = 0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	ChessScene* _tmp10_;
	ChessScene* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	ChessScene* _tmp92_;
	ChessScene* _tmp93_;
	ChessGame* _tmp94_;
	ChessGame* _tmp95_;
	gboolean _tmp96_;
	gboolean _tmp97_;
	ChessScene* _tmp102_;
	ChessScene* _tmp103_;
	GList* _tmp104_;
#line 117 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 117 "../src/chess-view.vala"
	g_return_if_fail (_self_ != NULL);
#line 117 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 119 "../src/chess-view.vala"
	chess_view_load_theme (self, c);
#line 121 "../src/chess-view.vala"
	cairo_translate (c, (gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2), (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) / 2));
#line 122 "../src/chess-view.vala"
	_tmp0_ = chess_view_get_scene (self);
#line 122 "../src/chess-view.vala"
	_tmp1_ = _tmp0_;
#line 122 "../src/chess-view.vala"
	_tmp2_ = chess_scene_get_board_angle (_tmp1_);
#line 122 "../src/chess-view.vala"
	_tmp3_ = _tmp2_;
#line 122 "../src/chess-view.vala"
	cairo_rotate (c, (G_PI * _tmp3_) / 180.0);
#line 124 "../src/chess-view.vala"
	_tmp4_ = chess_view_get_border_size (self);
#line 124 "../src/chess-view.vala"
	_tmp5_ = _tmp4_;
#line 124 "../src/chess-view.vala"
	board_size = (gint) ceil ((self->priv->square_size * 4) + _tmp5_);
#line 125 "../src/chess-view.vala"
	cairo_set_source_rgb (c, 0x2e / 255.0, 0x34 / 255.0, 0x36 / 255.0);
#line 126 "../src/chess-view.vala"
	cairo_rectangle (c, (gdouble) (-board_size), (gdouble) (-board_size), (gdouble) (board_size * 2), (gdouble) (board_size * 2));
#line 127 "../src/chess-view.vala"
	cairo_fill (c);
#line 821 "chess-view.c"
	{
		gint file = 0;
#line 129 "../src/chess-view.vala"
		file = 0;
#line 826 "chess-view.c"
		{
			gboolean _tmp6_ = FALSE;
#line 129 "../src/chess-view.vala"
			_tmp6_ = TRUE;
#line 129 "../src/chess-view.vala"
			while (TRUE) {
#line 129 "../src/chess-view.vala"
				if (!_tmp6_) {
#line 835 "chess-view.c"
					gint _tmp7_;
#line 129 "../src/chess-view.vala"
					_tmp7_ = file;
#line 129 "../src/chess-view.vala"
					file = _tmp7_ + 1;
#line 841 "chess-view.c"
				}
#line 129 "../src/chess-view.vala"
				_tmp6_ = FALSE;
#line 129 "../src/chess-view.vala"
				if (!(file < 8)) {
#line 129 "../src/chess-view.vala"
					break;
#line 849 "chess-view.c"
				}
				{
					gint rank = 0;
#line 131 "../src/chess-view.vala"
					rank = 0;
#line 855 "chess-view.c"
					{
						gboolean _tmp8_ = FALSE;
#line 131 "../src/chess-view.vala"
						_tmp8_ = TRUE;
#line 131 "../src/chess-view.vala"
						while (TRUE) {
#line 862 "chess-view.c"
							gint x = 0;
							gint y = 0;
#line 131 "../src/chess-view.vala"
							if (!_tmp8_) {
#line 867 "chess-view.c"
								gint _tmp9_;
#line 131 "../src/chess-view.vala"
								_tmp9_ = rank;
#line 131 "../src/chess-view.vala"
								rank = _tmp9_ + 1;
#line 873 "chess-view.c"
							}
#line 131 "../src/chess-view.vala"
							_tmp8_ = FALSE;
#line 131 "../src/chess-view.vala"
							if (!(rank < 8)) {
#line 131 "../src/chess-view.vala"
								break;
#line 881 "chess-view.c"
							}
#line 133 "../src/chess-view.vala"
							x = (gint) ((file - 4) * self->priv->square_size);
#line 134 "../src/chess-view.vala"
							y = (gint) ((3 - rank) * self->priv->square_size);
#line 136 "../src/chess-view.vala"
							cairo_rectangle (c, (gdouble) x, (gdouble) y, (gdouble) self->priv->square_size, (gdouble) self->priv->square_size);
#line 137 "../src/chess-view.vala"
							if (((file + rank) % 2) == 0) {
#line 138 "../src/chess-view.vala"
								cairo_set_source_rgb (c, 0xba / 255.0, 0xbd / 255.0, 0xb6 / 255.0);
#line 893 "chess-view.c"
							} else {
#line 140 "../src/chess-view.vala"
								cairo_set_source_rgb (c, 0xee / 255.0, 0xee / 255.0, 0xec / 255.0);
#line 897 "chess-view.c"
							}
#line 141 "../src/chess-view.vala"
							cairo_fill (c);
#line 901 "chess-view.c"
						}
					}
				}
			}
		}
	}
#line 145 "../src/chess-view.vala"
	_tmp10_ = chess_view_get_scene (self);
#line 145 "../src/chess-view.vala"
	_tmp11_ = _tmp10_;
#line 145 "../src/chess-view.vala"
	_tmp12_ = chess_scene_get_show_numbering (_tmp11_);
#line 145 "../src/chess-view.vala"
	_tmp13_ = _tmp12_;
#line 145 "../src/chess-view.vala"
	if (_tmp13_) {
#line 918 "chess-view.c"
		gdouble _tmp14_;
		gdouble _tmp15_;
		cairo_text_extents_t extents = {0};
		cairo_text_extents_t _tmp16_ = {0};
		gdouble y_offset = 0.0;
		cairo_text_extents_t _tmp17_;
		cairo_text_extents_t _tmp18_;
		cairo_text_extents_t _tmp19_;
		gdouble top = 0.0;
		gdouble bottom = 0.0;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gdouble file_offset = 0.0;
		gdouble rank_offset = 0.0;
		gchar** files = NULL;
		gint files_length1 = 0;
		gint _files_size_ = 0;
		gchar** ranks = NULL;
		gint ranks_length1 = 0;
		gint _ranks_size_ = 0;
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp22_ = {0};
		ChessScene* _tmp23_;
		ChessScene* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		cairo_matrix_t _tmp63_;
#line 150 "../src/chess-view.vala"
		cairo_set_source_rgb (c, 0x88 / 255.0, 0x8a / 255.0, 0x85 / 255.0);
#line 151 "../src/chess-view.vala"
		_tmp14_ = chess_view_get_border_size (self);
#line 151 "../src/chess-view.vala"
		_tmp15_ = _tmp14_;
#line 151 "../src/chess-view.vala"
		cairo_set_font_size (c, _tmp15_ * 0.6);
#line 152 "../src/chess-view.vala"
		cairo_select_font_face (c, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 155 "../src/chess-view.vala"
		cairo_text_extents (c, "abcdefgh", &_tmp16_);
#line 155 "../src/chess-view.vala"
		extents = _tmp16_;
#line 156 "../src/chess-view.vala"
		_tmp17_ = extents;
#line 156 "../src/chess-view.vala"
		_tmp18_ = extents;
#line 156 "../src/chess-view.vala"
		_tmp19_ = extents;
#line 156 "../src/chess-view.vala"
		y_offset = ((((self->priv->square_size / 2) - _tmp17_.height) / 2) + _tmp18_.height) + _tmp19_.y_bearing;
#line 157 "../src/chess-view.vala"
		top = -((self->priv->square_size * 4) + y_offset);
#line 158 "../src/chess-view.vala"
		_tmp20_ = chess_view_get_border_size (self);
#line 158 "../src/chess-view.vala"
		_tmp21_ = _tmp20_;
#line 158 "../src/chess-view.vala"
		bottom = ((self->priv->square_size * 4) + _tmp21_) - y_offset;
#line 160 "../src/chess-view.vala"
		file_offset = -(self->priv->square_size * 3.5);
#line 161 "../src/chess-view.vala"
		rank_offset = -(self->priv->square_size * 3.5);
#line 166 "../src/chess-view.vala"
		cairo_get_matrix (c, &_tmp22_);
#line 166 "../src/chess-view.vala"
		matrix = _tmp22_;
#line 168 "../src/chess-view.vala"
		_tmp23_ = chess_view_get_scene (self);
#line 168 "../src/chess-view.vala"
		_tmp24_ = _tmp23_;
#line 168 "../src/chess-view.vala"
		_tmp25_ = chess_scene_get_board_angle (_tmp24_);
#line 168 "../src/chess-view.vala"
		_tmp26_ = _tmp25_;
#line 168 "../src/chess-view.vala"
		if (_tmp26_ == 180.0) {
#line 994 "chess-view.c"
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar** _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar** _tmp44_;
#line 170 "../src/chess-view.vala"
			_tmp27_ = g_strdup ("h");
#line 170 "../src/chess-view.vala"
			_tmp28_ = g_strdup ("g");
#line 170 "../src/chess-view.vala"
			_tmp29_ = g_strdup ("f");
#line 170 "../src/chess-view.vala"
			_tmp30_ = g_strdup ("e");
#line 170 "../src/chess-view.vala"
			_tmp31_ = g_strdup ("d");
#line 170 "../src/chess-view.vala"
			_tmp32_ = g_strdup ("c");
#line 170 "../src/chess-view.vala"
			_tmp33_ = g_strdup ("b");
#line 170 "../src/chess-view.vala"
			_tmp34_ = g_strdup ("a");
#line 170 "../src/chess-view.vala"
			_tmp35_ = g_new0 (gchar*, 8 + 1);
#line 170 "../src/chess-view.vala"
			_tmp35_[0] = _tmp27_;
#line 170 "../src/chess-view.vala"
			_tmp35_[1] = _tmp28_;
#line 170 "../src/chess-view.vala"
			_tmp35_[2] = _tmp29_;
#line 170 "../src/chess-view.vala"
			_tmp35_[3] = _tmp30_;
#line 170 "../src/chess-view.vala"
			_tmp35_[4] = _tmp31_;
#line 170 "../src/chess-view.vala"
			_tmp35_[5] = _tmp32_;
#line 170 "../src/chess-view.vala"
			_tmp35_[6] = _tmp33_;
#line 170 "../src/chess-view.vala"
			_tmp35_[7] = _tmp34_;
#line 170 "../src/chess-view.vala"
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 170 "../src/chess-view.vala"
			files = _tmp35_;
#line 170 "../src/chess-view.vala"
			files_length1 = 8;
#line 170 "../src/chess-view.vala"
			_files_size_ = files_length1;
#line 171 "../src/chess-view.vala"
			_tmp36_ = g_strdup ("1");
#line 171 "../src/chess-view.vala"
			_tmp37_ = g_strdup ("2");
#line 171 "../src/chess-view.vala"
			_tmp38_ = g_strdup ("3");
#line 171 "../src/chess-view.vala"
			_tmp39_ = g_strdup ("4");
#line 171 "../src/chess-view.vala"
			_tmp40_ = g_strdup ("5");
#line 171 "../src/chess-view.vala"
			_tmp41_ = g_strdup ("6");
#line 171 "../src/chess-view.vala"
			_tmp42_ = g_strdup ("7");
#line 171 "../src/chess-view.vala"
			_tmp43_ = g_strdup ("8");
#line 171 "../src/chess-view.vala"
			_tmp44_ = g_new0 (gchar*, 8 + 1);
#line 171 "../src/chess-view.vala"
			_tmp44_[0] = _tmp36_;
#line 171 "../src/chess-view.vala"
			_tmp44_[1] = _tmp37_;
#line 171 "../src/chess-view.vala"
			_tmp44_[2] = _tmp38_;
#line 171 "../src/chess-view.vala"
			_tmp44_[3] = _tmp39_;
#line 171 "../src/chess-view.vala"
			_tmp44_[4] = _tmp40_;
#line 171 "../src/chess-view.vala"
			_tmp44_[5] = _tmp41_;
#line 171 "../src/chess-view.vala"
			_tmp44_[6] = _tmp42_;
#line 171 "../src/chess-view.vala"
			_tmp44_[7] = _tmp43_;
#line 171 "../src/chess-view.vala"
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 171 "../src/chess-view.vala"
			ranks = _tmp44_;
#line 171 "../src/chess-view.vala"
			ranks_length1 = 8;
#line 171 "../src/chess-view.vala"
			_ranks_size_ = ranks_length1;
#line 173 "../src/chess-view.vala"
			cairo_matrix_scale (&matrix, (gdouble) -1, (gdouble) -1);
#line 1099 "chess-view.c"
		} else {
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			gchar** _tmp53_;
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			gchar** _tmp62_;
#line 177 "../src/chess-view.vala"
			_tmp45_ = g_strdup ("a");
#line 177 "../src/chess-view.vala"
			_tmp46_ = g_strdup ("b");
#line 177 "../src/chess-view.vala"
			_tmp47_ = g_strdup ("c");
#line 177 "../src/chess-view.vala"
			_tmp48_ = g_strdup ("d");
#line 177 "../src/chess-view.vala"
			_tmp49_ = g_strdup ("e");
#line 177 "../src/chess-view.vala"
			_tmp50_ = g_strdup ("f");
#line 177 "../src/chess-view.vala"
			_tmp51_ = g_strdup ("g");
#line 177 "../src/chess-view.vala"
			_tmp52_ = g_strdup ("h");
#line 177 "../src/chess-view.vala"
			_tmp53_ = g_new0 (gchar*, 8 + 1);
#line 177 "../src/chess-view.vala"
			_tmp53_[0] = _tmp45_;
#line 177 "../src/chess-view.vala"
			_tmp53_[1] = _tmp46_;
#line 177 "../src/chess-view.vala"
			_tmp53_[2] = _tmp47_;
#line 177 "../src/chess-view.vala"
			_tmp53_[3] = _tmp48_;
#line 177 "../src/chess-view.vala"
			_tmp53_[4] = _tmp49_;
#line 177 "../src/chess-view.vala"
			_tmp53_[5] = _tmp50_;
#line 177 "../src/chess-view.vala"
			_tmp53_[6] = _tmp51_;
#line 177 "../src/chess-view.vala"
			_tmp53_[7] = _tmp52_;
#line 177 "../src/chess-view.vala"
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 177 "../src/chess-view.vala"
			files = _tmp53_;
#line 177 "../src/chess-view.vala"
			files_length1 = 8;
#line 177 "../src/chess-view.vala"
			_files_size_ = files_length1;
#line 178 "../src/chess-view.vala"
			_tmp54_ = g_strdup ("8");
#line 178 "../src/chess-view.vala"
			_tmp55_ = g_strdup ("7");
#line 178 "../src/chess-view.vala"
			_tmp56_ = g_strdup ("6");
#line 178 "../src/chess-view.vala"
			_tmp57_ = g_strdup ("5");
#line 178 "../src/chess-view.vala"
			_tmp58_ = g_strdup ("4");
#line 178 "../src/chess-view.vala"
			_tmp59_ = g_strdup ("3");
#line 178 "../src/chess-view.vala"
			_tmp60_ = g_strdup ("2");
#line 178 "../src/chess-view.vala"
			_tmp61_ = g_strdup ("1");
#line 178 "../src/chess-view.vala"
			_tmp62_ = g_new0 (gchar*, 8 + 1);
#line 178 "../src/chess-view.vala"
			_tmp62_[0] = _tmp54_;
#line 178 "../src/chess-view.vala"
			_tmp62_[1] = _tmp55_;
#line 178 "../src/chess-view.vala"
			_tmp62_[2] = _tmp56_;
#line 178 "../src/chess-view.vala"
			_tmp62_[3] = _tmp57_;
#line 178 "../src/chess-view.vala"
			_tmp62_[4] = _tmp58_;
#line 178 "../src/chess-view.vala"
			_tmp62_[5] = _tmp59_;
#line 178 "../src/chess-view.vala"
			_tmp62_[6] = _tmp60_;
#line 178 "../src/chess-view.vala"
			_tmp62_[7] = _tmp61_;
#line 178 "../src/chess-view.vala"
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 178 "../src/chess-view.vala"
			ranks = _tmp62_;
#line 178 "../src/chess-view.vala"
			ranks_length1 = 8;
#line 178 "../src/chess-view.vala"
			_ranks_size_ = ranks_length1;
#line 1203 "chess-view.c"
		}
#line 181 "../src/chess-view.vala"
		cairo_save (c);
#line 182 "../src/chess-view.vala"
		_tmp63_ = matrix;
#line 182 "../src/chess-view.vala"
		cairo_set_matrix (c, &_tmp63_);
#line 1211 "chess-view.c"
		{
			gint i = 0;
#line 184 "../src/chess-view.vala"
			i = 0;
#line 1216 "chess-view.c"
			{
				gboolean _tmp64_ = FALSE;
#line 184 "../src/chess-view.vala"
				_tmp64_ = TRUE;
#line 184 "../src/chess-view.vala"
				while (TRUE) {
#line 1223 "chess-view.c"
					gchar** _tmp66_;
					gint _tmp66__length1;
					const gchar* _tmp67_;
					cairo_text_extents_t _tmp68_ = {0};
					cairo_text_extents_t _tmp69_;
					gchar** _tmp70_;
					gint _tmp70__length1;
					const gchar* _tmp71_;
					cairo_text_extents_t _tmp72_;
					gchar** _tmp73_;
					gint _tmp73__length1;
					const gchar* _tmp74_;
					gchar** _tmp75_;
					gint _tmp75__length1;
					const gchar* _tmp76_;
					cairo_text_extents_t _tmp77_ = {0};
					cairo_text_extents_t _tmp78_;
					cairo_text_extents_t _tmp79_;
					gdouble _tmp80_;
					gdouble _tmp81_;
					gdouble _tmp82_;
					gdouble _tmp83_;
					cairo_text_extents_t _tmp84_;
					gchar** _tmp85_;
					gint _tmp85__length1;
					const gchar* _tmp86_;
					gdouble _tmp87_;
					gdouble _tmp88_;
					cairo_text_extents_t _tmp89_;
					gchar** _tmp90_;
					gint _tmp90__length1;
					const gchar* _tmp91_;
#line 184 "../src/chess-view.vala"
					if (!_tmp64_) {
#line 1258 "chess-view.c"
						gint _tmp65_;
#line 184 "../src/chess-view.vala"
						_tmp65_ = i;
#line 184 "../src/chess-view.vala"
						i = _tmp65_ + 1;
#line 1264 "chess-view.c"
					}
#line 184 "../src/chess-view.vala"
					_tmp64_ = FALSE;
#line 184 "../src/chess-view.vala"
					if (!(i < 8)) {
#line 184 "../src/chess-view.vala"
						break;
#line 1272 "chess-view.c"
					}
#line 186 "../src/chess-view.vala"
					_tmp66_ = ranks;
#line 186 "../src/chess-view.vala"
					_tmp66__length1 = ranks_length1;
#line 186 "../src/chess-view.vala"
					_tmp67_ = _tmp66_[i];
#line 186 "../src/chess-view.vala"
					cairo_text_extents (c, _tmp67_, &_tmp68_);
#line 186 "../src/chess-view.vala"
					extents = _tmp68_;
#line 189 "../src/chess-view.vala"
					cairo_save (c);
#line 190 "../src/chess-view.vala"
					_tmp69_ = extents;
#line 190 "../src/chess-view.vala"
					cairo_move_to (c, file_offset - (_tmp69_.width / 2), top);
#line 191 "../src/chess-view.vala"
					_tmp70_ = files;
#line 191 "../src/chess-view.vala"
					_tmp70__length1 = files_length1;
#line 191 "../src/chess-view.vala"
					_tmp71_ = _tmp70_[i];
#line 191 "../src/chess-view.vala"
					cairo_show_text (c, _tmp71_);
#line 192 "../src/chess-view.vala"
					cairo_restore (c);
#line 195 "../src/chess-view.vala"
					cairo_save (c);
#line 196 "../src/chess-view.vala"
					_tmp72_ = extents;
#line 196 "../src/chess-view.vala"
					cairo_move_to (c, file_offset - (_tmp72_.width / 2), bottom);
#line 197 "../src/chess-view.vala"
					_tmp73_ = files;
#line 197 "../src/chess-view.vala"
					_tmp73__length1 = files_length1;
#line 197 "../src/chess-view.vala"
					_tmp74_ = _tmp73_[i];
#line 197 "../src/chess-view.vala"
					cairo_show_text (c, _tmp74_);
#line 198 "../src/chess-view.vala"
					cairo_restore (c);
#line 200 "../src/chess-view.vala"
					_tmp75_ = ranks;
#line 200 "../src/chess-view.vala"
					_tmp75__length1 = ranks_length1;
#line 200 "../src/chess-view.vala"
					_tmp76_ = _tmp75_[i];
#line 200 "../src/chess-view.vala"
					cairo_text_extents (c, _tmp76_, &_tmp77_);
#line 200 "../src/chess-view.vala"
					extents = _tmp77_;
#line 201 "../src/chess-view.vala"
					_tmp78_ = extents;
#line 201 "../src/chess-view.vala"
					_tmp79_ = extents;
#line 201 "../src/chess-view.vala"
					y_offset = -(_tmp78_.y_bearing + (_tmp79_.height / 2));
#line 204 "../src/chess-view.vala"
					cairo_save (c);
#line 205 "../src/chess-view.vala"
					_tmp80_ = chess_view_get_border_size (self);
#line 205 "../src/chess-view.vala"
					_tmp81_ = _tmp80_;
#line 205 "../src/chess-view.vala"
					_tmp82_ = chess_view_get_border_size (self);
#line 205 "../src/chess-view.vala"
					_tmp83_ = _tmp82_;
#line 205 "../src/chess-view.vala"
					_tmp84_ = extents;
#line 205 "../src/chess-view.vala"
					cairo_move_to (c, -(((((gdouble) self->priv->square_size) * 4) + _tmp81_) - ((_tmp83_ - _tmp84_.width) / 2)), rank_offset + y_offset);
#line 206 "../src/chess-view.vala"
					_tmp85_ = ranks;
#line 206 "../src/chess-view.vala"
					_tmp85__length1 = ranks_length1;
#line 206 "../src/chess-view.vala"
					_tmp86_ = _tmp85_[i];
#line 206 "../src/chess-view.vala"
					cairo_show_text (c, _tmp86_);
#line 207 "../src/chess-view.vala"
					cairo_restore (c);
#line 210 "../src/chess-view.vala"
					cairo_save (c);
#line 211 "../src/chess-view.vala"
					_tmp87_ = chess_view_get_border_size (self);
#line 211 "../src/chess-view.vala"
					_tmp88_ = _tmp87_;
#line 211 "../src/chess-view.vala"
					_tmp89_ = extents;
#line 211 "../src/chess-view.vala"
					cairo_move_to (c, (((gdouble) self->priv->square_size) * 4) + ((_tmp88_ - _tmp89_.width) / 2), rank_offset + y_offset);
#line 212 "../src/chess-view.vala"
					_tmp90_ = ranks;
#line 212 "../src/chess-view.vala"
					_tmp90__length1 = ranks_length1;
#line 212 "../src/chess-view.vala"
					_tmp91_ = _tmp90_[i];
#line 212 "../src/chess-view.vala"
					cairo_show_text (c, _tmp91_);
#line 213 "../src/chess-view.vala"
					cairo_restore (c);
#line 215 "../src/chess-view.vala"
					file_offset += (gdouble) self->priv->square_size;
#line 216 "../src/chess-view.vala"
					rank_offset += (gdouble) self->priv->square_size;
#line 1380 "chess-view.c"
				}
			}
		}
#line 219 "../src/chess-view.vala"
		cairo_restore (c);
#line 145 "../src/chess-view.vala"
		ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
#line 145 "../src/chess-view.vala"
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
#line 1390 "chess-view.c"
	}
#line 223 "../src/chess-view.vala"
	_tmp92_ = chess_view_get_scene (self);
#line 223 "../src/chess-view.vala"
	_tmp93_ = _tmp92_;
#line 223 "../src/chess-view.vala"
	_tmp94_ = chess_scene_get_game (_tmp93_);
#line 223 "../src/chess-view.vala"
	_tmp95_ = _tmp94_;
#line 223 "../src/chess-view.vala"
	_tmp96_ = chess_game_get_should_show_paused_overlay (_tmp95_);
#line 223 "../src/chess-view.vala"
	_tmp97_ = _tmp96_;
#line 223 "../src/chess-view.vala"
	if (_tmp97_) {
#line 1406 "chess-view.c"
		ChessScene* _tmp98_;
		ChessScene* _tmp99_;
		gdouble _tmp100_;
		gdouble _tmp101_;
#line 225 "../src/chess-view.vala"
		_tmp98_ = chess_view_get_scene (self);
#line 225 "../src/chess-view.vala"
		_tmp99_ = _tmp98_;
#line 225 "../src/chess-view.vala"
		_tmp100_ = chess_scene_get_board_angle (_tmp99_);
#line 225 "../src/chess-view.vala"
		_tmp101_ = _tmp100_;
#line 225 "../src/chess-view.vala"
		cairo_rotate (c, (G_PI * _tmp101_) / 180.0);
#line 226 "../src/chess-view.vala"
		chess_view_draw_paused_overlay (self, c);
#line 227 "../src/chess-view.vala"
		return;
#line 1425 "chess-view.c"
	}
#line 231 "../src/chess-view.vala"
	_tmp102_ = chess_view_get_scene (self);
#line 231 "../src/chess-view.vala"
	_tmp103_ = _tmp102_;
#line 231 "../src/chess-view.vala"
	_tmp104_ = _tmp103_->pieces;
#line 1433 "chess-view.c"
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
#line 231 "../src/chess-view.vala"
		model_collection = _tmp104_;
#line 231 "../src/chess-view.vala"
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
#line 1441 "chess-view.c"
			ChessModel* _tmp105_;
			ChessModel* model = NULL;
#line 231 "../src/chess-view.vala"
			_tmp105_ = _g_object_ref0 ((ChessModel*) model_it->data);
#line 231 "../src/chess-view.vala"
			model = _tmp105_;
#line 1448 "chess-view.c"
			{
				ChessModel* _tmp106_;
				ChessModel* _tmp107_;
				ChessScene* _tmp108_;
				ChessScene* _tmp109_;
				gdouble _tmp110_;
				gdouble _tmp111_;
				cairo_surface_t* _tmp112_ = NULL;
				ChessModel* _tmp113_;
				gint _tmp116_ = 0;
				ChessModel* _tmp117_;
				gdouble _tmp118_ = 0.0;
				gboolean _tmp119_ = FALSE;
				ChessModel* _tmp120_;
				ChessModel* _tmp125_;
				ChessPiece* _tmp126_;
#line 233 "../src/chess-view.vala"
				cairo_save (c);
#line 234 "../src/chess-view.vala"
				_tmp106_ = model;
#line 234 "../src/chess-view.vala"
				_tmp107_ = model;
#line 234 "../src/chess-view.vala"
				cairo_translate (c, (_tmp106_->x - 4) * self->priv->square_size, (3 - _tmp107_->y) * self->priv->square_size);
#line 235 "../src/chess-view.vala"
				cairo_translate (c, (gdouble) (self->priv->square_size / 2), (gdouble) (self->priv->square_size / 2));
#line 236 "../src/chess-view.vala"
				_tmp108_ = chess_view_get_scene (self);
#line 236 "../src/chess-view.vala"
				_tmp109_ = _tmp108_;
#line 236 "../src/chess-view.vala"
				_tmp110_ = chess_scene_get_board_angle (_tmp109_);
#line 236 "../src/chess-view.vala"
				_tmp111_ = _tmp110_;
#line 236 "../src/chess-view.vala"
				cairo_rotate (c, ((-G_PI) * _tmp111_) / 180.0);
#line 239 "../src/chess-view.vala"
				_tmp113_ = model;
#line 239 "../src/chess-view.vala"
				if (_tmp113_->is_selected) {
#line 1489 "chess-view.c"
					cairo_surface_t* _tmp114_;
#line 239 "../src/chess-view.vala"
					_tmp114_ = self->priv->selected_model_surface;
#line 239 "../src/chess-view.vala"
					_tmp112_ = _tmp114_;
#line 1495 "chess-view.c"
				} else {
					cairo_surface_t* _tmp115_;
#line 239 "../src/chess-view.vala"
					_tmp115_ = self->priv->model_surface;
#line 239 "../src/chess-view.vala"
					_tmp112_ = _tmp115_;
#line 1502 "chess-view.c"
				}
#line 240 "../src/chess-view.vala"
				_tmp117_ = model;
#line 240 "../src/chess-view.vala"
				if (_tmp117_->is_selected) {
#line 240 "../src/chess-view.vala"
					_tmp116_ = self->priv->selected_square_size;
#line 1510 "chess-view.c"
				} else {
#line 240 "../src/chess-view.vala"
					_tmp116_ = self->priv->square_size;
#line 1514 "chess-view.c"
				}
#line 241 "../src/chess-view.vala"
				_tmp120_ = model;
#line 241 "../src/chess-view.vala"
				if (_tmp120_->under_threat) {
#line 1520 "chess-view.c"
					ChessScene* _tmp121_;
					ChessScene* _tmp122_;
					gboolean _tmp123_;
					gboolean _tmp124_;
#line 241 "../src/chess-view.vala"
					_tmp121_ = chess_view_get_scene (self);
#line 241 "../src/chess-view.vala"
					_tmp122_ = _tmp121_;
#line 241 "../src/chess-view.vala"
					_tmp123_ = chess_scene_get_show_move_hints (_tmp122_);
#line 241 "../src/chess-view.vala"
					_tmp124_ = _tmp123_;
#line 241 "../src/chess-view.vala"
					_tmp119_ = _tmp124_;
#line 1535 "chess-view.c"
				} else {
#line 241 "../src/chess-view.vala"
					_tmp119_ = FALSE;
#line 1539 "chess-view.c"
				}
#line 241 "../src/chess-view.vala"
				if (_tmp119_) {
#line 241 "../src/chess-view.vala"
					_tmp118_ = 0.8;
#line 1545 "chess-view.c"
				} else {
#line 241 "../src/chess-view.vala"
					_tmp118_ = 1.0;
#line 1549 "chess-view.c"
				}
#line 238 "../src/chess-view.vala"
				_tmp125_ = model;
#line 238 "../src/chess-view.vala"
				_tmp126_ = _tmp125_->piece;
#line 238 "../src/chess-view.vala"
				chess_view_draw_piece (self, c, _tmp112_, _tmp116_, _tmp126_, _tmp118_);
#line 243 "../src/chess-view.vala"
				cairo_restore (c);
#line 231 "../src/chess-view.vala"
				_g_object_unref0 (model);
#line 1561 "chess-view.c"
			}
		}
	}
	{
		gint rank = 0;
#line 247 "../src/chess-view.vala"
		rank = 0;
#line 1569 "chess-view.c"
		{
			gboolean _tmp127_ = FALSE;
#line 247 "../src/chess-view.vala"
			_tmp127_ = TRUE;
#line 247 "../src/chess-view.vala"
			while (TRUE) {
#line 247 "../src/chess-view.vala"
				if (!_tmp127_) {
#line 1578 "chess-view.c"
					gint _tmp128_;
#line 247 "../src/chess-view.vala"
					_tmp128_ = rank;
#line 247 "../src/chess-view.vala"
					rank = _tmp128_ + 1;
#line 1584 "chess-view.c"
				}
#line 247 "../src/chess-view.vala"
				_tmp127_ = FALSE;
#line 247 "../src/chess-view.vala"
				if (!(rank < 8)) {
#line 247 "../src/chess-view.vala"
					break;
#line 1592 "chess-view.c"
				}
				{
					gint file = 0;
#line 249 "../src/chess-view.vala"
					file = 0;
#line 1598 "chess-view.c"
					{
						gboolean _tmp129_ = FALSE;
#line 249 "../src/chess-view.vala"
						_tmp129_ = TRUE;
#line 249 "../src/chess-view.vala"
						while (TRUE) {
#line 1605 "chess-view.c"
							gboolean _tmp131_ = FALSE;
							ChessScene* _tmp132_;
							ChessScene* _tmp133_;
							gboolean _tmp134_;
							gboolean _tmp135_;
#line 249 "../src/chess-view.vala"
							if (!_tmp129_) {
#line 1613 "chess-view.c"
								gint _tmp130_;
#line 249 "../src/chess-view.vala"
								_tmp130_ = file;
#line 249 "../src/chess-view.vala"
								file = _tmp130_ + 1;
#line 1619 "chess-view.c"
							}
#line 249 "../src/chess-view.vala"
							_tmp129_ = FALSE;
#line 249 "../src/chess-view.vala"
							if (!(file < 8)) {
#line 249 "../src/chess-view.vala"
								break;
#line 1627 "chess-view.c"
							}
#line 251 "../src/chess-view.vala"
							_tmp132_ = chess_view_get_scene (self);
#line 251 "../src/chess-view.vala"
							_tmp133_ = _tmp132_;
#line 251 "../src/chess-view.vala"
							_tmp134_ = chess_scene_get_show_move_hints (_tmp133_);
#line 251 "../src/chess-view.vala"
							_tmp135_ = _tmp134_;
#line 251 "../src/chess-view.vala"
							if (_tmp135_) {
#line 1639 "chess-view.c"
								ChessScene* _tmp136_;
								ChessScene* _tmp137_;
#line 251 "../src/chess-view.vala"
								_tmp136_ = chess_view_get_scene (self);
#line 251 "../src/chess-view.vala"
								_tmp137_ = _tmp136_;
#line 251 "../src/chess-view.vala"
								_tmp131_ = chess_scene_can_move (_tmp137_, rank, file);
#line 1648 "chess-view.c"
							} else {
#line 251 "../src/chess-view.vala"
								_tmp131_ = FALSE;
#line 1652 "chess-view.c"
							}
#line 251 "../src/chess-view.vala"
							if (_tmp131_) {
#line 1656 "chess-view.c"
								ChessScene* _tmp138_;
								ChessScene* _tmp139_;
								gdouble _tmp140_;
								gdouble _tmp141_;
								cairo_surface_t* _tmp142_;
								ChessScene* _tmp143_;
								ChessScene* _tmp144_;
								ChessPiece* _tmp145_;
								ChessPiece* _tmp146_;
#line 253 "../src/chess-view.vala"
								cairo_save (c);
#line 254 "../src/chess-view.vala"
								cairo_translate (c, (gdouble) ((file - 4) * self->priv->square_size), (gdouble) ((3 - rank) * self->priv->square_size));
#line 255 "../src/chess-view.vala"
								cairo_translate (c, (gdouble) (self->priv->square_size / 2), (gdouble) (self->priv->square_size / 2));
#line 256 "../src/chess-view.vala"
								_tmp138_ = chess_view_get_scene (self);
#line 256 "../src/chess-view.vala"
								_tmp139_ = _tmp138_;
#line 256 "../src/chess-view.vala"
								_tmp140_ = chess_scene_get_board_angle (_tmp139_);
#line 256 "../src/chess-view.vala"
								_tmp141_ = _tmp140_;
#line 256 "../src/chess-view.vala"
								cairo_rotate (c, ((-G_PI) * _tmp141_) / 180.0);
#line 258 "../src/chess-view.vala"
								_tmp142_ = self->priv->model_surface;
#line 258 "../src/chess-view.vala"
								_tmp143_ = chess_view_get_scene (self);
#line 258 "../src/chess-view.vala"
								_tmp144_ = _tmp143_;
#line 258 "../src/chess-view.vala"
								_tmp145_ = chess_scene_get_selected_piece (_tmp144_);
#line 258 "../src/chess-view.vala"
								_tmp146_ = _tmp145_;
#line 258 "../src/chess-view.vala"
								chess_view_draw_piece (self, c, _tmp142_, self->priv->square_size, _tmp146_, 0.1);
#line 258 "../src/chess-view.vala"
								_g_object_unref0 (_tmp146_);
#line 260 "../src/chess-view.vala"
								cairo_restore (c);
#line 1698 "chess-view.c"
							}
						}
					}
				}
			}
		}
	}
}

static void
chess_view_draw_piece (ChessView* self,
                       cairo_t* c,
                       cairo_surface_t* surface,
                       gint size,
                       ChessPiece* piece,
                       gdouble alpha)
{
	gint offset = 0;
	Color _tmp0_;
	Color _tmp1_;
#line 266 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 266 "../src/chess-view.vala"
	g_return_if_fail (surface != NULL);
#line 266 "../src/chess-view.vala"
	g_return_if_fail (piece != NULL);
#line 268 "../src/chess-view.vala"
	cairo_translate (c, (gdouble) ((-size) / 2), (gdouble) ((-size) / 2));
#line 270 "../src/chess-view.vala"
	offset = (gint) piece->type;
#line 271 "../src/chess-view.vala"
	_tmp0_ = chess_piece_get_color (piece);
#line 271 "../src/chess-view.vala"
	_tmp1_ = _tmp0_;
#line 271 "../src/chess-view.vala"
	if (_tmp1_ == COLOR_BLACK) {
#line 272 "../src/chess-view.vala"
		offset += 6;
#line 1739 "chess-view.c"
	}
#line 273 "../src/chess-view.vala"
	cairo_set_source_surface (c, surface, (gdouble) ((-offset) * size), (gdouble) 0);
#line 274 "../src/chess-view.vala"
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
#line 275 "../src/chess-view.vala"
	cairo_clip (c);
#line 276 "../src/chess-view.vala"
	cairo_paint_with_alpha (c, alpha);
#line 1749 "chess-view.c"
}

static void
chess_view_on_click (ChessView* self,
                     GtkGestureClick* _click_controller,
                     gint n_press,
                     gdouble event_x,
                     gdouble event_y)
{
	gboolean _tmp0_ = FALSE;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	ChessScene* _tmp11_;
	ChessScene* _tmp12_;
	ChessGame* _tmp13_;
	ChessGame* _tmp14_;
	gint file = 0;
	gint rank = 0;
	ChessScene* _tmp15_;
	ChessScene* _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	ChessScene* _tmp22_;
	ChessScene* _tmp23_;
#line 279 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/chess-view.vala"
	g_return_if_fail (_click_controller != NULL);
#line 281 "../src/chess-view.vala"
	_tmp1_ = chess_view_get_scene (self);
#line 281 "../src/chess-view.vala"
	_tmp2_ = _tmp1_;
#line 281 "../src/chess-view.vala"
	_tmp3_ = chess_scene_get_game (_tmp2_);
#line 281 "../src/chess-view.vala"
	_tmp4_ = _tmp3_;
#line 281 "../src/chess-view.vala"
	if (_tmp4_ == NULL) {
#line 281 "../src/chess-view.vala"
		_tmp0_ = TRUE;
#line 1795 "chess-view.c"
	} else {
		ChessScene* _tmp5_;
		ChessScene* _tmp6_;
		ChessGame* _tmp7_;
		ChessGame* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 281 "../src/chess-view.vala"
		_tmp5_ = chess_view_get_scene (self);
#line 281 "../src/chess-view.vala"
		_tmp6_ = _tmp5_;
#line 281 "../src/chess-view.vala"
		_tmp7_ = chess_scene_get_game (_tmp6_);
#line 281 "../src/chess-view.vala"
		_tmp8_ = _tmp7_;
#line 281 "../src/chess-view.vala"
		_tmp9_ = chess_game_get_should_show_paused_overlay (_tmp8_);
#line 281 "../src/chess-view.vala"
		_tmp10_ = _tmp9_;
#line 281 "../src/chess-view.vala"
		_tmp0_ = _tmp10_;
#line 1817 "chess-view.c"
	}
#line 281 "../src/chess-view.vala"
	if (_tmp0_) {
#line 282 "../src/chess-view.vala"
		return;
#line 1823 "chess-view.c"
	}
#line 285 "../src/chess-view.vala"
	_tmp11_ = chess_view_get_scene (self);
#line 285 "../src/chess-view.vala"
	_tmp12_ = _tmp11_;
#line 285 "../src/chess-view.vala"
	_tmp13_ = chess_scene_get_game (_tmp12_);
#line 285 "../src/chess-view.vala"
	_tmp14_ = _tmp13_;
#line 285 "../src/chess-view.vala"
	if (_tmp14_->result != CHESS_RESULT_IN_PROGRESS) {
#line 286 "../src/chess-view.vala"
		return;
#line 1837 "chess-view.c"
	}
#line 288 "../src/chess-view.vala"
	file = (gint) floor (((event_x - (0.5 * gtk_widget_get_allocated_width ((GtkWidget*) self))) + (self->priv->square_size * 4)) / self->priv->square_size);
#line 289 "../src/chess-view.vala"
	rank = 7 - ((gint) floor (((event_y - (0.5 * gtk_widget_get_allocated_height ((GtkWidget*) self))) + (self->priv->square_size * 4)) / self->priv->square_size));
#line 292 "../src/chess-view.vala"
	_tmp15_ = chess_view_get_scene (self);
#line 292 "../src/chess-view.vala"
	_tmp16_ = _tmp15_;
#line 292 "../src/chess-view.vala"
	_tmp17_ = chess_scene_get_board_angle (_tmp16_);
#line 292 "../src/chess-view.vala"
	_tmp18_ = _tmp17_;
#line 292 "../src/chess-view.vala"
	if (_tmp18_ == 180.0) {
#line 294 "../src/chess-view.vala"
		rank = 7 - rank;
#line 295 "../src/chess-view.vala"
		file = 7 - file;
#line 1857 "chess-view.c"
	}
#line 298 "../src/chess-view.vala"
	if (file < 0) {
#line 298 "../src/chess-view.vala"
		_tmp21_ = TRUE;
#line 1863 "chess-view.c"
	} else {
#line 298 "../src/chess-view.vala"
		_tmp21_ = file >= 8;
#line 1867 "chess-view.c"
	}
#line 298 "../src/chess-view.vala"
	if (_tmp21_) {
#line 298 "../src/chess-view.vala"
		_tmp20_ = TRUE;
#line 1873 "chess-view.c"
	} else {
#line 298 "../src/chess-view.vala"
		_tmp20_ = rank < 0;
#line 1877 "chess-view.c"
	}
#line 298 "../src/chess-view.vala"
	if (_tmp20_) {
#line 298 "../src/chess-view.vala"
		_tmp19_ = TRUE;
#line 1883 "chess-view.c"
	} else {
#line 298 "../src/chess-view.vala"
		_tmp19_ = rank >= 8;
#line 1887 "chess-view.c"
	}
#line 298 "../src/chess-view.vala"
	if (_tmp19_) {
#line 299 "../src/chess-view.vala"
		return;
#line 1893 "chess-view.c"
	}
#line 301 "../src/chess-view.vala"
	_tmp22_ = chess_view_get_scene (self);
#line 301 "../src/chess-view.vala"
	_tmp23_ = _tmp22_;
#line 301 "../src/chess-view.vala"
	chess_scene_select_square (_tmp23_, file, rank);
#line 1901 "chess-view.c"
}

static void
chess_view_scene_changed_cb (ChessView* self,
                             ChessScene* scene)
{
#line 304 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 304 "../src/chess-view.vala"
	g_return_if_fail (scene != NULL);
#line 306 "../src/chess-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 1914 "chess-view.c"
}

void
chess_view_draw_paused_overlay (ChessView* self,
                                cairo_t* c)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
#line 309 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/chess-view.vala"
	g_return_if_fail (c != NULL);
#line 311 "../src/chess-view.vala"
	cairo_save (c);
#line 313 "../src/chess-view.vala"
	cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
#line 314 "../src/chess-view.vala"
	cairo_paint (c);
#line 316 "../src/chess-view.vala"
	cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 317 "../src/chess-view.vala"
	cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
#line 319 "../src/chess-view.vala"
	_tmp0_ = g_strdup (_ ("Paused"));
#line 319 "../src/chess-view.vala"
	text = _tmp0_;
#line 321 "../src/chess-view.vala"
	cairo_text_extents (c, text, &_tmp1_);
#line 321 "../src/chess-view.vala"
	extents = _tmp1_;
#line 322 "../src/chess-view.vala"
	_tmp2_ = extents;
#line 322 "../src/chess-view.vala"
	_tmp3_ = extents;
#line 322 "../src/chess-view.vala"
	cairo_move_to (c, (-_tmp2_.width) / 2.0, _tmp3_.height / 2.0);
#line 323 "../src/chess-view.vala"
	cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 324 "../src/chess-view.vala"
	cairo_show_text (c, text);
#line 326 "../src/chess-view.vala"
	cairo_restore (c);
#line 309 "../src/chess-view.vala"
	_g_free0 (text);
#line 1963 "chess-view.c"
}

ChessScene*
chess_view_get_scene (ChessView* self)
{
	ChessScene* result;
	ChessScene* _tmp0_;
#line 25 "../src/chess-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/chess-view.vala"
	_tmp0_ = self->priv->_scene;
#line 25 "../src/chess-view.vala"
	result = _tmp0_;
#line 25 "../src/chess-view.vala"
	return result;
#line 1979 "chess-view.c"
}

static void
_chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                  gpointer self)
{
#line 29 "../src/chess-view.vala"
	chess_view_scene_changed_cb ((ChessView*) self, _sender);
#line 1988 "chess-view.c"
}

void
chess_view_set_scene (ChessView* self,
                      ChessScene* value)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 26 "../src/chess-view.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/chess-view.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/chess-view.vala"
	_g_object_unref0 (self->priv->_scene);
#line 28 "../src/chess-view.vala"
	self->priv->_scene = _tmp0_;
#line 29 "../src/chess-view.vala"
	_tmp1_ = self->priv->_scene;
#line 29 "../src/chess-view.vala"
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _chess_view_scene_changed_cb_chess_scene_changed, self, 0);
#line 30 "../src/chess-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 26 "../src/chess-view.vala"
	g_object_notify_by_pspec ((GObject *) self, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY]);
#line 2013 "chess-view.c"
}

static gdouble
chess_view_get_border_size (ChessView* self)
{
	gdouble result;
#line 36 "../src/chess-view.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 36 "../src/chess-view.vala"
	result = (gdouble) (self->priv->square_size / 2);
#line 36 "../src/chess-view.vala"
	return result;
#line 2026 "chess-view.c"
}

static void
chess_view_class_init (ChessViewClass * klass,
                       gpointer klass_data)
{
#line 13 "../src/chess-view.vala"
	chess_view_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/chess-view.vala"
	g_type_class_adjust_private_offset (klass, &ChessView_private_offset);
#line 13 "../src/chess-view.vala"
	((GtkDrawingAreaClass *) klass)->resize = (void (*) (GtkDrawingArea*, gint, gint)) chess_view_real_resize;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_view_get_property;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_view_set_property;
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_view_finalize;
#line 13 "../src/chess-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_VIEW_SCENE_PROPERTY, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2047 "chess-view.c"
}

static void
chess_view_instance_init (ChessView * self,
                          gpointer klass)
{
	gchar* _tmp0_;
#line 13 "../src/chess-view.vala"
	self->priv = chess_view_get_instance_private (self);
#line 15 "../src/chess-view.vala"
	self->priv->border = 6;
#line 20 "../src/chess-view.vala"
	_tmp0_ = g_strdup ("");
#line 20 "../src/chess-view.vala"
	self->priv->loaded_theme_name = _tmp0_;
#line 2063 "chess-view.c"
}

static void
chess_view_finalize (GObject * obj)
{
	ChessView * self;
#line 13 "../src/chess-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_VIEW, ChessView);
#line 18 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->model_surface);
#line 19 "../src/chess-view.vala"
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
#line 20 "../src/chess-view.vala"
	_g_free0 (self->priv->loaded_theme_name);
#line 22 "../src/chess-view.vala"
	_g_object_unref0 (self->priv->_scene);
#line 13 "../src/chess-view.vala"
	G_OBJECT_CLASS (chess_view_parent_class)->finalize (obj);
#line 2082 "chess-view.c"
}

static GType
chess_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessView), 0, (GInstanceInitFunc) chess_view_instance_init, NULL };
	GType chess_view_type_id;
	chess_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ChessView", &g_define_type_info, 0);
	ChessView_private_offset = g_type_add_instance_private (chess_view_type_id, sizeof (ChessViewPrivate));
	return chess_view_type_id;
}

GType
chess_view_get_type (void)
{
	static volatile gsize chess_view_type_id__once = 0;
	if (g_once_init_enter (&chess_view_type_id__once)) {
		GType chess_view_type_id;
		chess_view_type_id = chess_view_get_type_once ();
		g_once_init_leave (&chess_view_type_id__once, chess_view_type_id);
	}
	return chess_view_type_id__once;
}

static void
_vala_chess_view_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
#line 13 "../src/chess-view.vala"
	switch (property_id) {
#line 13 "../src/chess-view.vala"
		case CHESS_VIEW_SCENE_PROPERTY:
#line 13 "../src/chess-view.vala"
		g_value_set_object (value, chess_view_get_scene (self));
#line 13 "../src/chess-view.vala"
		break;
#line 2123 "chess-view.c"
		default:
#line 13 "../src/chess-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-view.vala"
		break;
#line 2129 "chess-view.c"
	}
}

static void
_vala_chess_view_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
#line 13 "../src/chess-view.vala"
	switch (property_id) {
#line 13 "../src/chess-view.vala"
		case CHESS_VIEW_SCENE_PROPERTY:
#line 13 "../src/chess-view.vala"
		chess_view_set_scene (self, g_value_get_object (value));
#line 13 "../src/chess-view.vala"
		break;
#line 2149 "chess-view.c"
		default:
#line 13 "../src/chess-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/chess-view.vala"
		break;
#line 2155 "chess-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

