/* gnome-chess.c generated by valac 0.56.14, the Vala compiler
 * generated from gnome-chess.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2020 Michael Catanzaro
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include "libchess.h"
#include "libengine.h"
#include <glib/gi18n-lib.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gdk/gdk.h>
#include <locale.h>

#define NEW_GAME_ACTION_NAME "new"
#define OPEN_GAME_ACTION_NAME "open"
#define SAVE_GAME_ACTION_NAME "save"
#define SAVE_GAME_AS_ACTION_NAME "save-as"
#define UNDO_MOVE_ACTION_NAME "undo"
#define RESIGN_ACTION_NAME "resign"
#define PAUSE_RESUME_ACTION_NAME "pause-resume"
#define HISTORY_GO_FIRST_ACTION_NAME "go-first"
#define HISTORY_GO_PREVIOUS_ACTION_NAME "go-previous"
#define HISTORY_GO_NEXT_ACTION_NAME "go-next"
#define HISTORY_GO_LAST_ACTION_NAME "go-last"
#define PREFERENCES_ACTION_NAME "preferences"
#define HELP_ACTION_NAME "help"
#define ABOUT_ACTION_NAME "about"
#define QUIT_ACTION_NAME "quit"
#define WIDTH_SETTINGS_KEY "width"
#define HEIGHT_SETTINGS_KEY "height"
#define MAXIMIZED_SETTINGS_KEY "maximized"
#define SHOW_MOVE_HINTS_SETTINGS_KEY "show-move-hints"
#define SHOW_BOARD_NUMBERING_SETTINGS_KEY "show-numbering"
#define PIECE_STYLE_SETTINGS_KEY "piece-theme"
#define MOVE_FORMAT_SETTINGS_KEY "move-format"
#define BOARD_ORIENTATION_SETTINGS_KEY "board-side"
#define INCREMENT_SETTINGS_KEY "timer-increment"
#define CLOCK_TYPE_SETTINGS_KEY "clock-type"
#define DURATION_SETTINGS_KEY "duration"
#define OPPONENT_SETTINGS_KEY "opponent"
#define DIFFICULTY_SETTINGS_KEY "difficulty"
#define PLAY_AS_SETTINGS_KEY "play-as"
#define LAST_PLAYED_AS_SETTINGS_KEY "last-played-as"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CHESS_APPLICATION (chess_application_get_type ())
#define CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_APPLICATION, ChessApplication))
#define CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_APPLICATION, ChessApplicationClass))
#define IS_CHESS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_APPLICATION))
#define IS_CHESS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_APPLICATION))
#define CHESS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_APPLICATION, ChessApplicationClass))

typedef struct _ChessApplication ChessApplication;
typedef struct _ChessApplicationClass ChessApplicationClass;
typedef struct _ChessApplicationPrivate ChessApplicationPrivate;

#define TYPE_PREFERENCES (preferences_get_type ())
#define PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES, Preferences))
#define PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES, PreferencesClass))
#define IS_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES))
#define IS_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES))
#define PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES, PreferencesClass))

typedef struct _Preferences Preferences;
typedef struct _PreferencesClass PreferencesClass;

#define TYPE_CHESS_WINDOW (chess_window_get_type ())
#define CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_WINDOW, ChessWindow))
#define CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_WINDOW, ChessWindowClass))
#define IS_CHESS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_WINDOW))
#define IS_CHESS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_WINDOW))
#define CHESS_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_WINDOW, ChessWindowClass))

typedef struct _ChessWindow ChessWindow;
typedef struct _ChessWindowClass ChessWindowClass;

#define TYPE_NEW_GAME_WINDOW (new_game_window_get_type ())
#define NEW_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_GAME_WINDOW, NewGameWindow))
#define NEW_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_GAME_WINDOW, NewGameWindowClass))
#define IS_NEW_GAME_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_GAME_WINDOW))
#define IS_NEW_GAME_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_GAME_WINDOW))
#define NEW_GAME_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_GAME_WINDOW, NewGameWindowClass))

typedef struct _NewGameWindow NewGameWindow;
typedef struct _NewGameWindowClass NewGameWindowClass;

#define TYPE_PREFERENCES_WINDOW (preferences_window_get_type ())
#define PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_WINDOW, PreferencesWindow))
#define PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_WINDOW, PreferencesWindowClass))
#define IS_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_WINDOW))
#define IS_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_WINDOW))
#define PREFERENCES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_WINDOW, PreferencesWindowClass))

typedef struct _PreferencesWindow PreferencesWindow;
typedef struct _PreferencesWindowClass PreferencesWindowClass;
enum  {
	CHESS_APPLICATION_0_PROPERTY,
	CHESS_APPLICATION_WINDOW_PROPERTY,
	CHESS_APPLICATION_VIEW_PROPERTY,
	CHESS_APPLICATION_SCENE_PROPERTY,
	CHESS_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* chess_application_properties[CHESS_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
typedef void (*ChessScenePromotionTypeCompletionHandler) (PieceType* type, gpointer user_data);
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;

#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;
typedef void (*ChessApplicationPromptSaveGameCallback) (gboolean cancelled, gpointer user_data);
typedef struct _Block7Data Block7Data;
typedef void (*ChessApplicationPresentSaveDialogCallback) (gboolean saved, gpointer user_data);
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
typedef struct _ChessScenePrivate ChessScenePrivate;

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;

#define TYPE_PROMOTION_TYPE_SELECTOR_DIALOG (promotion_type_selector_dialog_get_type ())
#define PROMOTION_TYPE_SELECTOR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialog))
#define PROMOTION_TYPE_SELECTOR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialogClass))
#define IS_PROMOTION_TYPE_SELECTOR_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG))
#define IS_PROMOTION_TYPE_SELECTOR_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG))
#define PROMOTION_TYPE_SELECTOR_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROMOTION_TYPE_SELECTOR_DIALOG, PromotionTypeSelectorDialogClass))

typedef struct _PromotionTypeSelectorDialog PromotionTypeSelectorDialog;
typedef struct _PromotionTypeSelectorDialogClass PromotionTypeSelectorDialogClass;
typedef struct _Block10Data Block10Data;
typedef enum  {
	CHESS_WINDOW_LAYOUT_MODE_NORMAL,
	CHESS_WINDOW_LAYOUT_MODE_NARROW
} ChessWindowLayoutMode;

#define CHESS_WINDOW_TYPE_LAYOUT_MODE (chess_window_layout_mode_get_type ())
typedef enum  {
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_QUEEN,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_KNIGHT,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_ROOK,
	PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_BISHOP
} PromotionTypeSelectorDialogSelectedType;

#define PROMOTION_TYPE_SELECTOR_DIALOG_TYPE_SELECTED_TYPE (promotion_type_selector_dialog_selected_type_get_type ())
typedef struct _Block11Data Block11Data;
typedef struct _Block12Data Block12Data;
typedef struct _Block13Data Block13Data;
typedef struct _Block14Data Block14Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _ChessApplication {
	AdwApplication parent_instance;
	ChessApplicationPrivate * priv;
};

struct _ChessApplicationClass {
	AdwApplicationClass parent_class;
};

struct _ChessApplicationPrivate {
	GSettings* settings;
	Preferences* preferences;
	ChessWindow* _window;
	NewGameWindow* new_game_window;
	PreferencesWindow* preferences_window;
	GtkAboutDialog* about_dialog;
	GtkFileChooserNative* open_dialog;
	GtkFileChooserNative* save_dialog;
	gulong save_dialog_response_id;
	PGNGame* pgn_game;
	ChessGame* game;
	gchar* autosave_filename;
	GFile* game_file;
	gboolean game_needs_saving;
	gboolean starting;
	GList* ai_profiles;
	ChessPlayer* opponent;
	ChessPlayer* human_player;
	ChessEngine* opponent_engine;
	guint engine_timeout_source;
	gchar* copyrights;
};

struct _Block4Data {
	int _ref_count_;
	ChessApplication* self;
	ChessGame* original_game;
	ChessState* original_state;
	gchar* move;
};

struct _Block5Data {
	int _ref_count_;
	ChessApplication* self;
	ChessGame* original_game;
};

struct _Block6Data {
	int _ref_count_;
	ChessApplication* self;
	gboolean started;
	ChessGame* game;
	ChessMove* move;
};

struct _Block7Data {
	int _ref_count_;
	ChessApplication* self;
	GtkMessageDialog* prompt_save_game_dialog;
	ChessApplicationPromptSaveGameCallback callback;
	gpointer callback_target;
};

struct _Block8Data {
	int _ref_count_;
	ChessApplication* self;
	GtkMessageDialog* claim_draw_dialog;
};

struct _Block9Data {
	int _ref_count_;
	ChessApplication* self;
	GtkMessageDialog* resign_dialog;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _Block10Data {
	int _ref_count_;
	ChessApplication* self;
	PromotionTypeSelectorDialog* promotion_type_selector_dialog;
	ChessScenePromotionTypeCompletionHandler handler;
	gpointer handler_target;
	GDestroyNotify handler_target_destroy_notify;
};

struct _Block11Data {
	int _ref_count_;
	ChessApplication* self;
	GtkMessageDialog* invalid_pgn_dialog;
};

struct _Block12Data {
	int _ref_count_;
	ChessApplication* self;
	GtkMessageDialog* invalid_move_dialog;
};

struct _Block13Data {
	int _ref_count_;
	ChessApplication* self;
	ChessApplicationPresentSaveDialogCallback callback;
	gpointer callback_target;
};

struct _Block14Data {
	int _ref_count_;
	Block13Data * _data13_;
	GtkMessageDialog* save_error_dialog;
};

static gint ChessApplication_private_offset;
static gpointer chess_application_parent_class = NULL;

VALA_EXTERN GType chess_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessApplication, g_object_unref)
VALA_EXTERN GType preferences_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Preferences, g_object_unref)
VALA_EXTERN GType chess_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessWindow, g_object_unref)
VALA_EXTERN GType new_game_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NewGameWindow, g_object_unref)
VALA_EXTERN GType preferences_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesWindow, g_object_unref)
VALA_EXTERN void chess_application_new_game_cb (ChessApplication* self);
static void _chess_application_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self);
VALA_EXTERN void chess_application_open_game_cb (ChessApplication* self);
static void _chess_application_open_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_save_game_cb (ChessApplication* self);
static void _chess_application_save_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_save_game_as_cb (ChessApplication* self);
static void _chess_application_save_game_as_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
VALA_EXTERN void chess_application_undo_move_cb (ChessApplication* self);
static void _chess_application_undo_move_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self);
VALA_EXTERN void chess_application_resign_cb (ChessApplication* self);
static void _chess_application_resign_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self);
VALA_EXTERN void chess_application_pause_resume_cb (ChessApplication* self);
static void _chess_application_pause_resume_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void chess_application_history_go_first_cb (ChessApplication* self);
static void _chess_application_history_go_first_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self);
static void chess_application_history_go_previous_cb (ChessApplication* self);
static void _chess_application_history_go_previous_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void chess_application_history_go_next_cb (ChessApplication* self);
static void _chess_application_history_go_next_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void chess_application_history_go_last_cb (ChessApplication* self);
static void _chess_application_history_go_last_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self);
static void chess_application_preferences_cb (ChessApplication* self);
static void _chess_application_preferences_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
VALA_EXTERN void chess_application_help_cb (ChessApplication* self);
static void _chess_application_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
VALA_EXTERN void chess_application_about_cb (ChessApplication* self);
static void _chess_application_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self);
VALA_EXTERN void chess_application_quit_cb (ChessApplication* self);
static void _chess_application_quit_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static ChessApplication* chess_application_new (void);
static ChessApplication* chess_application_construct (GType object_type);
static gint chess_application_real_handle_local_options (GApplication* base,
                                                  GVariantDict* options);
static void chess_application_real_startup (GApplication* base);
VALA_EXTERN Preferences* preferences_new (GSettings* settings);
VALA_EXTERN Preferences* preferences_construct (GType object_type,
                                    GSettings* settings);
VALA_EXTERN ChessWindow* chess_window_new (ChessApplication* app);
VALA_EXTERN ChessWindow* chess_window_construct (GType object_type,
                                     ChessApplication* app);
static void chess_application_set_window (ChessApplication* self,
                                   ChessWindow* value);
VALA_EXTERN ChessWindow* chess_application_get_window (ChessApplication* self);
VALA_EXTERN GType chess_scene_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessScene, g_object_unref)
VALA_EXTERN ChessScene* chess_application_get_scene (ChessApplication* self);
static gboolean __lambda38_ (ChessApplication* self,
                      ChessPlayer* p);
static gboolean ___lambda38__chess_scene_is_human (ChessScene* _sender,
                                            ChessPlayer* player,
                                            gpointer self);
static void chess_application_show_promotion_type_selector (ChessApplication* self,
                                                     ChessScenePromotionTypeCompletionHandler handler,
                                                     gpointer handler_target,
                                                     GDestroyNotify handler_target_destroy_notify);
static void _chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type (ChessScene* _sender,
                                                                                        ChessScenePromotionTypeCompletionHandler handler,
                                                                                        gpointer handler_target,
                                                                                        GDestroyNotify handler_target_destroy_notify,
                                                                                        gpointer self);
static void chess_application_real_open (GApplication* base,
                                  GFile** files,
                                  gint files_length1,
                                  const gchar* hint);
static void chess_application_real_activate (GApplication* base);
static void chess_application_start_new_game (ChessApplication* self);
static void chess_application_load_game (ChessApplication* self,
                                  GFile* file);
static void chess_application_real_shutdown (GApplication* base);
static void chess_application_autosave (ChessApplication* self);
VALA_EXTERN void chess_application_quit_game (ChessApplication* self);
static void chess_application_update_pgn_time_remaining (ChessApplication* self);
static void chess_application_start_game (ChessApplication* self);
static void chess_application_game_turn_cb (ChessApplication* self,
                                     ChessGame* game,
                                     ChessPlayer* player);
static void _chess_application_game_turn_cb_chess_game_turn_started (ChessGame* _sender,
                                                              ChessPlayer* player,
                                                              gpointer self);
static void chess_application_game_move_cb (ChessApplication* self,
                                     ChessGame* game,
                                     ChessMove* move);
static void _chess_application_game_move_cb_chess_game_moved (ChessGame* _sender,
                                                       ChessMove* move,
                                                       gpointer self);
static void chess_application_game_undo_cb (ChessApplication* self,
                                     ChessGame* game);
static void _chess_application_game_undo_cb_chess_game_undo (ChessGame* _sender,
                                                      gpointer self);
static void chess_application_game_end_cb (ChessApplication* self);
static void _chess_application_game_end_cb_chess_game_ended (ChessGame* _sender,
                                                      gpointer self);
static void chess_application_show_invalid_move_dialog (ChessApplication* self,
                                                 const gchar* error_message);
static void chess_application_configure_new_game (ChessApplication* self);
VALA_EXTERN void chess_scene_set_game (ChessScene* self,
                           ChessGame* value);
VALA_EXTERN void chess_window_start_game (ChessWindow* self);
static void chess_application_engine_move_cb (ChessApplication* self,
                                       ChessEngine* engine,
                                       const gchar* move);
static void _chess_application_engine_move_cb_chess_engine_moved (ChessEngine* _sender,
                                                           const gchar* move,
                                                           gpointer self);
static void chess_application_engine_resigned_cb (ChessApplication* self,
                                           ChessEngine* engine);
static void _chess_application_engine_resigned_cb_chess_engine_resigned (ChessEngine* _sender,
                                                                  gpointer self);
static void chess_application_engine_stopped_unexpectedly_cb (ChessApplication* self,
                                                       ChessEngine* engine);
static void _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly (ChessEngine* _sender,
                                                                                          gpointer self);
static void chess_application_engine_error_cb (ChessApplication* self,
                                        ChessEngine* engine);
static void _chess_application_engine_error_cb_chess_engine_error (ChessEngine* _sender,
                                                            gpointer self);
static void chess_application_engine_claim_draw_cb (ChessApplication* self,
                                             ChessEngine* engine);
static void _chess_application_engine_claim_draw_cb_chess_engine_claim_draw (ChessEngine* _sender,
                                                                      gpointer self);
static void chess_application_engine_offer_draw_cb (ChessApplication* self,
                                             ChessEngine* engine);
static void _chess_application_engine_offer_draw_cb_chess_engine_offer_draw (ChessEngine* _sender,
                                                                      gpointer self);
static ChessEngine* chess_application_get_engine (ChessApplication* self,
                                           const gchar* name,
                                           const gchar* difficulty);
VALA_EXTERN void chess_application_disable_action (ChessApplication* self,
                                       const gchar* name);
VALA_EXTERN void chess_application_enable_action (ChessApplication* self,
                                      const gchar* name);
VALA_EXTERN void chess_window_set_clock_visible (ChessWindow* self,
                                     gboolean visible);
static void chess_application_update_action_status (ChessApplication* self);
VALA_EXTERN void chess_window_update_history_panel (ChessWindow* self);
VALA_EXTERN void chess_window_update_pause_resume_button (ChessWindow* self);
VALA_EXTERN void chess_window_update_game_status (ChessWindow* self,
                                      const gchar* title,
                                      const gchar* info);
static void chess_application_update_engine_timeout (ChessApplication* self);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup3 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup4 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup5 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup8 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup9 (gchar** self,
                          gssize length);
static void chess_application_do_engine_move (ChessApplication* self,
                                       const gchar* move);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean ___lambda32_ (Block4Data* _data4_);
static gboolean ____lambda32__gsource_func (gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda33_ (Block5Data* _data5_);
static gboolean ___lambda33__gsource_func (gpointer self);
static gboolean ___lambda29_ (ChessApplication* self);
static gboolean ____lambda29__gsource_func (gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
VALA_EXTERN void chess_window_move (ChessWindow* self,
                        ChessMove* m);
VALA_EXTERN GType chess_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessView, g_object_unref)
VALA_EXTERN ChessView* chess_application_get_view (ChessApplication* self);
static gboolean __lambda27_ (Block6Data* _data6_);
static void chess_application_present_claim_draw_dialog (ChessApplication* self);
static gboolean ___lambda27__gsource_func (gpointer self);
VALA_EXTERN void chess_window_undo (ChessWindow* self);
VALA_EXTERN gchar* chess_application_compute_current_title (ChessApplication* self);
VALA_EXTERN gchar* chess_application_compute_status_info (ChessApplication* self);
VALA_EXTERN void chess_window_end_game (ChessWindow* self);
static void chess_application_prompt_save_game (ChessApplication* self,
                                         const gchar* prompt_text,
                                         ChessApplicationPromptSaveGameCallback callback,
                                         gpointer callback_target);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda21_ (Block7Data* _data7_,
                  gint response_id);
static void chess_application_present_save_dialog (ChessApplication* self,
                                            ChessApplicationPresentSaveDialogCallback callback,
                                            gpointer callback_target);
static void ____lambda24_ (Block7Data* _data7_,
                    gboolean saved);
static void _____lambda24__chess_application_present_save_dialog_callback (gboolean saved,
                                                                    gpointer self);
static void ___lambda21__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda28_ (Block8Data* _data8_,
                  gint response_id);
static void ___lambda28__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void __lambda25_ (ChessApplication* self,
                  gboolean cancelled);
static void ___lambda25__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                               gpointer self);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void __lambda37_ (Block9Data* _data9_,
                  gint response_id);
static void ___lambda37__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
VALA_EXTERN GType chess_model_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ChessModel, g_object_unref)
VALA_EXTERN void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
VALA_EXTERN gint chess_scene_get_move_number (ChessScene* self);
VALA_EXTERN NewGameWindow* new_game_window_new (GtkWindow* window,
                                    Preferences* preferences,
                                    GList* ai_profiles);
VALA_EXTERN NewGameWindow* new_game_window_construct (GType object_type,
                                          GtkWindow* window,
                                          Preferences* preferences,
                                          GList* ai_profiles);
static void __lambda26_ (ChessApplication* self);
static void ___lambda26__new_game_window_new_game_requested (NewGameWindow* _sender,
                                                      gpointer self);
VALA_EXTERN PreferencesWindow* preferences_window_new (GtkWindow* window,
                                           Preferences* preferences);
VALA_EXTERN PreferencesWindow* preferences_window_construct (GType object_type,
                                                 GtkWindow* window,
                                                 Preferences* preferences);
VALA_EXTERN GType promotion_type_selector_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PromotionTypeSelectorDialog, g_object_unref)
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN const gchar* chess_scene_get_theme_name (ChessScene* self);
VALA_EXTERN GType chess_window_layout_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ChessWindowLayoutMode chess_window_get_layout_mode (ChessWindow* self);
VALA_EXTERN PromotionTypeSelectorDialog* promotion_type_selector_dialog_new (GtkWindow* window,
                                                                 Color color,
                                                                 const gchar* theme,
                                                                 ChessWindowLayoutMode layout_mode);
VALA_EXTERN PromotionTypeSelectorDialog* promotion_type_selector_dialog_construct (GType object_type,
                                                                       GtkWindow* window,
                                                                       Color color,
                                                                       const gchar* theme,
                                                                       ChessWindowLayoutMode layout_mode);
static void __lambda40_ (Block10Data* _data10_,
                  gint response_id);
static GType promotion_type_selector_dialog_selected_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void ___lambda40__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static void chess_application_run_invalid_pgn_dialog (ChessApplication* self);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void __lambda36_ (Block11Data* _data11_);
static void ___lambda36__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda30_ (Block12Data* _data12_);
static void ___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                       gint response_id,
                                       gpointer self);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void __lambda22_ (Block13Data* _data13_,
                  gint response_id);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void ____lambda23_ (Block14Data* _data14_);
static void _____lambda23__gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self);
static void ___lambda22__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static void __lambda34_ (ChessApplication* self,
                  gboolean cancelled);
static void ___lambda35_ (ChessApplication* self,
                   gint response_id);
static void ____lambda35__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                               gint response_id,
                                               gpointer self);
static void ___lambda34__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                               gpointer self);
static gint chess_application_main (gchar** args,
                             gint args_length1);
VALA_EXTERN ChessView* chess_window_get_view (ChessWindow* self);
VALA_EXTERN ChessScene* chess_view_get_scene (ChessView* self);
static void chess_application_finalize (GObject * obj);
static GType chess_application_get_type_once (void);
static void _vala_chess_application_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_chess_application_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry CHESS_APPLICATION_action_entries[15] = {{NEW_GAME_ACTION_NAME, _chess_application_new_game_cb_gsimple_action_activate_callback}, {OPEN_GAME_ACTION_NAME, _chess_application_open_game_cb_gsimple_action_activate_callback}, {SAVE_GAME_ACTION_NAME, _chess_application_save_game_cb_gsimple_action_activate_callback}, {SAVE_GAME_AS_ACTION_NAME, _chess_application_save_game_as_cb_gsimple_action_activate_callback}, {UNDO_MOVE_ACTION_NAME, _chess_application_undo_move_cb_gsimple_action_activate_callback}, {RESIGN_ACTION_NAME, _chess_application_resign_cb_gsimple_action_activate_callback}, {PAUSE_RESUME_ACTION_NAME, _chess_application_pause_resume_cb_gsimple_action_activate_callback}, {HISTORY_GO_FIRST_ACTION_NAME, _chess_application_history_go_first_cb_gsimple_action_activate_callback}, {HISTORY_GO_PREVIOUS_ACTION_NAME, _chess_application_history_go_previous_cb_gsimple_action_activate_callback}, {HISTORY_GO_NEXT_ACTION_NAME, _chess_application_history_go_next_cb_gsimple_action_activate_callback}, {HISTORY_GO_LAST_ACTION_NAME, _chess_application_history_go_last_cb_gsimple_action_activate_callback}, {PREFERENCES_ACTION_NAME, _chess_application_preferences_cb_gsimple_action_activate_callback}, {HELP_ACTION_NAME, _chess_application_help_cb_gsimple_action_activate_callback}, {ABOUT_ACTION_NAME, _chess_application_about_cb_gsimple_action_activate_callback}, {QUIT_ACTION_NAME, _chess_application_quit_cb_gsimple_action_activate_callback}};
static const GOptionEntry CHESS_APPLICATION_option_entries[2] = {{"version", 'v', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Show release version"), NULL}, {NULL}};
static const gchar* CHESS_APPLICATION_authors[2] = {"Robert Ancell <robert.ancell@gmail.com>", NULL};
static const gchar* CHESS_APPLICATION_artists[3] = {"Max Froumentin", "Jakub Steiner", NULL};

static inline gpointer
chess_application_get_instance_private (ChessApplication* self)
{
	return G_STRUCT_MEMBER_P (self, ChessApplication_private_offset);
}

static void
_chess_application_new_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                 GVariant* parameter,
                                                                 gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_new_game_cb ((ChessApplication*) self);
#line 720 "gnome-chess.c"
}

static void
_chess_application_open_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_open_game_cb ((ChessApplication*) self);
#line 730 "gnome-chess.c"
}

static void
_chess_application_save_game_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_save_game_cb ((ChessApplication*) self);
#line 740 "gnome-chess.c"
}

static void
_chess_application_save_game_as_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_save_game_as_cb ((ChessApplication*) self);
#line 750 "gnome-chess.c"
}

static void
_chess_application_undo_move_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                  GVariant* parameter,
                                                                  gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_undo_move_cb ((ChessApplication*) self);
#line 760 "gnome-chess.c"
}

static void
_chess_application_resign_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_resign_cb ((ChessApplication*) self);
#line 770 "gnome-chess.c"
}

static void
_chess_application_pause_resume_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_pause_resume_cb ((ChessApplication*) self);
#line 780 "gnome-chess.c"
}

static void
_chess_application_history_go_first_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_history_go_first_cb ((ChessApplication*) self);
#line 790 "gnome-chess.c"
}

static void
_chess_application_history_go_previous_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_history_go_previous_cb ((ChessApplication*) self);
#line 800 "gnome-chess.c"
}

static void
_chess_application_history_go_next_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_history_go_next_cb ((ChessApplication*) self);
#line 810 "gnome-chess.c"
}

static void
_chess_application_history_go_last_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_history_go_last_cb ((ChessApplication*) self);
#line 820 "gnome-chess.c"
}

static void
_chess_application_preferences_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_preferences_cb ((ChessApplication*) self);
#line 830 "gnome-chess.c"
}

static void
_chess_application_help_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_help_cb ((ChessApplication*) self);
#line 840 "gnome-chess.c"
}

static void
_chess_application_about_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                              GVariant* parameter,
                                                              gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_about_cb ((ChessApplication*) self);
#line 850 "gnome-chess.c"
}

static void
_chess_application_quit_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                             GVariant* parameter,
                                                             gpointer self)
{
#line 72 "../src/gnome-chess.vala"
	chess_application_quit_cb ((ChessApplication*) self);
#line 860 "gnome-chess.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 63 "../src/gnome-chess.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 868 "gnome-chess.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 63 "../src/gnome-chess.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 876 "gnome-chess.c"
}

static ChessApplication*
chess_application_construct (GType object_type)
{
	ChessApplication * self = NULL;
#line 102 "../src/gnome-chess.vala"
	self = (ChessApplication*) g_object_new (object_type, "application-id", "org.gnome.Chess", "flags", G_APPLICATION_HANDLES_OPEN, NULL);
#line 103 "../src/gnome-chess.vala"
	g_application_add_main_option_entries ((GApplication*) self, CHESS_APPLICATION_option_entries);
#line 100 "../src/gnome-chess.vala"
	return self;
#line 889 "gnome-chess.c"
}

static ChessApplication*
chess_application_new (void)
{
#line 100 "../src/gnome-chess.vala"
	return chess_application_construct (TYPE_CHESS_APPLICATION);
#line 897 "gnome-chess.c"
}

static gint
chess_application_real_handle_local_options (GApplication* base,
                                             GVariantDict* options)
{
	ChessApplication * self;
	gint result;
#line 106 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 106 "../src/gnome-chess.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 108 "../src/gnome-chess.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 912 "gnome-chess.c"
		FILE* _tmp0_;
#line 111 "../src/gnome-chess.vala"
		_tmp0_ = stderr;
#line 111 "../src/gnome-chess.vala"
		fprintf (_tmp0_, "gnome-chess %s\n", VERSION);
#line 112 "../src/gnome-chess.vala"
		result = EXIT_SUCCESS;
#line 112 "../src/gnome-chess.vala"
		return result;
#line 922 "gnome-chess.c"
	}
#line 116 "../src/gnome-chess.vala"
	result = -1;
#line 116 "../src/gnome-chess.vala"
	return result;
#line 928 "gnome-chess.c"
}

static gboolean
__lambda38_ (ChessApplication* self,
             ChessPlayer* p)
{
	ChessPlayer* _tmp0_;
	gboolean result;
#line 154 "../src/gnome-chess.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 154 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->human_player;
#line 154 "../src/gnome-chess.vala"
	result = p == _tmp0_;
#line 154 "../src/gnome-chess.vala"
	return result;
#line 945 "gnome-chess.c"
}

static gboolean
___lambda38__chess_scene_is_human (ChessScene* _sender,
                                   ChessPlayer* player,
                                   gpointer self)
{
	gboolean result;
	result = __lambda38_ ((ChessApplication*) self, player);
#line 154 "../src/gnome-chess.vala"
	return result;
#line 957 "gnome-chess.c"
}

static void
_chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type (ChessScene* _sender,
                                                                                   ChessScenePromotionTypeCompletionHandler handler,
                                                                                   gpointer handler_target,
                                                                                   GDestroyNotify handler_target_destroy_notify,
                                                                                   gpointer self)
{
#line 155 "../src/gnome-chess.vala"
	chess_application_show_promotion_type_selector ((ChessApplication*) self, handler, handler_target, handler_target_destroy_notify);
#line 969 "gnome-chess.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "../src/gnome-chess.vala"
	return self ? g_object_ref (self) : NULL;
#line 977 "gnome-chess.c"
}

static void
chess_application_real_startup (GApplication* base)
{
	ChessApplication * self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	Preferences* _tmp2_;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	gchar* _tmp22_;
	gchar** _tmp23_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	gint _tmp33__length1;
	gchar* _tmp34_;
	gchar** _tmp35_;
	gchar** _tmp36_;
	gint _tmp36__length1;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar** _tmp39_;
	gchar** _tmp40_;
	gint _tmp40__length1;
	ChessWindow* _tmp41_;
	ChessWindow* _tmp42_;
	ChessWindow* _tmp43_;
	GSettings* _tmp44_;
	GSettings* _tmp45_;
	GSettings* _tmp46_;
	ChessWindow* _tmp48_;
	GSettings* _tmp49_;
	ChessScene* _tmp50_;
	ChessScene* _tmp51_;
	GSettings* _tmp52_;
	ChessScene* _tmp53_;
	ChessScene* _tmp54_;
	GSettings* _tmp55_;
	ChessScene* _tmp56_;
	ChessScene* _tmp57_;
	GSettings* _tmp58_;
	ChessScene* _tmp59_;
	ChessScene* _tmp60_;
	GSettings* _tmp61_;
	ChessScene* _tmp62_;
	ChessScene* _tmp63_;
	ChessScene* _tmp64_;
	ChessScene* _tmp65_;
	ChessScene* _tmp66_;
	ChessScene* _tmp67_;
	gchar* system_engine_cfg = NULL;
	gchar* _tmp68_;
	gchar* user_engine_cfg = NULL;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	const gchar* _tmp71_;
	GList* _tmp77_;
#line 119 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 121 "../src/gnome-chess.vala"
	G_APPLICATION_CLASS (chess_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication));
#line 123 "../src/gnome-chess.vala"
	_tmp0_ = g_settings_new ("org.gnome.Chess");
#line 123 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->settings);
#line 123 "../src/gnome-chess.vala"
	self->priv->settings = _tmp0_;
#line 124 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->settings;
#line 124 "../src/gnome-chess.vala"
	_tmp2_ = preferences_new (_tmp1_);
#line 124 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences);
#line 124 "../src/gnome-chess.vala"
	self->priv->preferences = _tmp2_;
#line 126 "../src/gnome-chess.vala"
	g_action_map_add_action_entries ((GActionMap*) self, CHESS_APPLICATION_action_entries, (gint) G_N_ELEMENTS (CHESS_APPLICATION_action_entries), self);
#line 127 "../src/gnome-chess.vala"
	_tmp3_ = g_strdup ("<Control>n");
#line 127 "../src/gnome-chess.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 127 "../src/gnome-chess.vala"
	_tmp4_[0] = _tmp3_;
#line 127 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 127 "../src/gnome-chess.vala"
	_tmp5__length1 = 1;
#line 127 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." NEW_GAME_ACTION_NAME, _tmp5_);
#line 127 "../src/gnome-chess.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 128 "../src/gnome-chess.vala"
	_tmp6_ = g_strdup ("<Control>o");
#line 128 "../src/gnome-chess.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 128 "../src/gnome-chess.vala"
	_tmp7_[0] = _tmp6_;
#line 128 "../src/gnome-chess.vala"
	_tmp8_ = _tmp7_;
#line 128 "../src/gnome-chess.vala"
	_tmp8__length1 = 1;
#line 128 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." OPEN_GAME_ACTION_NAME, _tmp8_);
#line 128 "../src/gnome-chess.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 129 "../src/gnome-chess.vala"
	_tmp9_ = g_strdup ("<Control>s");
#line 129 "../src/gnome-chess.vala"
	_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 129 "../src/gnome-chess.vala"
	_tmp10_[0] = _tmp9_;
#line 129 "../src/gnome-chess.vala"
	_tmp11_ = _tmp10_;
#line 129 "../src/gnome-chess.vala"
	_tmp11__length1 = 1;
#line 129 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." SAVE_GAME_ACTION_NAME, _tmp11_);
#line 129 "../src/gnome-chess.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/gnome-chess.vala"
	_tmp12_ = g_strdup ("<Shift><Control>s");
#line 130 "../src/gnome-chess.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 130 "../src/gnome-chess.vala"
	_tmp13_[0] = _tmp12_;
#line 130 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 130 "../src/gnome-chess.vala"
	_tmp14__length1 = 1;
#line 130 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." SAVE_GAME_AS_ACTION_NAME, _tmp14_);
#line 130 "../src/gnome-chess.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 131 "../src/gnome-chess.vala"
	_tmp15_ = g_strdup ("<Control>z");
#line 131 "../src/gnome-chess.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 131 "../src/gnome-chess.vala"
	_tmp16_[0] = _tmp15_;
#line 131 "../src/gnome-chess.vala"
	_tmp17_ = _tmp16_;
#line 131 "../src/gnome-chess.vala"
	_tmp17__length1 = 1;
#line 131 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." UNDO_MOVE_ACTION_NAME, _tmp17_);
#line 131 "../src/gnome-chess.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 132 "../src/gnome-chess.vala"
	_tmp18_ = g_strdup ("<Control>p");
#line 132 "../src/gnome-chess.vala"
	_tmp19_ = g_strdup ("Pause");
#line 132 "../src/gnome-chess.vala"
	_tmp20_ = g_new0 (gchar*, 2 + 1);
#line 132 "../src/gnome-chess.vala"
	_tmp20_[0] = _tmp18_;
#line 132 "../src/gnome-chess.vala"
	_tmp20_[1] = _tmp19_;
#line 132 "../src/gnome-chess.vala"
	_tmp21_ = _tmp20_;
#line 132 "../src/gnome-chess.vala"
	_tmp21__length1 = 2;
#line 132 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." PAUSE_RESUME_ACTION_NAME, _tmp21_);
#line 132 "../src/gnome-chess.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/gnome-chess.vala"
	_tmp22_ = g_strdup ("<Shift><Alt>Left");
#line 134 "../src/gnome-chess.vala"
	_tmp23_ = g_new0 (gchar*, 1 + 1);
#line 134 "../src/gnome-chess.vala"
	_tmp23_[0] = _tmp22_;
#line 134 "../src/gnome-chess.vala"
	_tmp24_ = _tmp23_;
#line 134 "../src/gnome-chess.vala"
	_tmp24__length1 = 1;
#line 134 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_FIRST_ACTION_NAME, _tmp24_);
#line 134 "../src/gnome-chess.vala"
	_tmp24_ = (_vala_array_free (_tmp24_, _tmp24__length1, (GDestroyNotify) g_free), NULL);
#line 135 "../src/gnome-chess.vala"
	_tmp25_ = g_strdup ("<Alt>Left");
#line 135 "../src/gnome-chess.vala"
	_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 135 "../src/gnome-chess.vala"
	_tmp26_[0] = _tmp25_;
#line 135 "../src/gnome-chess.vala"
	_tmp27_ = _tmp26_;
#line 135 "../src/gnome-chess.vala"
	_tmp27__length1 = 1;
#line 135 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_PREVIOUS_ACTION_NAME, _tmp27_);
#line 135 "../src/gnome-chess.vala"
	_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 136 "../src/gnome-chess.vala"
	_tmp28_ = g_strdup ("<Alt>Right");
#line 136 "../src/gnome-chess.vala"
	_tmp29_ = g_new0 (gchar*, 1 + 1);
#line 136 "../src/gnome-chess.vala"
	_tmp29_[0] = _tmp28_;
#line 136 "../src/gnome-chess.vala"
	_tmp30_ = _tmp29_;
#line 136 "../src/gnome-chess.vala"
	_tmp30__length1 = 1;
#line 136 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_NEXT_ACTION_NAME, _tmp30_);
#line 136 "../src/gnome-chess.vala"
	_tmp30_ = (_vala_array_free (_tmp30_, _tmp30__length1, (GDestroyNotify) g_free), NULL);
#line 137 "../src/gnome-chess.vala"
	_tmp31_ = g_strdup ("<Shift><Alt>Right");
#line 137 "../src/gnome-chess.vala"
	_tmp32_ = g_new0 (gchar*, 1 + 1);
#line 137 "../src/gnome-chess.vala"
	_tmp32_[0] = _tmp31_;
#line 137 "../src/gnome-chess.vala"
	_tmp33_ = _tmp32_;
#line 137 "../src/gnome-chess.vala"
	_tmp33__length1 = 1;
#line 137 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HISTORY_GO_LAST_ACTION_NAME, _tmp33_);
#line 137 "../src/gnome-chess.vala"
	_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
#line 138 "../src/gnome-chess.vala"
	_tmp34_ = g_strdup ("F1");
#line 138 "../src/gnome-chess.vala"
	_tmp35_ = g_new0 (gchar*, 1 + 1);
#line 138 "../src/gnome-chess.vala"
	_tmp35_[0] = _tmp34_;
#line 138 "../src/gnome-chess.vala"
	_tmp36_ = _tmp35_;
#line 138 "../src/gnome-chess.vala"
	_tmp36__length1 = 1;
#line 138 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." HELP_ACTION_NAME, _tmp36_);
#line 138 "../src/gnome-chess.vala"
	_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 139 "../src/gnome-chess.vala"
	_tmp37_ = g_strdup ("<Control>q");
#line 139 "../src/gnome-chess.vala"
	_tmp38_ = g_strdup ("<Control>w");
#line 139 "../src/gnome-chess.vala"
	_tmp39_ = g_new0 (gchar*, 2 + 1);
#line 139 "../src/gnome-chess.vala"
	_tmp39_[0] = _tmp37_;
#line 139 "../src/gnome-chess.vala"
	_tmp39_[1] = _tmp38_;
#line 139 "../src/gnome-chess.vala"
	_tmp40_ = _tmp39_;
#line 139 "../src/gnome-chess.vala"
	_tmp40__length1 = 2;
#line 139 "../src/gnome-chess.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app." QUIT_ACTION_NAME, _tmp40_);
#line 139 "../src/gnome-chess.vala"
	_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
#line 142 "../src/gnome-chess.vala"
	_tmp41_ = chess_window_new (self);
#line 142 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp41_);
#line 142 "../src/gnome-chess.vala"
	_tmp42_ = _tmp41_;
#line 142 "../src/gnome-chess.vala"
	chess_application_set_window (self, _tmp42_);
#line 142 "../src/gnome-chess.vala"
	_g_object_unref0 (_tmp42_);
#line 143 "../src/gnome-chess.vala"
	_tmp43_ = self->priv->_window;
#line 143 "../src/gnome-chess.vala"
	_tmp44_ = self->priv->settings;
#line 143 "../src/gnome-chess.vala"
	_tmp45_ = self->priv->settings;
#line 143 "../src/gnome-chess.vala"
	gtk_window_set_default_size ((GtkWindow*) _tmp43_, g_settings_get_int (_tmp44_, WIDTH_SETTINGS_KEY), g_settings_get_int (_tmp45_, HEIGHT_SETTINGS_KEY));
#line 144 "../src/gnome-chess.vala"
	_tmp46_ = self->priv->settings;
#line 144 "../src/gnome-chess.vala"
	if (g_settings_get_boolean (_tmp46_, MAXIMIZED_SETTINGS_KEY)) {
#line 1288 "gnome-chess.c"
		ChessWindow* _tmp47_;
#line 145 "../src/gnome-chess.vala"
		_tmp47_ = self->priv->_window;
#line 145 "../src/gnome-chess.vala"
		gtk_window_maximize ((GtkWindow*) _tmp47_);
#line 1294 "gnome-chess.c"
	}
#line 146 "../src/gnome-chess.vala"
	_tmp48_ = self->priv->_window;
#line 146 "../src/gnome-chess.vala"
	gtk_application_add_window ((GtkApplication*) self, (GtkWindow*) _tmp48_);
#line 148 "../src/gnome-chess.vala"
	_tmp49_ = self->priv->settings;
#line 148 "../src/gnome-chess.vala"
	_tmp50_ = chess_application_get_scene (self);
#line 148 "../src/gnome-chess.vala"
	_tmp51_ = _tmp50_;
#line 148 "../src/gnome-chess.vala"
	g_settings_bind (_tmp49_, SHOW_MOVE_HINTS_SETTINGS_KEY, (GObject*) _tmp51_, "show-move-hints", G_SETTINGS_BIND_GET);
#line 149 "../src/gnome-chess.vala"
	_tmp52_ = self->priv->settings;
#line 149 "../src/gnome-chess.vala"
	_tmp53_ = chess_application_get_scene (self);
#line 149 "../src/gnome-chess.vala"
	_tmp54_ = _tmp53_;
#line 149 "../src/gnome-chess.vala"
	g_settings_bind (_tmp52_, SHOW_BOARD_NUMBERING_SETTINGS_KEY, (GObject*) _tmp54_, "show-numbering", G_SETTINGS_BIND_GET);
#line 150 "../src/gnome-chess.vala"
	_tmp55_ = self->priv->settings;
#line 150 "../src/gnome-chess.vala"
	_tmp56_ = chess_application_get_scene (self);
#line 150 "../src/gnome-chess.vala"
	_tmp57_ = _tmp56_;
#line 150 "../src/gnome-chess.vala"
	g_settings_bind (_tmp55_, PIECE_STYLE_SETTINGS_KEY, (GObject*) _tmp57_, "theme-name", G_SETTINGS_BIND_GET);
#line 151 "../src/gnome-chess.vala"
	_tmp58_ = self->priv->settings;
#line 151 "../src/gnome-chess.vala"
	_tmp59_ = chess_application_get_scene (self);
#line 151 "../src/gnome-chess.vala"
	_tmp60_ = _tmp59_;
#line 151 "../src/gnome-chess.vala"
	g_settings_bind (_tmp58_, MOVE_FORMAT_SETTINGS_KEY, (GObject*) _tmp60_, "move-format", G_SETTINGS_BIND_GET);
#line 152 "../src/gnome-chess.vala"
	_tmp61_ = self->priv->settings;
#line 152 "../src/gnome-chess.vala"
	_tmp62_ = chess_application_get_scene (self);
#line 152 "../src/gnome-chess.vala"
	_tmp63_ = _tmp62_;
#line 152 "../src/gnome-chess.vala"
	g_settings_bind (_tmp61_, BOARD_ORIENTATION_SETTINGS_KEY, (GObject*) _tmp63_, "board-side", G_SETTINGS_BIND_GET);
#line 154 "../src/gnome-chess.vala"
	_tmp64_ = chess_application_get_scene (self);
#line 154 "../src/gnome-chess.vala"
	_tmp65_ = _tmp64_;
#line 154 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp65_, "is-human", (GCallback) ___lambda38__chess_scene_is_human, self, 0);
#line 155 "../src/gnome-chess.vala"
	_tmp66_ = chess_application_get_scene (self);
#line 155 "../src/gnome-chess.vala"
	_tmp67_ = _tmp66_;
#line 155 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp67_, "choose-promotion-type", (GCallback) _chess_application_show_promotion_type_selector_chess_scene_choose_promotion_type, self, 0);
#line 157 "../src/gnome-chess.vala"
	_tmp68_ = g_build_filename (SYSCONFDIR, "gnome-chess", "engines.conf", NULL, NULL);
#line 157 "../src/gnome-chess.vala"
	system_engine_cfg = _tmp68_;
#line 158 "../src/gnome-chess.vala"
	_tmp69_ = g_get_user_config_dir ();
#line 158 "../src/gnome-chess.vala"
	_tmp70_ = g_build_filename (_tmp69_, "gnome-chess", "engines.conf", NULL, NULL);
#line 158 "../src/gnome-chess.vala"
	user_engine_cfg = _tmp70_;
#line 159 "../src/gnome-chess.vala"
	_tmp71_ = user_engine_cfg;
#line 159 "../src/gnome-chess.vala"
	if (g_file_test (_tmp71_, G_FILE_TEST_EXISTS)) {
#line 1366 "gnome-chess.c"
		const gchar* _tmp72_;
		GList* _tmp73_;
#line 160 "../src/gnome-chess.vala"
		_tmp72_ = user_engine_cfg;
#line 160 "../src/gnome-chess.vala"
		_tmp73_ = ai_profile_load_ai_profiles (_tmp72_);
#line 160 "../src/gnome-chess.vala"
		(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 160 "../src/gnome-chess.vala"
		self->priv->ai_profiles = _tmp73_;
#line 1377 "gnome-chess.c"
	} else {
		const gchar* _tmp74_;
#line 161 "../src/gnome-chess.vala"
		_tmp74_ = system_engine_cfg;
#line 161 "../src/gnome-chess.vala"
		if (g_file_test (_tmp74_, G_FILE_TEST_EXISTS)) {
#line 1384 "gnome-chess.c"
			const gchar* _tmp75_;
			GList* _tmp76_;
#line 162 "../src/gnome-chess.vala"
			_tmp75_ = system_engine_cfg;
#line 162 "../src/gnome-chess.vala"
			_tmp76_ = ai_profile_load_ai_profiles (_tmp75_);
#line 162 "../src/gnome-chess.vala"
			(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 162 "../src/gnome-chess.vala"
			self->priv->ai_profiles = _tmp76_;
#line 1395 "gnome-chess.c"
		} else {
#line 164 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:164: engines.conf not found");
#line 1399 "gnome-chess.c"
		}
	}
#line 166 "../src/gnome-chess.vala"
	_tmp77_ = self->priv->ai_profiles;
#line 1404 "gnome-chess.c"
	{
		GList* profile_collection = NULL;
		GList* profile_it = NULL;
#line 166 "../src/gnome-chess.vala"
		profile_collection = _tmp77_;
#line 166 "../src/gnome-chess.vala"
		for (profile_it = profile_collection; profile_it != NULL; profile_it = profile_it->next) {
#line 1412 "gnome-chess.c"
			AIProfile* _tmp78_;
			AIProfile* profile = NULL;
#line 166 "../src/gnome-chess.vala"
			_tmp78_ = _g_object_ref0 ((AIProfile*) profile_it->data);
#line 166 "../src/gnome-chess.vala"
			profile = _tmp78_;
#line 1419 "gnome-chess.c"
			{
				AIProfile* _tmp79_;
				const gchar* _tmp80_;
				const gchar* _tmp81_;
				AIProfile* _tmp82_;
				const gchar* _tmp83_;
				const gchar* _tmp84_;
#line 167 "../src/gnome-chess.vala"
				_tmp79_ = profile;
#line 167 "../src/gnome-chess.vala"
				_tmp80_ = ai_profile_get_name (_tmp79_);
#line 167 "../src/gnome-chess.vala"
				_tmp81_ = _tmp80_;
#line 167 "../src/gnome-chess.vala"
				_tmp82_ = profile;
#line 167 "../src/gnome-chess.vala"
				_tmp83_ = ai_profile_get_path (_tmp82_);
#line 167 "../src/gnome-chess.vala"
				_tmp84_ = _tmp83_;
#line 167 "../src/gnome-chess.vala"
				g_debug ("gnome-chess.vala:167: Detected AI profile %s in %s", _tmp81_, _tmp84_);
#line 166 "../src/gnome-chess.vala"
				_g_object_unref0 (profile);
#line 1443 "gnome-chess.c"
			}
		}
	}
#line 119 "../src/gnome-chess.vala"
	_g_free0 (user_engine_cfg);
#line 119 "../src/gnome-chess.vala"
	_g_free0 (system_engine_cfg);
#line 1451 "gnome-chess.c"
}

static void
chess_application_real_open (GApplication* base,
                             GFile** files,
                             gint files_length1,
                             const gchar* hint)
{
	ChessApplication * self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 170 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 170 "../src/gnome-chess.vala"
	g_return_if_fail (hint != NULL);
#line 172 "../src/gnome-chess.vala"
	if (files_length1 != 1) {
#line 175 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:175: %s", _ ("GNOME Chess can only open one PGN at a time."));
#line 1471 "gnome-chess.c"
	}
#line 178 "../src/gnome-chess.vala"
	_tmp0_ = files[0];
#line 178 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 178 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 178 "../src/gnome-chess.vala"
	self->priv->game_file = _tmp1_;
#line 179 "../src/gnome-chess.vala"
	g_application_activate ((GApplication*) self);
#line 1483 "gnome-chess.c"
}

static void
chess_application_real_activate (GApplication* base)
{
	ChessApplication * self;
	ChessWindow* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ChessWindow* _tmp22_;
#line 182 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 184 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 184 "../src/gnome-chess.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 184 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 184 "../src/gnome-chess.vala"
	if (!_tmp2_) {
#line 1504 "gnome-chess.c"
		GFile* data_dir = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		GFile* _tmp16_;
		GFile* _tmp20_;
#line 186 "../src/gnome-chess.vala"
		_tmp3_ = g_get_user_data_dir ();
#line 186 "../src/gnome-chess.vala"
		_tmp4_ = g_build_filename (_tmp3_, "gnome-chess", NULL, NULL);
#line 186 "../src/gnome-chess.vala"
		_tmp5_ = _tmp4_;
#line 186 "../src/gnome-chess.vala"
		_tmp6_ = g_file_new_for_path (_tmp5_);
#line 186 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 186 "../src/gnome-chess.vala"
		_g_free0 (_tmp5_);
#line 186 "../src/gnome-chess.vala"
		data_dir = _tmp7_;
#line 187 "../src/gnome-chess.vala"
		_tmp8_ = data_dir;
#line 187 "../src/gnome-chess.vala"
		_tmp9_ = g_file_get_path (_tmp8_);
#line 187 "../src/gnome-chess.vala"
		_tmp10_ = _tmp9_;
#line 187 "../src/gnome-chess.vala"
		g_mkdir_with_parents (_tmp10_, 0755);
#line 187 "../src/gnome-chess.vala"
		_g_free0 (_tmp10_);
#line 189 "../src/gnome-chess.vala"
		_tmp11_ = data_dir;
#line 189 "../src/gnome-chess.vala"
		_tmp12_ = g_file_get_path (_tmp11_);
#line 189 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 189 "../src/gnome-chess.vala"
		_tmp14_ = g_strconcat (_tmp13_, "/autosave.pgn", NULL);
#line 189 "../src/gnome-chess.vala"
		_g_free0 (self->priv->autosave_filename);
#line 189 "../src/gnome-chess.vala"
		self->priv->autosave_filename = _tmp14_;
#line 189 "../src/gnome-chess.vala"
		_g_free0 (_tmp13_);
#line 192 "../src/gnome-chess.vala"
		_tmp16_ = self->priv->game_file;
#line 192 "../src/gnome-chess.vala"
		if (_tmp16_ == NULL) {
#line 1563 "gnome-chess.c"
			const gchar* _tmp17_;
#line 192 "../src/gnome-chess.vala"
			_tmp17_ = self->priv->autosave_filename;
#line 192 "../src/gnome-chess.vala"
			_tmp15_ = g_file_test (_tmp17_, G_FILE_TEST_EXISTS);
#line 1569 "gnome-chess.c"
		} else {
#line 192 "../src/gnome-chess.vala"
			_tmp15_ = FALSE;
#line 1573 "gnome-chess.c"
		}
#line 192 "../src/gnome-chess.vala"
		if (_tmp15_) {
#line 1577 "gnome-chess.c"
			const gchar* _tmp18_;
			GFile* _tmp19_;
#line 193 "../src/gnome-chess.vala"
			_tmp18_ = self->priv->autosave_filename;
#line 193 "../src/gnome-chess.vala"
			_tmp19_ = g_file_new_for_path (_tmp18_);
#line 193 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->game_file);
#line 193 "../src/gnome-chess.vala"
			self->priv->game_file = _tmp19_;
#line 1588 "gnome-chess.c"
		}
#line 195 "../src/gnome-chess.vala"
		_tmp20_ = self->priv->game_file;
#line 195 "../src/gnome-chess.vala"
		if (_tmp20_ == NULL) {
#line 196 "../src/gnome-chess.vala"
			chess_application_start_new_game (self);
#line 1596 "gnome-chess.c"
		} else {
			GFile* _tmp21_;
#line 198 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game_file;
#line 198 "../src/gnome-chess.vala"
			chess_application_load_game (self, _tmp21_);
#line 1603 "gnome-chess.c"
		}
#line 184 "../src/gnome-chess.vala"
		_g_object_unref0 (data_dir);
#line 1607 "gnome-chess.c"
	}
#line 201 "../src/gnome-chess.vala"
	_tmp22_ = self->priv->_window;
#line 201 "../src/gnome-chess.vala"
	gtk_window_present ((GtkWindow*) _tmp22_);
#line 1613 "gnome-chess.c"
}

static void
chess_application_real_shutdown (GApplication* base)
{
	ChessApplication * self;
	ChessEngine* _tmp0_;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	ChessWindow* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GSettings* _tmp7_;
	ChessWindow* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GSettings* _tmp11_;
	ChessWindow* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GSettings* _tmp15_;
#line 204 "../src/gnome-chess.vala"
	self = (ChessApplication*) base;
#line 206 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 206 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 1641 "gnome-chess.c"
		ChessEngine* _tmp1_;
#line 207 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent_engine;
#line 207 "../src/gnome-chess.vala"
		chess_engine_stop (_tmp1_, TRUE);
#line 1647 "gnome-chess.c"
	}
#line 209 "../src/gnome-chess.vala"
	chess_application_autosave (self);
#line 212 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->settings;
#line 212 "../src/gnome-chess.vala"
	g_settings_delay (_tmp2_);
#line 213 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->settings;
#line 213 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->_window;
#line 213 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp4_, "default-width", &_tmp5_, NULL);
#line 213 "../src/gnome-chess.vala"
	_tmp6_ = _tmp5_;
#line 213 "../src/gnome-chess.vala"
	g_settings_set_int (_tmp3_, WIDTH_SETTINGS_KEY, _tmp6_);
#line 214 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->settings;
#line 214 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 214 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp8_, "default-height", &_tmp9_, NULL);
#line 214 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 214 "../src/gnome-chess.vala"
	g_settings_set_int (_tmp7_, HEIGHT_SETTINGS_KEY, _tmp10_);
#line 215 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->settings;
#line 215 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 215 "../src/gnome-chess.vala"
	g_object_get ((GtkWindow*) _tmp12_, "maximized", &_tmp13_, NULL);
#line 215 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 215 "../src/gnome-chess.vala"
	g_settings_set_boolean (_tmp11_, MAXIMIZED_SETTINGS_KEY, _tmp14_);
#line 216 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->settings;
#line 216 "../src/gnome-chess.vala"
	g_settings_apply (_tmp15_);
#line 218 "../src/gnome-chess.vala"
	G_APPLICATION_CLASS (chess_application_parent_class)->shutdown ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication));
#line 1691 "gnome-chess.c"
}

void
chess_application_quit_game (ChessApplication* self)
{
	ChessWindow* _tmp0_;
#line 221 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 223 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 1704 "gnome-chess.c"
}

static void
chess_application_autosave (ChessApplication* self)
{
	GError* _inner_error0_ = NULL;
#line 226 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/gnome-chess.vala"
	if (!self->priv->game_needs_saving) {
#line 1715 "gnome-chess.c"
		const gchar* _tmp0_;
#line 231 "../src/gnome-chess.vala"
		_tmp0_ = self->priv->autosave_filename;
#line 231 "../src/gnome-chess.vala"
		g_remove (_tmp0_);
#line 232 "../src/gnome-chess.vala"
		return;
#line 1723 "gnome-chess.c"
	}
	{
		GFile* autosave_file = NULL;
		const gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		PGNGame* _tmp6_;
		GFile* _tmp7_;
#line 237 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->autosave_filename;
#line 237 "../src/gnome-chess.vala"
		_tmp2_ = g_file_new_for_path (_tmp1_);
#line 237 "../src/gnome-chess.vala"
		autosave_file = _tmp2_;
#line 238 "../src/gnome-chess.vala"
		_tmp3_ = autosave_file;
#line 238 "../src/gnome-chess.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 238 "../src/gnome-chess.vala"
		_tmp5_ = _tmp4_;
#line 238 "../src/gnome-chess.vala"
		g_debug ("gnome-chess.vala:238: Writing current game to %s", _tmp5_);
#line 238 "../src/gnome-chess.vala"
		_g_free0 (_tmp5_);
#line 239 "../src/gnome-chess.vala"
		chess_application_update_pgn_time_remaining (self);
#line 240 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->pgn_game;
#line 240 "../src/gnome-chess.vala"
		_tmp7_ = autosave_file;
#line 240 "../src/gnome-chess.vala"
		pgn_game_write (_tmp6_, _tmp7_, &_inner_error0_);
#line 240 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "../src/gnome-chess.vala"
			_g_object_unref0 (autosave_file);
#line 1762 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 235 "../src/gnome-chess.vala"
		_g_object_unref0 (autosave_file);
#line 1767 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
#line 235 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 235 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 244 "../src/gnome-chess.vala"
		_tmp8_ = e;
#line 244 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_->message;
#line 244 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:244: Failed to autosave: %s", _tmp9_);
#line 235 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 1787 "gnome-chess.c"
	}
	__finally0:
#line 235 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 235 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 235 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 235 "../src/gnome-chess.vala"
		return;
#line 1798 "gnome-chess.c"
	}
}

static void
_chess_application_game_turn_cb_chess_game_turn_started (ChessGame* _sender,
                                                         ChessPlayer* player,
                                                         gpointer self)
{
#line 268 "../src/gnome-chess.vala"
	chess_application_game_turn_cb ((ChessApplication*) self, _sender, player);
#line 1809 "gnome-chess.c"
}

static void
_chess_application_game_move_cb_chess_game_moved (ChessGame* _sender,
                                                  ChessMove* move,
                                                  gpointer self)
{
#line 269 "../src/gnome-chess.vala"
	chess_application_game_move_cb ((ChessApplication*) self, _sender, move);
#line 1819 "gnome-chess.c"
}

static void
_chess_application_game_undo_cb_chess_game_undo (ChessGame* _sender,
                                                 gpointer self)
{
#line 270 "../src/gnome-chess.vala"
	chess_application_game_undo_cb ((ChessApplication*) self, _sender);
#line 1828 "gnome-chess.c"
}

static void
_chess_application_game_end_cb_chess_game_ended (ChessGame* _sender,
                                                 gpointer self)
{
#line 271 "../src/gnome-chess.vala"
	chess_application_game_end_cb ((ChessApplication*) self);
#line 1837 "gnome-chess.c"
}

static void
_chess_application_engine_move_cb_chess_engine_moved (ChessEngine* _sender,
                                                      const gchar* move,
                                                      gpointer self)
{
#line 325 "../src/gnome-chess.vala"
	chess_application_engine_move_cb ((ChessApplication*) self, _sender, move);
#line 1847 "gnome-chess.c"
}

static void
_chess_application_engine_resigned_cb_chess_engine_resigned (ChessEngine* _sender,
                                                             gpointer self)
{
#line 326 "../src/gnome-chess.vala"
	chess_application_engine_resigned_cb ((ChessApplication*) self, _sender);
#line 1856 "gnome-chess.c"
}

static void
_chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly (ChessEngine* _sender,
                                                                                     gpointer self)
{
#line 327 "../src/gnome-chess.vala"
	chess_application_engine_stopped_unexpectedly_cb ((ChessApplication*) self, _sender);
#line 1865 "gnome-chess.c"
}

static void
_chess_application_engine_error_cb_chess_engine_error (ChessEngine* _sender,
                                                       gpointer self)
{
#line 328 "../src/gnome-chess.vala"
	chess_application_engine_error_cb ((ChessApplication*) self, _sender);
#line 1874 "gnome-chess.c"
}

static void
_chess_application_engine_claim_draw_cb_chess_engine_claim_draw (ChessEngine* _sender,
                                                                 gpointer self)
{
#line 329 "../src/gnome-chess.vala"
	chess_application_engine_claim_draw_cb ((ChessApplication*) self, _sender);
#line 1883 "gnome-chess.c"
}

static void
_chess_application_engine_offer_draw_cb_chess_engine_offer_draw (ChessEngine* _sender,
                                                                 gpointer self)
{
#line 330 "../src/gnome-chess.vala"
	chess_application_engine_offer_draw_cb ((ChessApplication*) self, _sender);
#line 1892 "gnome-chess.c"
}

static void
chess_application_start_game (ChessApplication* self)
{
	gchar* fen = NULL;
	gchar* _tmp0_;
	gchar** moves = NULL;
	PGNGame* _tmp1_;
	GList* _tmp2_;
	gchar** _tmp3_;
	gint moves_length1;
	gint _moves_size_;
	gint i = 0;
	PGNGame* _tmp4_;
	GList* _tmp5_;
	PGNGame* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	ChessGame* _tmp21_;
	gboolean _tmp36_ = FALSE;
	PGNGame* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	ChessGame* _tmp60_;
	ChessGame* _tmp61_;
	ChessGame* _tmp62_;
	ChessGame* _tmp63_;
	ChessScene* _tmp64_;
	ChessScene* _tmp65_;
	ChessGame* _tmp66_;
	ChessWindow* _tmp67_;
	gchar* white_engine = NULL;
	PGNGame* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gchar* _tmp71_;
	gchar* white_level = NULL;
	PGNGame* _tmp72_;
	const gchar* _tmp73_;
	const gchar* _tmp74_;
	gchar* _tmp75_;
	const gchar* _tmp76_;
	gchar* black_engine = NULL;
	PGNGame* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* black_level = NULL;
	PGNGame* _tmp82_;
	const gchar* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	const gchar* _tmp86_;
	ChessEngine* _tmp88_;
	const gchar* _tmp102_;
	ChessEngine* _tmp130_;
	gboolean _tmp157_ = FALSE;
	GFile* _tmp158_;
	ChessGame* _tmp163_;
	gint timer_increment_adj_value = 0;
	PGNGame* _tmp164_;
	const gchar* _tmp165_;
	const gchar* _tmp166_;
	ChessClockType clock_type = 0;
	PGNGame* _tmp174_;
	const gchar* _tmp175_;
	const gchar* _tmp176_;
	ChessWindow* _tmp186_;
	ChessGame* _tmp187_;
	ChessClock* _tmp188_;
	ChessClock* _tmp189_;
	ChessGame* _tmp190_;
	ChessClock* _tmp191_;
	ChessClock* _tmp192_;
	PGNGame* _tmp199_;
	const gchar* _tmp200_;
	const gchar* _tmp201_;
	const gchar* _tmp202_;
	ChessEngine* _tmp214_;
	gboolean _tmp216_ = FALSE;
	gchar** _tmp217_;
	gint _tmp217__length1;
	ChessWindow* _tmp224_;
	ChessWindow* _tmp225_;
	GList* _tmp226_;
	gboolean _tmp229_ = FALSE;
	gboolean _tmp230_ = FALSE;
	const gchar* _tmp231_;
	ChessGame* _tmp242_;
	GError* _inner_error0_ = NULL;
#line 248 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 250 "../src/gnome-chess.vala"
	self->priv->starting = TRUE;
#line 252 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup (CHESS_GAME_STANDARD_SETUP);
#line 252 "../src/gnome-chess.vala"
	fen = _tmp0_;
#line 253 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->pgn_game;
#line 253 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_->moves;
#line 253 "../src/gnome-chess.vala"
	_tmp3_ = g_new0 (gchar*, g_list_length (_tmp2_) + 1);
#line 253 "../src/gnome-chess.vala"
	moves = _tmp3_;
#line 253 "../src/gnome-chess.vala"
	moves_length1 = g_list_length (_tmp2_);
#line 253 "../src/gnome-chess.vala"
	_moves_size_ = moves_length1;
#line 254 "../src/gnome-chess.vala"
	i = 0;
#line 255 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->pgn_game;
#line 255 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_->moves;
#line 2010 "gnome-chess.c"
	{
		GList* move_collection = NULL;
		GList* move_it = NULL;
#line 255 "../src/gnome-chess.vala"
		move_collection = _tmp5_;
#line 255 "../src/gnome-chess.vala"
		for (move_it = move_collection; move_it != NULL; move_it = move_it->next) {
#line 2018 "gnome-chess.c"
			gchar* _tmp6_;
			gchar* move = NULL;
#line 255 "../src/gnome-chess.vala"
			_tmp6_ = g_strdup ((const gchar*) move_it->data);
#line 255 "../src/gnome-chess.vala"
			move = _tmp6_;
#line 2025 "gnome-chess.c"
			{
				gchar** _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				const gchar* _tmp9_;
				gchar* _tmp10_;
#line 256 "../src/gnome-chess.vala"
				_tmp7_ = moves;
#line 256 "../src/gnome-chess.vala"
				_tmp7__length1 = moves_length1;
#line 256 "../src/gnome-chess.vala"
				_tmp8_ = i;
#line 256 "../src/gnome-chess.vala"
				i = _tmp8_ + 1;
#line 256 "../src/gnome-chess.vala"
				_tmp9_ = move;
#line 256 "../src/gnome-chess.vala"
				_tmp10_ = g_strdup (_tmp9_);
#line 256 "../src/gnome-chess.vala"
				_g_free0 (_tmp7_[_tmp8_]);
#line 256 "../src/gnome-chess.vala"
				_tmp7_[_tmp8_] = _tmp10_;
#line 255 "../src/gnome-chess.vala"
				_g_free0 (move);
#line 2050 "gnome-chess.c"
			}
		}
	}
#line 258 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->pgn_game;
#line 258 "../src/gnome-chess.vala"
	_tmp12_ = pgn_game_get_set_up (_tmp11_);
#line 258 "../src/gnome-chess.vala"
	_tmp13_ = _tmp12_;
#line 258 "../src/gnome-chess.vala"
	if (_tmp13_) {
#line 2062 "gnome-chess.c"
		PGNGame* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 260 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->pgn_game;
#line 260 "../src/gnome-chess.vala"
		_tmp15_ = pgn_game_get_fen (_tmp14_);
#line 260 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 260 "../src/gnome-chess.vala"
		if (_tmp16_ != NULL) {
#line 2074 "gnome-chess.c"
			PGNGame* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 261 "../src/gnome-chess.vala"
			_tmp17_ = self->priv->pgn_game;
#line 261 "../src/gnome-chess.vala"
			_tmp18_ = pgn_game_get_fen (_tmp17_);
#line 261 "../src/gnome-chess.vala"
			_tmp19_ = _tmp18_;
#line 261 "../src/gnome-chess.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 261 "../src/gnome-chess.vala"
			_g_free0 (fen);
#line 261 "../src/gnome-chess.vala"
			fen = _tmp20_;
#line 2091 "gnome-chess.c"
		} else {
#line 263 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:263: Chess game has SetUp tag but no FEN tag");
#line 2095 "gnome-chess.c"
		}
	}
#line 266 "../src/gnome-chess.vala"
	_tmp21_ = self->priv->game;
#line 266 "../src/gnome-chess.vala"
	if (_tmp21_ != NULL) {
#line 2102 "gnome-chess.c"
		ChessGame* _tmp22_;
		guint _tmp23_;
		ChessGame* _tmp24_;
		guint _tmp25_;
		ChessGame* _tmp26_;
		guint _tmp27_;
		ChessGame* _tmp28_;
#line 268 "../src/gnome-chess.vala"
		_tmp22_ = self->priv->game;
#line 268 "../src/gnome-chess.vala"
		g_signal_parse_name ("turn-started", TYPE_CHESS_GAME, &_tmp23_, NULL, FALSE);
#line 268 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _chess_application_game_turn_cb_chess_game_turn_started, self);
#line 269 "../src/gnome-chess.vala"
		_tmp24_ = self->priv->game;
#line 269 "../src/gnome-chess.vala"
		g_signal_parse_name ("moved", TYPE_CHESS_GAME, &_tmp25_, NULL, FALSE);
#line 269 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _chess_application_game_move_cb_chess_game_moved, self);
#line 270 "../src/gnome-chess.vala"
		_tmp26_ = self->priv->game;
#line 270 "../src/gnome-chess.vala"
		g_signal_parse_name ("undo", TYPE_CHESS_GAME, &_tmp27_, NULL, FALSE);
#line 270 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _chess_application_game_undo_cb_chess_game_undo, self);
#line 271 "../src/gnome-chess.vala"
		_tmp28_ = self->priv->game;
#line 271 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp28_, "ended", (GCallback) _chess_application_game_end_cb_chess_game_ended, self, 0);
#line 2132 "gnome-chess.c"
	}
	{
		ChessGame* _tmp29_ = NULL;
		const gchar* _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		ChessGame* _tmp32_;
		ChessGame* _tmp33_;
#line 276 "../src/gnome-chess.vala"
		_tmp30_ = fen;
#line 276 "../src/gnome-chess.vala"
		_tmp31_ = moves;
#line 276 "../src/gnome-chess.vala"
		_tmp31__length1 = moves_length1;
#line 276 "../src/gnome-chess.vala"
		_tmp32_ = chess_game_new (_tmp30_, _tmp31_, _tmp31__length1, &_inner_error0_);
#line 276 "../src/gnome-chess.vala"
		_tmp29_ = _tmp32_;
#line 276 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2153 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 276 "../src/gnome-chess.vala"
		_tmp33_ = _tmp29_;
#line 276 "../src/gnome-chess.vala"
		_tmp29_ = NULL;
#line 276 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game);
#line 276 "../src/gnome-chess.vala"
		self->priv->game = _tmp33_;
#line 274 "../src/gnome-chess.vala"
		_g_object_unref0 (_tmp29_);
#line 2166 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 274 "../src/gnome-chess.vala"
		e = _inner_error0_;
#line 274 "../src/gnome-chess.vala"
		_inner_error0_ = NULL;
#line 280 "../src/gnome-chess.vala"
		_tmp34_ = e;
#line 280 "../src/gnome-chess.vala"
		_tmp35_ = _tmp34_->message;
#line 280 "../src/gnome-chess.vala"
		chess_application_show_invalid_move_dialog (self, _tmp35_);
#line 281 "../src/gnome-chess.vala"
		chess_application_configure_new_game (self);
#line 282 "../src/gnome-chess.vala"
		_g_error_free0 (e);
#line 282 "../src/gnome-chess.vala"
		moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 282 "../src/gnome-chess.vala"
		_g_free0 (fen);
#line 282 "../src/gnome-chess.vala"
		return;
#line 2194 "gnome-chess.c"
	}
	__finally0:
#line 274 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 274 "../src/gnome-chess.vala"
		moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 274 "../src/gnome-chess.vala"
		_g_free0 (fen);
#line 274 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 274 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 274 "../src/gnome-chess.vala"
		return;
#line 2209 "gnome-chess.c"
	}
#line 289 "../src/gnome-chess.vala"
	_tmp37_ = self->priv->pgn_game;
#line 289 "../src/gnome-chess.vala"
	_tmp38_ = pgn_game_get_time_control (_tmp37_);
#line 289 "../src/gnome-chess.vala"
	_tmp39_ = _tmp38_;
#line 289 "../src/gnome-chess.vala"
	if (_tmp39_ != NULL) {
#line 2219 "gnome-chess.c"
		PGNGame* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
#line 289 "../src/gnome-chess.vala"
		_tmp40_ = self->priv->pgn_game;
#line 289 "../src/gnome-chess.vala"
		_tmp41_ = pgn_game_get_time_control (_tmp40_);
#line 289 "../src/gnome-chess.vala"
		_tmp42_ = _tmp41_;
#line 289 "../src/gnome-chess.vala"
		_tmp36_ = atoi (_tmp42_) != 0;
#line 2231 "gnome-chess.c"
	} else {
#line 289 "../src/gnome-chess.vala"
		_tmp36_ = FALSE;
#line 2235 "gnome-chess.c"
	}
#line 289 "../src/gnome-chess.vala"
	if (_tmp36_) {
#line 2239 "gnome-chess.c"
		gboolean _tmp43_ = FALSE;
		PGNGame* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
#line 291 "../src/gnome-chess.vala"
		_tmp44_ = self->priv->pgn_game;
#line 291 "../src/gnome-chess.vala"
		_tmp45_ = pgn_game_get_white_time_left (_tmp44_);
#line 291 "../src/gnome-chess.vala"
		_tmp46_ = _tmp45_;
#line 291 "../src/gnome-chess.vala"
		if (_tmp46_ != NULL) {
#line 2252 "gnome-chess.c"
			PGNGame* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
#line 291 "../src/gnome-chess.vala"
			_tmp47_ = self->priv->pgn_game;
#line 291 "../src/gnome-chess.vala"
			_tmp48_ = pgn_game_get_black_time_left (_tmp47_);
#line 291 "../src/gnome-chess.vala"
			_tmp49_ = _tmp48_;
#line 291 "../src/gnome-chess.vala"
			_tmp43_ = _tmp49_ != NULL;
#line 2264 "gnome-chess.c"
		} else {
#line 291 "../src/gnome-chess.vala"
			_tmp43_ = FALSE;
#line 2268 "gnome-chess.c"
		}
#line 291 "../src/gnome-chess.vala"
		if (_tmp43_) {
#line 2272 "gnome-chess.c"
			gint white_seconds = 0;
			PGNGame* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			gint black_seconds = 0;
			PGNGame* _tmp53_;
			const gchar* _tmp54_;
			const gchar* _tmp55_;
			gboolean _tmp56_ = FALSE;
#line 293 "../src/gnome-chess.vala"
			_tmp50_ = self->priv->pgn_game;
#line 293 "../src/gnome-chess.vala"
			_tmp51_ = pgn_game_get_white_time_left (_tmp50_);
#line 293 "../src/gnome-chess.vala"
			_tmp52_ = _tmp51_;
#line 293 "../src/gnome-chess.vala"
			white_seconds = atoi (_tmp52_);
#line 294 "../src/gnome-chess.vala"
			_tmp53_ = self->priv->pgn_game;
#line 294 "../src/gnome-chess.vala"
			_tmp54_ = pgn_game_get_black_time_left (_tmp53_);
#line 294 "../src/gnome-chess.vala"
			_tmp55_ = _tmp54_;
#line 294 "../src/gnome-chess.vala"
			black_seconds = atoi (_tmp55_);
#line 296 "../src/gnome-chess.vala"
			if (white_seconds >= 0) {
#line 296 "../src/gnome-chess.vala"
				_tmp56_ = black_seconds >= 0;
#line 2302 "gnome-chess.c"
			} else {
#line 296 "../src/gnome-chess.vala"
				_tmp56_ = FALSE;
#line 2306 "gnome-chess.c"
			}
#line 296 "../src/gnome-chess.vala"
			if (_tmp56_) {
#line 2310 "gnome-chess.c"
				ChessGame* _tmp57_;
				ChessClock* _tmp58_;
				ChessClock* _tmp59_;
#line 297 "../src/gnome-chess.vala"
				_tmp57_ = self->priv->game;
#line 297 "../src/gnome-chess.vala"
				_tmp58_ = chess_clock_new (white_seconds, black_seconds);
#line 297 "../src/gnome-chess.vala"
				_tmp59_ = _tmp58_;
#line 297 "../src/gnome-chess.vala"
				chess_game_set_clock (_tmp57_, _tmp59_);
#line 297 "../src/gnome-chess.vala"
				_g_object_unref0 (_tmp59_);
#line 2324 "gnome-chess.c"
			}
		}
	}
#line 301 "../src/gnome-chess.vala"
	_tmp60_ = self->priv->game;
#line 301 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp60_, "turn-started", (GCallback) _chess_application_game_turn_cb_chess_game_turn_started, self, 0);
#line 302 "../src/gnome-chess.vala"
	_tmp61_ = self->priv->game;
#line 302 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp61_, "moved", (GCallback) _chess_application_game_move_cb_chess_game_moved, self, 0);
#line 303 "../src/gnome-chess.vala"
	_tmp62_ = self->priv->game;
#line 303 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp62_, "undo", (GCallback) _chess_application_game_undo_cb_chess_game_undo, self, 0);
#line 304 "../src/gnome-chess.vala"
	_tmp63_ = self->priv->game;
#line 304 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp63_, "ended", (GCallback) _chess_application_game_end_cb_chess_game_ended, self, 0);
#line 306 "../src/gnome-chess.vala"
	_tmp64_ = chess_application_get_scene (self);
#line 306 "../src/gnome-chess.vala"
	_tmp65_ = _tmp64_;
#line 306 "../src/gnome-chess.vala"
	_tmp66_ = self->priv->game;
#line 306 "../src/gnome-chess.vala"
	chess_scene_set_game (_tmp65_, _tmp66_);
#line 308 "../src/gnome-chess.vala"
	_tmp67_ = self->priv->_window;
#line 308 "../src/gnome-chess.vala"
	chess_window_start_game (_tmp67_);
#line 310 "../src/gnome-chess.vala"
	_tmp68_ = self->priv->pgn_game;
#line 310 "../src/gnome-chess.vala"
	_tmp69_ = pgn_game_get_white_ai (_tmp68_);
#line 310 "../src/gnome-chess.vala"
	_tmp70_ = _tmp69_;
#line 310 "../src/gnome-chess.vala"
	_tmp71_ = g_strdup (_tmp70_);
#line 310 "../src/gnome-chess.vala"
	white_engine = _tmp71_;
#line 311 "../src/gnome-chess.vala"
	_tmp72_ = self->priv->pgn_game;
#line 311 "../src/gnome-chess.vala"
	_tmp73_ = pgn_game_get_white_level (_tmp72_);
#line 311 "../src/gnome-chess.vala"
	_tmp74_ = _tmp73_;
#line 311 "../src/gnome-chess.vala"
	_tmp75_ = g_strdup (_tmp74_);
#line 311 "../src/gnome-chess.vala"
	white_level = _tmp75_;
#line 312 "../src/gnome-chess.vala"
	_tmp76_ = white_level;
#line 312 "../src/gnome-chess.vala"
	if (_tmp76_ == NULL) {
#line 2380 "gnome-chess.c"
		gchar* _tmp77_;
#line 313 "../src/gnome-chess.vala"
		_tmp77_ = g_strdup ("normal");
#line 313 "../src/gnome-chess.vala"
		_g_free0 (white_level);
#line 313 "../src/gnome-chess.vala"
		white_level = _tmp77_;
#line 2388 "gnome-chess.c"
	}
#line 315 "../src/gnome-chess.vala"
	_tmp78_ = self->priv->pgn_game;
#line 315 "../src/gnome-chess.vala"
	_tmp79_ = pgn_game_get_black_ai (_tmp78_);
#line 315 "../src/gnome-chess.vala"
	_tmp80_ = _tmp79_;
#line 315 "../src/gnome-chess.vala"
	_tmp81_ = g_strdup (_tmp80_);
#line 315 "../src/gnome-chess.vala"
	black_engine = _tmp81_;
#line 316 "../src/gnome-chess.vala"
	_tmp82_ = self->priv->pgn_game;
#line 316 "../src/gnome-chess.vala"
	_tmp83_ = pgn_game_get_black_level (_tmp82_);
#line 316 "../src/gnome-chess.vala"
	_tmp84_ = _tmp83_;
#line 316 "../src/gnome-chess.vala"
	_tmp85_ = g_strdup (_tmp84_);
#line 316 "../src/gnome-chess.vala"
	black_level = _tmp85_;
#line 317 "../src/gnome-chess.vala"
	_tmp86_ = black_level;
#line 317 "../src/gnome-chess.vala"
	if (_tmp86_ == NULL) {
#line 2414 "gnome-chess.c"
		gchar* _tmp87_;
#line 318 "../src/gnome-chess.vala"
		_tmp87_ = g_strdup ("normal");
#line 318 "../src/gnome-chess.vala"
		_g_free0 (black_level);
#line 318 "../src/gnome-chess.vala"
		black_level = _tmp87_;
#line 2422 "gnome-chess.c"
	}
#line 320 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->human_player);
#line 320 "../src/gnome-chess.vala"
	self->priv->human_player = NULL;
#line 321 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent);
#line 321 "../src/gnome-chess.vala"
	self->priv->opponent = NULL;
#line 322 "../src/gnome-chess.vala"
	_tmp88_ = self->priv->opponent_engine;
#line 322 "../src/gnome-chess.vala"
	if (_tmp88_ != NULL) {
#line 2436 "gnome-chess.c"
		ChessEngine* _tmp89_;
		ChessEngine* _tmp90_;
		guint _tmp91_;
		ChessEngine* _tmp92_;
		guint _tmp93_;
		ChessEngine* _tmp94_;
		guint _tmp95_;
		ChessEngine* _tmp96_;
		guint _tmp97_;
		ChessEngine* _tmp98_;
		guint _tmp99_;
		ChessEngine* _tmp100_;
		guint _tmp101_;
#line 324 "../src/gnome-chess.vala"
		_tmp89_ = self->priv->opponent_engine;
#line 324 "../src/gnome-chess.vala"
		chess_engine_stop (_tmp89_, TRUE);
#line 325 "../src/gnome-chess.vala"
		_tmp90_ = self->priv->opponent_engine;
#line 325 "../src/gnome-chess.vala"
		g_signal_parse_name ("moved", TYPE_CHESS_ENGINE, &_tmp91_, NULL, FALSE);
#line 325 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp90_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp91_, 0, NULL, (GCallback) _chess_application_engine_move_cb_chess_engine_moved, self);
#line 326 "../src/gnome-chess.vala"
		_tmp92_ = self->priv->opponent_engine;
#line 326 "../src/gnome-chess.vala"
		g_signal_parse_name ("resigned", TYPE_CHESS_ENGINE, &_tmp93_, NULL, FALSE);
#line 326 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp92_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp93_, 0, NULL, (GCallback) _chess_application_engine_resigned_cb_chess_engine_resigned, self);
#line 327 "../src/gnome-chess.vala"
		_tmp94_ = self->priv->opponent_engine;
#line 327 "../src/gnome-chess.vala"
		g_signal_parse_name ("stopped-unexpectedly", TYPE_CHESS_ENGINE, &_tmp95_, NULL, FALSE);
#line 327 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp94_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp95_, 0, NULL, (GCallback) _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly, self);
#line 328 "../src/gnome-chess.vala"
		_tmp96_ = self->priv->opponent_engine;
#line 328 "../src/gnome-chess.vala"
		g_signal_parse_name ("error", TYPE_CHESS_ENGINE, &_tmp97_, NULL, FALSE);
#line 328 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp96_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp97_, 0, NULL, (GCallback) _chess_application_engine_error_cb_chess_engine_error, self);
#line 329 "../src/gnome-chess.vala"
		_tmp98_ = self->priv->opponent_engine;
#line 329 "../src/gnome-chess.vala"
		g_signal_parse_name ("claim-draw", TYPE_CHESS_ENGINE, &_tmp99_, NULL, FALSE);
#line 329 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp98_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp99_, 0, NULL, (GCallback) _chess_application_engine_claim_draw_cb_chess_engine_claim_draw, self);
#line 330 "../src/gnome-chess.vala"
		_tmp100_ = self->priv->opponent_engine;
#line 330 "../src/gnome-chess.vala"
		g_signal_parse_name ("offer-draw", TYPE_CHESS_ENGINE, &_tmp101_, NULL, FALSE);
#line 330 "../src/gnome-chess.vala"
		g_signal_handlers_disconnect_matched (_tmp100_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp101_, 0, NULL, (GCallback) _chess_application_engine_offer_draw_cb_chess_engine_offer_draw, self);
#line 331 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent_engine);
#line 331 "../src/gnome-chess.vala"
		self->priv->opponent_engine = NULL;
#line 2494 "gnome-chess.c"
	}
#line 334 "../src/gnome-chess.vala"
	_tmp102_ = white_engine;
#line 334 "../src/gnome-chess.vala"
	if (_tmp102_ != NULL) {
#line 2500 "gnome-chess.c"
		ChessGame* _tmp103_;
		ChessPlayer* _tmp104_;
		ChessPlayer* _tmp105_;
		ChessPlayer* _tmp106_;
		ChessGame* _tmp107_;
		ChessPlayer* _tmp108_;
		ChessPlayer* _tmp109_;
		ChessPlayer* _tmp110_;
		const gchar* _tmp111_;
		const gchar* _tmp112_;
		ChessEngine* _tmp113_;
		ChessPlayer* _tmp114_;
		ChessPlayer* _tmp115_;
#line 336 "../src/gnome-chess.vala"
		_tmp103_ = self->priv->game;
#line 336 "../src/gnome-chess.vala"
		_tmp104_ = chess_game_get_white (_tmp103_);
#line 336 "../src/gnome-chess.vala"
		_tmp105_ = _tmp104_;
#line 336 "../src/gnome-chess.vala"
		_tmp106_ = _g_object_ref0 (_tmp105_);
#line 336 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent);
#line 336 "../src/gnome-chess.vala"
		self->priv->opponent = _tmp106_;
#line 337 "../src/gnome-chess.vala"
		_tmp107_ = self->priv->game;
#line 337 "../src/gnome-chess.vala"
		_tmp108_ = chess_game_get_black (_tmp107_);
#line 337 "../src/gnome-chess.vala"
		_tmp109_ = _tmp108_;
#line 337 "../src/gnome-chess.vala"
		_tmp110_ = _g_object_ref0 (_tmp109_);
#line 337 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->human_player);
#line 337 "../src/gnome-chess.vala"
		self->priv->human_player = _tmp110_;
#line 338 "../src/gnome-chess.vala"
		_tmp111_ = white_engine;
#line 338 "../src/gnome-chess.vala"
		_tmp112_ = white_level;
#line 338 "../src/gnome-chess.vala"
		_tmp113_ = chess_application_get_engine (self, _tmp111_, _tmp112_);
#line 338 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->opponent_engine);
#line 338 "../src/gnome-chess.vala"
		self->priv->opponent_engine = _tmp113_;
#line 339 "../src/gnome-chess.vala"
		_tmp114_ = self->priv->opponent;
#line 339 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp114_, FALSE);
#line 340 "../src/gnome-chess.vala"
		_tmp115_ = self->priv->human_player;
#line 340 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp115_, TRUE);
#line 2556 "gnome-chess.c"
	} else {
		const gchar* _tmp116_;
#line 342 "../src/gnome-chess.vala"
		_tmp116_ = black_engine;
#line 342 "../src/gnome-chess.vala"
		if (_tmp116_ != NULL) {
#line 2563 "gnome-chess.c"
			ChessGame* _tmp117_;
			ChessPlayer* _tmp118_;
			ChessPlayer* _tmp119_;
			ChessPlayer* _tmp120_;
			ChessGame* _tmp121_;
			ChessPlayer* _tmp122_;
			ChessPlayer* _tmp123_;
			ChessPlayer* _tmp124_;
			const gchar* _tmp125_;
			const gchar* _tmp126_;
			ChessEngine* _tmp127_;
			ChessPlayer* _tmp128_;
			ChessPlayer* _tmp129_;
#line 344 "../src/gnome-chess.vala"
			_tmp117_ = self->priv->game;
#line 344 "../src/gnome-chess.vala"
			_tmp118_ = chess_game_get_black (_tmp117_);
#line 344 "../src/gnome-chess.vala"
			_tmp119_ = _tmp118_;
#line 344 "../src/gnome-chess.vala"
			_tmp120_ = _g_object_ref0 (_tmp119_);
#line 344 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->opponent);
#line 344 "../src/gnome-chess.vala"
			self->priv->opponent = _tmp120_;
#line 345 "../src/gnome-chess.vala"
			_tmp121_ = self->priv->game;
#line 345 "../src/gnome-chess.vala"
			_tmp122_ = chess_game_get_white (_tmp121_);
#line 345 "../src/gnome-chess.vala"
			_tmp123_ = _tmp122_;
#line 345 "../src/gnome-chess.vala"
			_tmp124_ = _g_object_ref0 (_tmp123_);
#line 345 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->human_player);
#line 345 "../src/gnome-chess.vala"
			self->priv->human_player = _tmp124_;
#line 346 "../src/gnome-chess.vala"
			_tmp125_ = black_engine;
#line 346 "../src/gnome-chess.vala"
			_tmp126_ = black_level;
#line 346 "../src/gnome-chess.vala"
			_tmp127_ = chess_application_get_engine (self, _tmp125_, _tmp126_);
#line 346 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->opponent_engine);
#line 346 "../src/gnome-chess.vala"
			self->priv->opponent_engine = _tmp127_;
#line 347 "../src/gnome-chess.vala"
			_tmp128_ = self->priv->opponent;
#line 347 "../src/gnome-chess.vala"
			chess_player_set_local_human (_tmp128_, FALSE);
#line 348 "../src/gnome-chess.vala"
			_tmp129_ = self->priv->human_player;
#line 348 "../src/gnome-chess.vala"
			chess_player_set_local_human (_tmp129_, TRUE);
#line 2619 "gnome-chess.c"
		}
	}
#line 352 "../src/gnome-chess.vala"
	_tmp130_ = self->priv->opponent_engine;
#line 352 "../src/gnome-chess.vala"
	if (_tmp130_ == NULL) {
#line 2626 "gnome-chess.c"
		ChessGame* _tmp131_;
		ChessPlayer* _tmp132_;
		ChessPlayer* _tmp133_;
		ChessGame* _tmp134_;
		ChessPlayer* _tmp135_;
		ChessPlayer* _tmp136_;
#line 354 "../src/gnome-chess.vala"
		_tmp131_ = self->priv->game;
#line 354 "../src/gnome-chess.vala"
		_tmp132_ = chess_game_get_black (_tmp131_);
#line 354 "../src/gnome-chess.vala"
		_tmp133_ = _tmp132_;
#line 354 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp133_, TRUE);
#line 355 "../src/gnome-chess.vala"
		_tmp134_ = self->priv->game;
#line 355 "../src/gnome-chess.vala"
		_tmp135_ = chess_game_get_white (_tmp134_);
#line 355 "../src/gnome-chess.vala"
		_tmp136_ = _tmp135_;
#line 355 "../src/gnome-chess.vala"
		chess_player_set_local_human (_tmp136_, TRUE);
#line 356 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->human_player);
#line 356 "../src/gnome-chess.vala"
		self->priv->human_player = NULL;
#line 2653 "gnome-chess.c"
	} else {
		ChessEngine* _tmp137_;
		ChessEngine* _tmp138_;
		ChessEngine* _tmp139_;
		ChessEngine* _tmp140_;
		ChessEngine* _tmp141_;
		ChessEngine* _tmp142_;
		ChessEngine* _tmp143_;
#line 360 "../src/gnome-chess.vala"
		_tmp137_ = self->priv->opponent_engine;
#line 360 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp137_, "moved", (GCallback) _chess_application_engine_move_cb_chess_engine_moved, self, 0);
#line 361 "../src/gnome-chess.vala"
		_tmp138_ = self->priv->opponent_engine;
#line 361 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp138_, "resigned", (GCallback) _chess_application_engine_resigned_cb_chess_engine_resigned, self, 0);
#line 362 "../src/gnome-chess.vala"
		_tmp139_ = self->priv->opponent_engine;
#line 362 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp139_, "stopped-unexpectedly", (GCallback) _chess_application_engine_stopped_unexpectedly_cb_chess_engine_stopped_unexpectedly, self, 0);
#line 363 "../src/gnome-chess.vala"
		_tmp140_ = self->priv->opponent_engine;
#line 363 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp140_, "error", (GCallback) _chess_application_engine_error_cb_chess_engine_error, self, 0);
#line 364 "../src/gnome-chess.vala"
		_tmp141_ = self->priv->opponent_engine;
#line 364 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp141_, "claim-draw", (GCallback) _chess_application_engine_claim_draw_cb_chess_engine_claim_draw, self, 0);
#line 365 "../src/gnome-chess.vala"
		_tmp142_ = self->priv->opponent_engine;
#line 365 "../src/gnome-chess.vala"
		g_signal_connect_object (_tmp142_, "offer-draw", (GCallback) _chess_application_engine_offer_draw_cb_chess_engine_offer_draw, self, 0);
#line 367 "../src/gnome-chess.vala"
		_tmp143_ = self->priv->opponent_engine;
#line 367 "../src/gnome-chess.vala"
		if (!chess_engine_start (_tmp143_)) {
#line 2690 "gnome-chess.c"
			ChessGame* _tmp144_;
			ChessGame* _tmp145_;
#line 369 "../src/gnome-chess.vala"
			chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 370 "../src/gnome-chess.vala"
			_tmp144_ = self->priv->game;
#line 370 "../src/gnome-chess.vala"
			_tmp144_->result = CHESS_RESULT_BUG;
#line 371 "../src/gnome-chess.vala"
			_tmp145_ = self->priv->game;
#line 371 "../src/gnome-chess.vala"
			_tmp145_->rule = CHESS_RULE_BUG;
#line 372 "../src/gnome-chess.vala"
			chess_application_game_end_cb (self);
#line 373 "../src/gnome-chess.vala"
			_g_free0 (black_level);
#line 373 "../src/gnome-chess.vala"
			_g_free0 (black_engine);
#line 373 "../src/gnome-chess.vala"
			_g_free0 (white_level);
#line 373 "../src/gnome-chess.vala"
			_g_free0 (white_engine);
#line 373 "../src/gnome-chess.vala"
			moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 373 "../src/gnome-chess.vala"
			_g_free0 (fen);
#line 373 "../src/gnome-chess.vala"
			return;
#line 2719 "gnome-chess.c"
		}
	}
	{
		gint j = 0;
		ChessGame* _tmp146_;
		GList* _tmp147_;
#line 378 "../src/gnome-chess.vala"
		_tmp146_ = self->priv->game;
#line 378 "../src/gnome-chess.vala"
		_tmp147_ = _tmp146_->move_stack;
#line 378 "../src/gnome-chess.vala"
		j = ((gint) g_list_length (_tmp147_)) - 2;
#line 2732 "gnome-chess.c"
		{
			gboolean _tmp148_ = FALSE;
#line 378 "../src/gnome-chess.vala"
			_tmp148_ = TRUE;
#line 378 "../src/gnome-chess.vala"
			while (TRUE) {
#line 2739 "gnome-chess.c"
				ChessState* state = NULL;
				ChessGame* _tmp150_;
				GList* _tmp151_;
				gconstpointer _tmp152_;
				ChessState* _tmp153_;
				ChessGame* _tmp154_;
				ChessState* _tmp155_;
				ChessMove* _tmp156_;
#line 378 "../src/gnome-chess.vala"
				if (!_tmp148_) {
#line 2750 "gnome-chess.c"
					gint _tmp149_;
#line 378 "../src/gnome-chess.vala"
					_tmp149_ = j;
#line 378 "../src/gnome-chess.vala"
					j = _tmp149_ - 1;
#line 2756 "gnome-chess.c"
				}
#line 378 "../src/gnome-chess.vala"
				_tmp148_ = FALSE;
#line 378 "../src/gnome-chess.vala"
				if (!(j >= 0)) {
#line 378 "../src/gnome-chess.vala"
					break;
#line 2764 "gnome-chess.c"
				}
#line 380 "../src/gnome-chess.vala"
				_tmp150_ = self->priv->game;
#line 380 "../src/gnome-chess.vala"
				_tmp151_ = _tmp150_->move_stack;
#line 380 "../src/gnome-chess.vala"
				_tmp152_ = g_list_nth_data (_tmp151_, (guint) j);
#line 380 "../src/gnome-chess.vala"
				_tmp153_ = _g_object_ref0 ((ChessState*) _tmp152_);
#line 380 "../src/gnome-chess.vala"
				state = _tmp153_;
#line 381 "../src/gnome-chess.vala"
				_tmp154_ = self->priv->game;
#line 381 "../src/gnome-chess.vala"
				_tmp155_ = state;
#line 381 "../src/gnome-chess.vala"
				_tmp156_ = _tmp155_->last_move;
#line 381 "../src/gnome-chess.vala"
				chess_application_game_move_cb (self, _tmp154_, _tmp156_);
#line 378 "../src/gnome-chess.vala"
				_g_object_unref0 (state);
#line 2786 "gnome-chess.c"
			}
		}
	}
#line 384 "../src/gnome-chess.vala"
	_tmp158_ = self->priv->game_file;
#line 384 "../src/gnome-chess.vala"
	if (_tmp158_ != NULL) {
#line 2794 "gnome-chess.c"
		GFile* _tmp159_;
		gchar* _tmp160_;
		gchar* _tmp161_;
		const gchar* _tmp162_;
#line 384 "../src/gnome-chess.vala"
		_tmp159_ = self->priv->game_file;
#line 384 "../src/gnome-chess.vala"
		_tmp160_ = g_file_get_path (_tmp159_);
#line 384 "../src/gnome-chess.vala"
		_tmp161_ = _tmp160_;
#line 384 "../src/gnome-chess.vala"
		_tmp162_ = self->priv->autosave_filename;
#line 384 "../src/gnome-chess.vala"
		_tmp157_ = g_strcmp0 (_tmp161_, _tmp162_) == 0;
#line 384 "../src/gnome-chess.vala"
		_g_free0 (_tmp161_);
#line 2811 "gnome-chess.c"
	} else {
#line 384 "../src/gnome-chess.vala"
		_tmp157_ = FALSE;
#line 2815 "gnome-chess.c"
	}
#line 384 "../src/gnome-chess.vala"
	if (_tmp157_) {
#line 386 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = TRUE;
#line 387 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 2823 "gnome-chess.c"
	} else {
#line 391 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 392 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 2829 "gnome-chess.c"
	}
#line 395 "../src/gnome-chess.vala"
	_tmp163_ = self->priv->game;
#line 395 "../src/gnome-chess.vala"
	chess_game_start (_tmp163_);
#line 397 "../src/gnome-chess.vala"
	timer_increment_adj_value = 0;
#line 398 "../src/gnome-chess.vala"
	_tmp164_ = self->priv->pgn_game;
#line 398 "../src/gnome-chess.vala"
	_tmp165_ = pgn_game_get_timer_increment (_tmp164_);
#line 398 "../src/gnome-chess.vala"
	_tmp166_ = _tmp165_;
#line 398 "../src/gnome-chess.vala"
	if (_tmp166_ != NULL) {
#line 2845 "gnome-chess.c"
		PGNGame* _tmp167_;
		const gchar* _tmp168_;
		const gchar* _tmp169_;
#line 399 "../src/gnome-chess.vala"
		_tmp167_ = self->priv->pgn_game;
#line 399 "../src/gnome-chess.vala"
		_tmp168_ = pgn_game_get_timer_increment (_tmp167_);
#line 399 "../src/gnome-chess.vala"
		_tmp169_ = _tmp168_;
#line 399 "../src/gnome-chess.vala"
		timer_increment_adj_value = atoi (_tmp169_);
#line 2857 "gnome-chess.c"
	} else {
		GSettings* _tmp170_;
		PGNGame* _tmp171_;
		gchar* _tmp172_;
		gchar* _tmp173_;
#line 402 "../src/gnome-chess.vala"
		_tmp170_ = self->priv->settings;
#line 402 "../src/gnome-chess.vala"
		timer_increment_adj_value = g_settings_get_int (_tmp170_, INCREMENT_SETTINGS_KEY);
#line 403 "../src/gnome-chess.vala"
		_tmp171_ = self->priv->pgn_game;
#line 403 "../src/gnome-chess.vala"
		_tmp172_ = g_strdup_printf ("%i", timer_increment_adj_value);
#line 403 "../src/gnome-chess.vala"
		_tmp173_ = _tmp172_;
#line 403 "../src/gnome-chess.vala"
		pgn_game_set_timer_increment (_tmp171_, _tmp173_);
#line 403 "../src/gnome-chess.vala"
		_g_free0 (_tmp173_);
#line 2877 "gnome-chess.c"
	}
#line 406 "../src/gnome-chess.vala"
	clock_type = CHESS_CLOCK_TYPE_SIMPLE;
#line 407 "../src/gnome-chess.vala"
	_tmp174_ = self->priv->pgn_game;
#line 407 "../src/gnome-chess.vala"
	_tmp175_ = pgn_game_get_clock_type (_tmp174_);
#line 407 "../src/gnome-chess.vala"
	_tmp176_ = _tmp175_;
#line 407 "../src/gnome-chess.vala"
	if (_tmp176_ != NULL) {
#line 2889 "gnome-chess.c"
		PGNGame* _tmp177_;
		const gchar* _tmp178_;
		const gchar* _tmp179_;
#line 408 "../src/gnome-chess.vala"
		_tmp177_ = self->priv->pgn_game;
#line 408 "../src/gnome-chess.vala"
		_tmp178_ = pgn_game_get_clock_type (_tmp177_);
#line 408 "../src/gnome-chess.vala"
		_tmp179_ = _tmp178_;
#line 408 "../src/gnome-chess.vala"
		clock_type = chess_clock_type_string_to_enum (_tmp179_);
#line 2901 "gnome-chess.c"
	} else {
		GSettings* _tmp180_;
		gchar* _tmp181_;
		gchar* _tmp182_;
		PGNGame* _tmp183_;
		gchar* _tmp184_;
		gchar* _tmp185_;
#line 411 "../src/gnome-chess.vala"
		_tmp180_ = self->priv->settings;
#line 411 "../src/gnome-chess.vala"
		_tmp181_ = g_settings_get_string (_tmp180_, CLOCK_TYPE_SETTINGS_KEY);
#line 411 "../src/gnome-chess.vala"
		_tmp182_ = _tmp181_;
#line 411 "../src/gnome-chess.vala"
		clock_type = chess_clock_type_string_to_enum (_tmp182_);
#line 411 "../src/gnome-chess.vala"
		_g_free0 (_tmp182_);
#line 412 "../src/gnome-chess.vala"
		_tmp183_ = self->priv->pgn_game;
#line 412 "../src/gnome-chess.vala"
		_tmp184_ = chess_clock_type_to_string (clock_type);
#line 412 "../src/gnome-chess.vala"
		_tmp185_ = _tmp184_;
#line 412 "../src/gnome-chess.vala"
		pgn_game_set_clock_type (_tmp183_, _tmp185_);
#line 412 "../src/gnome-chess.vala"
		_g_free0 (_tmp185_);
#line 2929 "gnome-chess.c"
	}
#line 415 "../src/gnome-chess.vala"
	_tmp186_ = self->priv->_window;
#line 415 "../src/gnome-chess.vala"
	_tmp187_ = self->priv->game;
#line 415 "../src/gnome-chess.vala"
	_tmp188_ = chess_game_get_clock (_tmp187_);
#line 415 "../src/gnome-chess.vala"
	_tmp189_ = _tmp188_;
#line 415 "../src/gnome-chess.vala"
	chess_window_set_clock_visible (_tmp186_, _tmp189_ != NULL);
#line 417 "../src/gnome-chess.vala"
	_tmp190_ = self->priv->game;
#line 417 "../src/gnome-chess.vala"
	_tmp191_ = chess_game_get_clock (_tmp190_);
#line 417 "../src/gnome-chess.vala"
	_tmp192_ = _tmp191_;
#line 417 "../src/gnome-chess.vala"
	if (_tmp192_ != NULL) {
#line 2949 "gnome-chess.c"
		ChessGame* _tmp193_;
		ChessClock* _tmp194_;
		ChessClock* _tmp195_;
		ChessGame* _tmp196_;
		ChessClock* _tmp197_;
		ChessClock* _tmp198_;
#line 419 "../src/gnome-chess.vala"
		_tmp193_ = self->priv->game;
#line 419 "../src/gnome-chess.vala"
		_tmp194_ = chess_game_get_clock (_tmp193_);
#line 419 "../src/gnome-chess.vala"
		_tmp195_ = _tmp194_;
#line 419 "../src/gnome-chess.vala"
		chess_clock_set_extra_seconds (_tmp195_, (gint) timer_increment_adj_value);
#line 420 "../src/gnome-chess.vala"
		_tmp196_ = self->priv->game;
#line 420 "../src/gnome-chess.vala"
		_tmp197_ = chess_game_get_clock (_tmp196_);
#line 420 "../src/gnome-chess.vala"
		_tmp198_ = _tmp197_;
#line 420 "../src/gnome-chess.vala"
		chess_clock_set_clock_type (_tmp198_, clock_type);
#line 2972 "gnome-chess.c"
	}
#line 424 "../src/gnome-chess.vala"
	_tmp199_ = self->priv->pgn_game;
#line 424 "../src/gnome-chess.vala"
	_tmp200_ = pgn_game_get_result (_tmp199_);
#line 424 "../src/gnome-chess.vala"
	_tmp201_ = _tmp200_;
#line 424 "../src/gnome-chess.vala"
	_tmp202_ = pgn_game_RESULT_WHITE;
#line 424 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp201_, _tmp202_) == 0) {
#line 2984 "gnome-chess.c"
		ChessGame* _tmp203_;
#line 425 "../src/gnome-chess.vala"
		_tmp203_ = self->priv->game;
#line 425 "../src/gnome-chess.vala"
		_tmp203_->result = CHESS_RESULT_WHITE_WON;
#line 2990 "gnome-chess.c"
	} else {
		PGNGame* _tmp204_;
		const gchar* _tmp205_;
		const gchar* _tmp206_;
		const gchar* _tmp207_;
#line 426 "../src/gnome-chess.vala"
		_tmp204_ = self->priv->pgn_game;
#line 426 "../src/gnome-chess.vala"
		_tmp205_ = pgn_game_get_result (_tmp204_);
#line 426 "../src/gnome-chess.vala"
		_tmp206_ = _tmp205_;
#line 426 "../src/gnome-chess.vala"
		_tmp207_ = pgn_game_RESULT_BLACK;
#line 426 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp206_, _tmp207_) == 0) {
#line 3006 "gnome-chess.c"
			ChessGame* _tmp208_;
#line 427 "../src/gnome-chess.vala"
			_tmp208_ = self->priv->game;
#line 427 "../src/gnome-chess.vala"
			_tmp208_->result = CHESS_RESULT_BLACK_WON;
#line 3012 "gnome-chess.c"
		} else {
			PGNGame* _tmp209_;
			const gchar* _tmp210_;
			const gchar* _tmp211_;
			const gchar* _tmp212_;
#line 428 "../src/gnome-chess.vala"
			_tmp209_ = self->priv->pgn_game;
#line 428 "../src/gnome-chess.vala"
			_tmp210_ = pgn_game_get_result (_tmp209_);
#line 428 "../src/gnome-chess.vala"
			_tmp211_ = _tmp210_;
#line 428 "../src/gnome-chess.vala"
			_tmp212_ = pgn_game_RESULT_DRAW;
#line 428 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp211_, _tmp212_) == 0) {
#line 3028 "gnome-chess.c"
				ChessGame* _tmp213_;
#line 429 "../src/gnome-chess.vala"
				_tmp213_ = self->priv->game;
#line 429 "../src/gnome-chess.vala"
				_tmp213_->result = CHESS_RESULT_DRAW;
#line 3034 "gnome-chess.c"
			}
		}
	}
#line 431 "../src/gnome-chess.vala"
	_tmp214_ = self->priv->opponent_engine;
#line 431 "../src/gnome-chess.vala"
	if (_tmp214_ != NULL) {
#line 3042 "gnome-chess.c"
		ChessEngine* _tmp215_;
#line 432 "../src/gnome-chess.vala"
		_tmp215_ = self->priv->opponent_engine;
#line 432 "../src/gnome-chess.vala"
		chess_engine_start_game (_tmp215_);
#line 3048 "gnome-chess.c"
	}
#line 434 "../src/gnome-chess.vala"
	_tmp217_ = moves;
#line 434 "../src/gnome-chess.vala"
	_tmp217__length1 = moves_length1;
#line 434 "../src/gnome-chess.vala"
	if (_tmp217__length1 > 0) {
#line 3056 "gnome-chess.c"
		ChessGame* _tmp218_;
		ChessClock* _tmp219_;
		ChessClock* _tmp220_;
#line 434 "../src/gnome-chess.vala"
		_tmp218_ = self->priv->game;
#line 434 "../src/gnome-chess.vala"
		_tmp219_ = chess_game_get_clock (_tmp218_);
#line 434 "../src/gnome-chess.vala"
		_tmp220_ = _tmp219_;
#line 434 "../src/gnome-chess.vala"
		_tmp216_ = _tmp220_ != NULL;
#line 3068 "gnome-chess.c"
	} else {
#line 434 "../src/gnome-chess.vala"
		_tmp216_ = FALSE;
#line 3072 "gnome-chess.c"
	}
#line 434 "../src/gnome-chess.vala"
	if (_tmp216_) {
#line 3076 "gnome-chess.c"
		ChessGame* _tmp221_;
		ChessClock* _tmp222_;
		ChessClock* _tmp223_;
#line 436 "../src/gnome-chess.vala"
		_tmp221_ = self->priv->game;
#line 436 "../src/gnome-chess.vala"
		_tmp222_ = chess_game_get_clock (_tmp221_);
#line 436 "../src/gnome-chess.vala"
		_tmp223_ = _tmp222_;
#line 436 "../src/gnome-chess.vala"
		chess_clock_start (_tmp223_);
#line 437 "../src/gnome-chess.vala"
		chess_application_enable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 3090 "gnome-chess.c"
	} else {
#line 441 "../src/gnome-chess.vala"
		chess_application_disable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 3094 "gnome-chess.c"
	}
#line 444 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 445 "../src/gnome-chess.vala"
	_tmp224_ = self->priv->_window;
#line 445 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp224_);
#line 446 "../src/gnome-chess.vala"
	_tmp225_ = self->priv->_window;
#line 446 "../src/gnome-chess.vala"
	chess_window_update_pause_resume_button (_tmp225_);
#line 448 "../src/gnome-chess.vala"
	_tmp226_ = self->priv->ai_profiles;
#line 448 "../src/gnome-chess.vala"
	if (_tmp226_ == NULL) {
#line 3110 "gnome-chess.c"
		ChessWindow* _tmp227_;
#line 450 "../src/gnome-chess.vala"
		_tmp227_ = self->priv->_window;
#line 450 "../src/gnome-chess.vala"
		chess_window_update_game_status (_tmp227_, NULL, _ ("No chess engine is installed. You will not be able to play against the" \
" computer."));
#line 3116 "gnome-chess.c"
	} else {
		ChessWindow* _tmp228_;
#line 456 "../src/gnome-chess.vala"
		_tmp228_ = self->priv->_window;
#line 456 "../src/gnome-chess.vala"
		chess_window_update_game_status (_tmp228_, NULL, NULL);
#line 3123 "gnome-chess.c"
	}
#line 459 "../src/gnome-chess.vala"
	self->priv->starting = FALSE;
#line 461 "../src/gnome-chess.vala"
	_tmp231_ = white_engine;
#line 461 "../src/gnome-chess.vala"
	if (_tmp231_ != NULL) {
#line 3131 "gnome-chess.c"
		ChessGame* _tmp232_;
		ChessPlayer* _tmp233_;
		ChessPlayer* _tmp234_;
#line 461 "../src/gnome-chess.vala"
		_tmp232_ = self->priv->game;
#line 461 "../src/gnome-chess.vala"
		_tmp233_ = chess_game_get_current_player (_tmp232_);
#line 461 "../src/gnome-chess.vala"
		_tmp234_ = _tmp233_;
#line 461 "../src/gnome-chess.vala"
		_tmp230_ = _tmp234_->color == COLOR_WHITE;
#line 3143 "gnome-chess.c"
	} else {
#line 461 "../src/gnome-chess.vala"
		_tmp230_ = FALSE;
#line 3147 "gnome-chess.c"
	}
#line 461 "../src/gnome-chess.vala"
	if (_tmp230_) {
#line 461 "../src/gnome-chess.vala"
		_tmp229_ = TRUE;
#line 3153 "gnome-chess.c"
	} else {
		gboolean _tmp235_ = FALSE;
		const gchar* _tmp236_;
#line 462 "../src/gnome-chess.vala"
		_tmp236_ = black_engine;
#line 462 "../src/gnome-chess.vala"
		if (_tmp236_ != NULL) {
#line 3161 "gnome-chess.c"
			ChessGame* _tmp237_;
			ChessPlayer* _tmp238_;
			ChessPlayer* _tmp239_;
#line 462 "../src/gnome-chess.vala"
			_tmp237_ = self->priv->game;
#line 462 "../src/gnome-chess.vala"
			_tmp238_ = chess_game_get_current_player (_tmp237_);
#line 462 "../src/gnome-chess.vala"
			_tmp239_ = _tmp238_;
#line 462 "../src/gnome-chess.vala"
			_tmp235_ = _tmp239_->color == COLOR_BLACK;
#line 3173 "gnome-chess.c"
		} else {
#line 462 "../src/gnome-chess.vala"
			_tmp235_ = FALSE;
#line 3177 "gnome-chess.c"
		}
#line 462 "../src/gnome-chess.vala"
		_tmp229_ = _tmp235_;
#line 3181 "gnome-chess.c"
	}
#line 461 "../src/gnome-chess.vala"
	if (_tmp229_) {
#line 3185 "gnome-chess.c"
		ChessEngine* _tmp240_;
		ChessEngine* _tmp241_;
#line 464 "../src/gnome-chess.vala"
		_tmp240_ = self->priv->opponent_engine;
#line 464 "../src/gnome-chess.vala"
		_vala_assert (_tmp240_ != NULL, "opponent_engine != null");
#line 465 "../src/gnome-chess.vala"
		chess_application_update_engine_timeout (self);
#line 466 "../src/gnome-chess.vala"
		_tmp241_ = self->priv->opponent_engine;
#line 466 "../src/gnome-chess.vala"
		chess_engine_move (_tmp241_);
#line 3198 "gnome-chess.c"
	}
#line 470 "../src/gnome-chess.vala"
	_tmp242_ = self->priv->game;
#line 470 "../src/gnome-chess.vala"
	if (_tmp242_->result != CHESS_RESULT_IN_PROGRESS) {
#line 3204 "gnome-chess.c"
		ChessGame* _tmp243_;
		ChessGame* _tmp244_;
#line 471 "../src/gnome-chess.vala"
		_tmp243_ = self->priv->game;
#line 471 "../src/gnome-chess.vala"
		_tmp244_ = self->priv->game;
#line 471 "../src/gnome-chess.vala"
		chess_game_stop (_tmp243_, _tmp244_->result, CHESS_RULE_UNKNOWN);
#line 3213 "gnome-chess.c"
	}
#line 248 "../src/gnome-chess.vala"
	_g_free0 (black_level);
#line 248 "../src/gnome-chess.vala"
	_g_free0 (black_engine);
#line 248 "../src/gnome-chess.vala"
	_g_free0 (white_level);
#line 248 "../src/gnome-chess.vala"
	_g_free0 (white_engine);
#line 248 "../src/gnome-chess.vala"
	moves = (_vala_array_free (moves, moves_length1, (GDestroyNotify) g_free), NULL);
#line 248 "../src/gnome-chess.vala"
	_g_free0 (fen);
#line 3227 "gnome-chess.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 506 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3236 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 506 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 506 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3243 "gnome-chess.c"
			gchar* _tmp0_;
#line 506 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 506 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3249 "gnome-chess.c"
		}
#line 506 "../src/gnome-chess.vala"
		return result;
#line 3253 "gnome-chess.c"
	}
#line 506 "../src/gnome-chess.vala"
	return NULL;
#line 3257 "gnome-chess.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 507 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3266 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 507 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 507 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3273 "gnome-chess.c"
			gchar* _tmp0_;
#line 507 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 507 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3279 "gnome-chess.c"
		}
#line 507 "../src/gnome-chess.vala"
		return result;
#line 3283 "gnome-chess.c"
	}
#line 507 "../src/gnome-chess.vala"
	return NULL;
#line 3287 "gnome-chess.c"
}

static gchar**
_vala_array_dup3 (gchar** self,
                  gssize length)
{
#line 508 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3296 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 508 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 508 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3303 "gnome-chess.c"
			gchar* _tmp0_;
#line 508 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 508 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3309 "gnome-chess.c"
		}
#line 508 "../src/gnome-chess.vala"
		return result;
#line 3313 "gnome-chess.c"
	}
#line 508 "../src/gnome-chess.vala"
	return NULL;
#line 3317 "gnome-chess.c"
}

static gchar**
_vala_array_dup4 (gchar** self,
                  gssize length)
{
#line 517 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3326 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 517 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 517 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3333 "gnome-chess.c"
			gchar* _tmp0_;
#line 517 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 517 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3339 "gnome-chess.c"
		}
#line 517 "../src/gnome-chess.vala"
		return result;
#line 3343 "gnome-chess.c"
	}
#line 517 "../src/gnome-chess.vala"
	return NULL;
#line 3347 "gnome-chess.c"
}

static gchar**
_vala_array_dup5 (gchar** self,
                  gssize length)
{
#line 518 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3356 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 518 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 518 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3363 "gnome-chess.c"
			gchar* _tmp0_;
#line 518 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 518 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3369 "gnome-chess.c"
		}
#line 518 "../src/gnome-chess.vala"
		return result;
#line 3373 "gnome-chess.c"
	}
#line 518 "../src/gnome-chess.vala"
	return NULL;
#line 3377 "gnome-chess.c"
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 519 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3386 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 519 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 519 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3393 "gnome-chess.c"
			gchar* _tmp0_;
#line 519 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 519 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3399 "gnome-chess.c"
		}
#line 519 "../src/gnome-chess.vala"
		return result;
#line 3403 "gnome-chess.c"
	}
#line 519 "../src/gnome-chess.vala"
	return NULL;
#line 3407 "gnome-chess.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 512 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3416 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 512 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 512 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3423 "gnome-chess.c"
			gchar* _tmp0_;
#line 512 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 512 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3429 "gnome-chess.c"
		}
#line 512 "../src/gnome-chess.vala"
		return result;
#line 3433 "gnome-chess.c"
	}
#line 512 "../src/gnome-chess.vala"
	return NULL;
#line 3437 "gnome-chess.c"
}

static gchar**
_vala_array_dup8 (gchar** self,
                  gssize length)
{
#line 513 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3446 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 513 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 513 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3453 "gnome-chess.c"
			gchar* _tmp0_;
#line 513 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 513 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3459 "gnome-chess.c"
		}
#line 513 "../src/gnome-chess.vala"
		return result;
#line 3463 "gnome-chess.c"
	}
#line 513 "../src/gnome-chess.vala"
	return NULL;
#line 3467 "gnome-chess.c"
}

static gchar**
_vala_array_dup9 (gchar** self,
                  gssize length)
{
#line 514 "../src/gnome-chess.vala"
	if (length >= 0) {
#line 3476 "gnome-chess.c"
		gchar** result;
		gssize i;
#line 514 "../src/gnome-chess.vala"
		result = g_new0 (gchar*, length + 1);
#line 514 "../src/gnome-chess.vala"
		for (i = 0; i < length; i++) {
#line 3483 "gnome-chess.c"
			gchar* _tmp0_;
#line 514 "../src/gnome-chess.vala"
			_tmp0_ = g_strdup (self[i]);
#line 514 "../src/gnome-chess.vala"
			result[i] = _tmp0_;
#line 3489 "gnome-chess.c"
		}
#line 514 "../src/gnome-chess.vala"
		return result;
#line 3493 "gnome-chess.c"
	}
#line 514 "../src/gnome-chess.vala"
	return NULL;
#line 3497 "gnome-chess.c"
}

static ChessEngine*
chess_application_get_engine (ChessApplication* self,
                              const gchar* name,
                              const gchar* difficulty)
{
	ChessEngine* engine = NULL;
	AIProfile* profile = NULL;
	GList* _tmp0_;
	AIProfile* _tmp8_;
	gchar** options = NULL;
	gint options_length1 = 0;
	gint _options_size_ = 0;
	gchar** uci_go_options = NULL;
	gint uci_go_options_length1 = 0;
	gint _uci_go_options_size_ = 0;
	gchar** args = NULL;
	gint args_length1 = 0;
	gint _args_size_ = 0;
	const gchar* _tmp13_;
	GQuark _tmp15_ = 0U;
#line 503 "../src/gnome-chess.vala"
	static GQuark _tmp14_label0 = 0;
#line 503 "../src/gnome-chess.vala"
	static GQuark _tmp14_label1 = 0;
#line 3524 "gnome-chess.c"
	AIProfile* _tmp61_;
	const gchar* _tmp62_;
	const gchar* _tmp63_;
	ChessEngine* result;
#line 474 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 474 "../src/gnome-chess.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 474 "../src/gnome-chess.vala"
	g_return_val_if_fail (difficulty != NULL, NULL);
#line 477 "../src/gnome-chess.vala"
	profile = NULL;
#line 479 "../src/gnome-chess.vala"
	if (g_strcmp0 (name, "human") == 0) {
#line 480 "../src/gnome-chess.vala"
		result = NULL;
#line 480 "../src/gnome-chess.vala"
		_g_object_unref0 (profile);
#line 480 "../src/gnome-chess.vala"
		_g_object_unref0 (engine);
#line 480 "../src/gnome-chess.vala"
		return result;
#line 3547 "gnome-chess.c"
	}
#line 483 "../src/gnome-chess.vala"
	if (g_strcmp0 (name, "GNUchess") == 0) {
#line 484 "../src/gnome-chess.vala"
		name = "GNU Chess";
#line 3553 "gnome-chess.c"
	}
#line 486 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->ai_profiles;
#line 3557 "gnome-chess.c"
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
#line 486 "../src/gnome-chess.vala"
		p_collection = _tmp0_;
#line 486 "../src/gnome-chess.vala"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 3565 "gnome-chess.c"
			AIProfile* _tmp1_;
			AIProfile* p = NULL;
#line 486 "../src/gnome-chess.vala"
			_tmp1_ = _g_object_ref0 ((AIProfile*) p_it->data);
#line 486 "../src/gnome-chess.vala"
			p = _tmp1_;
#line 3572 "gnome-chess.c"
			{
				gboolean _tmp2_ = FALSE;
#line 488 "../src/gnome-chess.vala"
				if (g_strcmp0 (name, "") == 0) {
#line 488 "../src/gnome-chess.vala"
					_tmp2_ = TRUE;
#line 3579 "gnome-chess.c"
				} else {
					AIProfile* _tmp3_;
					const gchar* _tmp4_;
					const gchar* _tmp5_;
#line 488 "../src/gnome-chess.vala"
					_tmp3_ = p;
#line 488 "../src/gnome-chess.vala"
					_tmp4_ = ai_profile_get_name (_tmp3_);
#line 488 "../src/gnome-chess.vala"
					_tmp5_ = _tmp4_;
#line 488 "../src/gnome-chess.vala"
					_tmp2_ = g_strcmp0 (_tmp5_, name) == 0;
#line 3592 "gnome-chess.c"
				}
#line 488 "../src/gnome-chess.vala"
				if (_tmp2_) {
#line 3596 "gnome-chess.c"
					AIProfile* _tmp6_;
					AIProfile* _tmp7_;
#line 490 "../src/gnome-chess.vala"
					_tmp6_ = p;
#line 490 "../src/gnome-chess.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 490 "../src/gnome-chess.vala"
					_g_object_unref0 (profile);
#line 490 "../src/gnome-chess.vala"
					profile = _tmp7_;
#line 491 "../src/gnome-chess.vala"
					_g_object_unref0 (p);
#line 491 "../src/gnome-chess.vala"
					break;
#line 3611 "gnome-chess.c"
				}
#line 486 "../src/gnome-chess.vala"
				_g_object_unref0 (p);
#line 3615 "gnome-chess.c"
			}
		}
	}
#line 494 "../src/gnome-chess.vala"
	_tmp8_ = profile;
#line 494 "../src/gnome-chess.vala"
	if (_tmp8_ == NULL) {
#line 3623 "gnome-chess.c"
		GList* _tmp9_;
		GList* _tmp10_;
		gconstpointer _tmp11_;
		AIProfile* _tmp12_;
#line 496 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:496: Unknown AI profile %s", name);
#line 497 "../src/gnome-chess.vala"
		_tmp9_ = self->priv->ai_profiles;
#line 497 "../src/gnome-chess.vala"
		if (_tmp9_ == NULL) {
#line 498 "../src/gnome-chess.vala"
			result = NULL;
#line 498 "../src/gnome-chess.vala"
			_g_object_unref0 (profile);
#line 498 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 498 "../src/gnome-chess.vala"
			return result;
#line 3642 "gnome-chess.c"
		}
#line 499 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->ai_profiles;
#line 499 "../src/gnome-chess.vala"
		_tmp11_ = _tmp10_->data;
#line 499 "../src/gnome-chess.vala"
		_tmp12_ = _g_object_ref0 ((AIProfile*) _tmp11_);
#line 499 "../src/gnome-chess.vala"
		_g_object_unref0 (profile);
#line 499 "../src/gnome-chess.vala"
		profile = _tmp12_;
#line 3654 "gnome-chess.c"
	}
#line 503 "../src/gnome-chess.vala"
	_tmp13_ = difficulty;
#line 503 "../src/gnome-chess.vala"
	_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
#line 503 "../src/gnome-chess.vala"
	if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("easy")))) {
#line 503 "../src/gnome-chess.vala"
		switch (0) {
#line 3664 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp16_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_ = 0;
				gchar** _tmp19_;
				gint _tmp19__length1;
				gchar** _tmp20_;
				gint _tmp20__length1;
				AIProfile* _tmp21_;
				gchar** _tmp22_;
				gint _tmp22__length1;
				gint _tmp23_ = 0;
				gchar** _tmp24_;
				gint _tmp24__length1;
				gchar** _tmp25_;
				gint _tmp25__length1;
				AIProfile* _tmp26_;
				gchar** _tmp27_;
				gint _tmp27__length1;
				gint _tmp28_ = 0;
				gchar** _tmp29_;
				gint _tmp29__length1;
				gchar** _tmp30_;
				gint _tmp30__length1;
#line 506 "../src/gnome-chess.vala"
				_tmp16_ = profile;
#line 506 "../src/gnome-chess.vala"
				_tmp17_ = ai_profile_get_easy_options (_tmp16_, &_tmp18_);
#line 506 "../src/gnome-chess.vala"
				_tmp17__length1 = _tmp18_;
#line 506 "../src/gnome-chess.vala"
				_tmp19_ = _tmp17_;
#line 506 "../src/gnome-chess.vala"
				_tmp19__length1 = _tmp17__length1;
#line 506 "../src/gnome-chess.vala"
				_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup1 (_tmp19_, _tmp19__length1) : _tmp19_;
#line 506 "../src/gnome-chess.vala"
				_tmp20__length1 = _tmp19__length1;
#line 506 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 506 "../src/gnome-chess.vala"
				options = _tmp20_;
#line 506 "../src/gnome-chess.vala"
				options_length1 = _tmp20__length1;
#line 506 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 507 "../src/gnome-chess.vala"
				_tmp21_ = profile;
#line 507 "../src/gnome-chess.vala"
				_tmp22_ = ai_profile_get_easy_uci_go_options (_tmp21_, &_tmp23_);
#line 507 "../src/gnome-chess.vala"
				_tmp22__length1 = _tmp23_;
#line 507 "../src/gnome-chess.vala"
				_tmp24_ = _tmp22_;
#line 507 "../src/gnome-chess.vala"
				_tmp24__length1 = _tmp22__length1;
#line 507 "../src/gnome-chess.vala"
				_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup2 (_tmp24_, _tmp24__length1) : _tmp24_;
#line 507 "../src/gnome-chess.vala"
				_tmp25__length1 = _tmp24__length1;
#line 507 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 507 "../src/gnome-chess.vala"
				uci_go_options = _tmp25_;
#line 507 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp25__length1;
#line 507 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 508 "../src/gnome-chess.vala"
				_tmp26_ = profile;
#line 508 "../src/gnome-chess.vala"
				_tmp27_ = ai_profile_get_easy_args (_tmp26_, &_tmp28_);
#line 508 "../src/gnome-chess.vala"
				_tmp27__length1 = _tmp28_;
#line 508 "../src/gnome-chess.vala"
				_tmp29_ = _tmp27_;
#line 508 "../src/gnome-chess.vala"
				_tmp29__length1 = _tmp27__length1;
#line 508 "../src/gnome-chess.vala"
				_tmp30_ = (_tmp29_ != NULL) ? _vala_array_dup3 (_tmp29_, _tmp29__length1) : _tmp29_;
#line 508 "../src/gnome-chess.vala"
				_tmp30__length1 = _tmp29__length1;
#line 508 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 508 "../src/gnome-chess.vala"
				args = _tmp30_;
#line 508 "../src/gnome-chess.vala"
				args_length1 = _tmp30__length1;
#line 508 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 509 "../src/gnome-chess.vala"
				break;
#line 3759 "gnome-chess.c"
			}
		}
	} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("hard")))) {
#line 503 "../src/gnome-chess.vala"
		switch (0) {
#line 3765 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp31_;
				gchar** _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_ = 0;
				gchar** _tmp34_;
				gint _tmp34__length1;
				gchar** _tmp35_;
				gint _tmp35__length1;
				AIProfile* _tmp36_;
				gchar** _tmp37_;
				gint _tmp37__length1;
				gint _tmp38_ = 0;
				gchar** _tmp39_;
				gint _tmp39__length1;
				gchar** _tmp40_;
				gint _tmp40__length1;
				AIProfile* _tmp41_;
				gchar** _tmp42_;
				gint _tmp42__length1;
				gint _tmp43_ = 0;
				gchar** _tmp44_;
				gint _tmp44__length1;
				gchar** _tmp45_;
				gint _tmp45__length1;
#line 517 "../src/gnome-chess.vala"
				_tmp31_ = profile;
#line 517 "../src/gnome-chess.vala"
				_tmp32_ = ai_profile_get_hard_options (_tmp31_, &_tmp33_);
#line 517 "../src/gnome-chess.vala"
				_tmp32__length1 = _tmp33_;
#line 517 "../src/gnome-chess.vala"
				_tmp34_ = _tmp32_;
#line 517 "../src/gnome-chess.vala"
				_tmp34__length1 = _tmp32__length1;
#line 517 "../src/gnome-chess.vala"
				_tmp35_ = (_tmp34_ != NULL) ? _vala_array_dup4 (_tmp34_, _tmp34__length1) : _tmp34_;
#line 517 "../src/gnome-chess.vala"
				_tmp35__length1 = _tmp34__length1;
#line 517 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 517 "../src/gnome-chess.vala"
				options = _tmp35_;
#line 517 "../src/gnome-chess.vala"
				options_length1 = _tmp35__length1;
#line 517 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 518 "../src/gnome-chess.vala"
				_tmp36_ = profile;
#line 518 "../src/gnome-chess.vala"
				_tmp37_ = ai_profile_get_hard_uci_go_options (_tmp36_, &_tmp38_);
#line 518 "../src/gnome-chess.vala"
				_tmp37__length1 = _tmp38_;
#line 518 "../src/gnome-chess.vala"
				_tmp39_ = _tmp37_;
#line 518 "../src/gnome-chess.vala"
				_tmp39__length1 = _tmp37__length1;
#line 518 "../src/gnome-chess.vala"
				_tmp40_ = (_tmp39_ != NULL) ? _vala_array_dup5 (_tmp39_, _tmp39__length1) : _tmp39_;
#line 518 "../src/gnome-chess.vala"
				_tmp40__length1 = _tmp39__length1;
#line 518 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 518 "../src/gnome-chess.vala"
				uci_go_options = _tmp40_;
#line 518 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp40__length1;
#line 518 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 519 "../src/gnome-chess.vala"
				_tmp41_ = profile;
#line 519 "../src/gnome-chess.vala"
				_tmp42_ = ai_profile_get_hard_args (_tmp41_, &_tmp43_);
#line 519 "../src/gnome-chess.vala"
				_tmp42__length1 = _tmp43_;
#line 519 "../src/gnome-chess.vala"
				_tmp44_ = _tmp42_;
#line 519 "../src/gnome-chess.vala"
				_tmp44__length1 = _tmp42__length1;
#line 519 "../src/gnome-chess.vala"
				_tmp45_ = (_tmp44_ != NULL) ? _vala_array_dup6 (_tmp44_, _tmp44__length1) : _tmp44_;
#line 519 "../src/gnome-chess.vala"
				_tmp45__length1 = _tmp44__length1;
#line 519 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 519 "../src/gnome-chess.vala"
				args = _tmp45_;
#line 519 "../src/gnome-chess.vala"
				args_length1 = _tmp45__length1;
#line 519 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 520 "../src/gnome-chess.vala"
				break;
#line 3860 "gnome-chess.c"
			}
		}
	} else {
#line 503 "../src/gnome-chess.vala"
		switch (0) {
#line 3866 "gnome-chess.c"
			default:
			{
				AIProfile* _tmp46_;
				gchar** _tmp47_;
				gint _tmp47__length1;
				gint _tmp48_ = 0;
				gchar** _tmp49_;
				gint _tmp49__length1;
				gchar** _tmp50_;
				gint _tmp50__length1;
				AIProfile* _tmp51_;
				gchar** _tmp52_;
				gint _tmp52__length1;
				gint _tmp53_ = 0;
				gchar** _tmp54_;
				gint _tmp54__length1;
				gchar** _tmp55_;
				gint _tmp55__length1;
				AIProfile* _tmp56_;
				gchar** _tmp57_;
				gint _tmp57__length1;
				gint _tmp58_ = 0;
				gchar** _tmp59_;
				gint _tmp59__length1;
				gchar** _tmp60_;
				gint _tmp60__length1;
#line 512 "../src/gnome-chess.vala"
				_tmp46_ = profile;
#line 512 "../src/gnome-chess.vala"
				_tmp47_ = ai_profile_get_normal_options (_tmp46_, &_tmp48_);
#line 512 "../src/gnome-chess.vala"
				_tmp47__length1 = _tmp48_;
#line 512 "../src/gnome-chess.vala"
				_tmp49_ = _tmp47_;
#line 512 "../src/gnome-chess.vala"
				_tmp49__length1 = _tmp47__length1;
#line 512 "../src/gnome-chess.vala"
				_tmp50_ = (_tmp49_ != NULL) ? _vala_array_dup7 (_tmp49_, _tmp49__length1) : _tmp49_;
#line 512 "../src/gnome-chess.vala"
				_tmp50__length1 = _tmp49__length1;
#line 512 "../src/gnome-chess.vala"
				options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 512 "../src/gnome-chess.vala"
				options = _tmp50_;
#line 512 "../src/gnome-chess.vala"
				options_length1 = _tmp50__length1;
#line 512 "../src/gnome-chess.vala"
				_options_size_ = options_length1;
#line 513 "../src/gnome-chess.vala"
				_tmp51_ = profile;
#line 513 "../src/gnome-chess.vala"
				_tmp52_ = ai_profile_get_normal_uci_go_options (_tmp51_, &_tmp53_);
#line 513 "../src/gnome-chess.vala"
				_tmp52__length1 = _tmp53_;
#line 513 "../src/gnome-chess.vala"
				_tmp54_ = _tmp52_;
#line 513 "../src/gnome-chess.vala"
				_tmp54__length1 = _tmp52__length1;
#line 513 "../src/gnome-chess.vala"
				_tmp55_ = (_tmp54_ != NULL) ? _vala_array_dup8 (_tmp54_, _tmp54__length1) : _tmp54_;
#line 513 "../src/gnome-chess.vala"
				_tmp55__length1 = _tmp54__length1;
#line 513 "../src/gnome-chess.vala"
				uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 513 "../src/gnome-chess.vala"
				uci_go_options = _tmp55_;
#line 513 "../src/gnome-chess.vala"
				uci_go_options_length1 = _tmp55__length1;
#line 513 "../src/gnome-chess.vala"
				_uci_go_options_size_ = uci_go_options_length1;
#line 514 "../src/gnome-chess.vala"
				_tmp56_ = profile;
#line 514 "../src/gnome-chess.vala"
				_tmp57_ = ai_profile_get_normal_args (_tmp56_, &_tmp58_);
#line 514 "../src/gnome-chess.vala"
				_tmp57__length1 = _tmp58_;
#line 514 "../src/gnome-chess.vala"
				_tmp59_ = _tmp57_;
#line 514 "../src/gnome-chess.vala"
				_tmp59__length1 = _tmp57__length1;
#line 514 "../src/gnome-chess.vala"
				_tmp60_ = (_tmp59_ != NULL) ? _vala_array_dup9 (_tmp59_, _tmp59__length1) : _tmp59_;
#line 514 "../src/gnome-chess.vala"
				_tmp60__length1 = _tmp59__length1;
#line 514 "../src/gnome-chess.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 514 "../src/gnome-chess.vala"
				args = _tmp60_;
#line 514 "../src/gnome-chess.vala"
				args_length1 = _tmp60__length1;
#line 514 "../src/gnome-chess.vala"
				_args_size_ = args_length1;
#line 515 "../src/gnome-chess.vala"
				break;
#line 3961 "gnome-chess.c"
			}
		}
	}
#line 523 "../src/gnome-chess.vala"
	_tmp61_ = profile;
#line 523 "../src/gnome-chess.vala"
	_tmp62_ = ai_profile_get_protocol (_tmp61_);
#line 523 "../src/gnome-chess.vala"
	_tmp63_ = _tmp62_;
#line 523 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp63_, "cecp") == 0) {
#line 3973 "gnome-chess.c"
		gchar** _tmp64_;
		gint _tmp64__length1;
		AIProfile* _tmp65_;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		gchar** _tmp68_;
		gint _tmp68__length1;
		AIProfile* _tmp69_;
		guint _tmp70_;
		guint _tmp71_;
		gchar** _tmp72_;
		gint _tmp72__length1;
		ChessEngineCECP* _tmp73_;
#line 525 "../src/gnome-chess.vala"
		_tmp64_ = uci_go_options;
#line 525 "../src/gnome-chess.vala"
		_tmp64__length1 = uci_go_options_length1;
#line 525 "../src/gnome-chess.vala"
		g_warn_if_fail (_tmp64__length1 == 0);
#line 526 "../src/gnome-chess.vala"
		_tmp65_ = profile;
#line 526 "../src/gnome-chess.vala"
		_tmp66_ = ai_profile_get_binary (_tmp65_);
#line 526 "../src/gnome-chess.vala"
		_tmp67_ = _tmp66_;
#line 526 "../src/gnome-chess.vala"
		_tmp68_ = args;
#line 526 "../src/gnome-chess.vala"
		_tmp68__length1 = args_length1;
#line 526 "../src/gnome-chess.vala"
		_tmp69_ = profile;
#line 526 "../src/gnome-chess.vala"
		_tmp70_ = ai_profile_get_delay_seconds (_tmp69_);
#line 526 "../src/gnome-chess.vala"
		_tmp71_ = _tmp70_;
#line 526 "../src/gnome-chess.vala"
		_tmp72_ = options;
#line 526 "../src/gnome-chess.vala"
		_tmp72__length1 = options_length1;
#line 526 "../src/gnome-chess.vala"
		_tmp73_ = chess_engine_cecp_new (_tmp67_, _tmp68_, _tmp68__length1, _tmp71_, _tmp72_, _tmp72__length1);
#line 526 "../src/gnome-chess.vala"
		_g_object_unref0 (engine);
#line 526 "../src/gnome-chess.vala"
		engine = (ChessEngine*) _tmp73_;
#line 4019 "gnome-chess.c"
	} else {
		AIProfile* _tmp74_;
		const gchar* _tmp75_;
		const gchar* _tmp76_;
#line 528 "../src/gnome-chess.vala"
		_tmp74_ = profile;
#line 528 "../src/gnome-chess.vala"
		_tmp75_ = ai_profile_get_protocol (_tmp74_);
#line 528 "../src/gnome-chess.vala"
		_tmp76_ = _tmp75_;
#line 528 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp76_, "uci") == 0) {
#line 4032 "gnome-chess.c"
			AIProfile* _tmp77_;
			const gchar* _tmp78_;
			const gchar* _tmp79_;
			gchar** _tmp80_;
			gint _tmp80__length1;
			AIProfile* _tmp81_;
			guint _tmp82_;
			guint _tmp83_;
			gchar** _tmp84_;
			gint _tmp84__length1;
			gchar** _tmp85_;
			gint _tmp85__length1;
			ChessEngineUCI* _tmp86_;
#line 530 "../src/gnome-chess.vala"
			_tmp77_ = profile;
#line 530 "../src/gnome-chess.vala"
			_tmp78_ = ai_profile_get_binary (_tmp77_);
#line 530 "../src/gnome-chess.vala"
			_tmp79_ = _tmp78_;
#line 530 "../src/gnome-chess.vala"
			_tmp80_ = args;
#line 530 "../src/gnome-chess.vala"
			_tmp80__length1 = args_length1;
#line 530 "../src/gnome-chess.vala"
			_tmp81_ = profile;
#line 530 "../src/gnome-chess.vala"
			_tmp82_ = ai_profile_get_delay_seconds (_tmp81_);
#line 530 "../src/gnome-chess.vala"
			_tmp83_ = _tmp82_;
#line 530 "../src/gnome-chess.vala"
			_tmp84_ = options;
#line 530 "../src/gnome-chess.vala"
			_tmp84__length1 = options_length1;
#line 530 "../src/gnome-chess.vala"
			_tmp85_ = uci_go_options;
#line 530 "../src/gnome-chess.vala"
			_tmp85__length1 = uci_go_options_length1;
#line 530 "../src/gnome-chess.vala"
			_tmp86_ = chess_engine_uci_new (_tmp79_, _tmp80_, _tmp80__length1, _tmp83_, _tmp84_, _tmp84__length1, _tmp85_, _tmp85__length1);
#line 530 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 530 "../src/gnome-chess.vala"
			engine = (ChessEngine*) _tmp86_;
#line 4076 "gnome-chess.c"
		} else {
			AIProfile* _tmp87_;
			const gchar* _tmp88_;
			const gchar* _tmp89_;
#line 534 "../src/gnome-chess.vala"
			_tmp87_ = profile;
#line 534 "../src/gnome-chess.vala"
			_tmp88_ = ai_profile_get_protocol (_tmp87_);
#line 534 "../src/gnome-chess.vala"
			_tmp89_ = _tmp88_;
#line 534 "../src/gnome-chess.vala"
			g_warning ("gnome-chess.vala:534: Unknown AI protocol %s", _tmp89_);
#line 535 "../src/gnome-chess.vala"
			result = NULL;
#line 535 "../src/gnome-chess.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 535 "../src/gnome-chess.vala"
			uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 535 "../src/gnome-chess.vala"
			options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 535 "../src/gnome-chess.vala"
			_g_object_unref0 (profile);
#line 535 "../src/gnome-chess.vala"
			_g_object_unref0 (engine);
#line 535 "../src/gnome-chess.vala"
			return result;
#line 4103 "gnome-chess.c"
		}
	}
#line 538 "../src/gnome-chess.vala"
	result = engine;
#line 538 "../src/gnome-chess.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 538 "../src/gnome-chess.vala"
	uci_go_options = (_vala_array_free (uci_go_options, uci_go_options_length1, (GDestroyNotify) g_free), NULL);
#line 538 "../src/gnome-chess.vala"
	options = (_vala_array_free (options, options_length1, (GDestroyNotify) g_free), NULL);
#line 538 "../src/gnome-chess.vala"
	_g_object_unref0 (profile);
#line 538 "../src/gnome-chess.vala"
	return result;
#line 4118 "gnome-chess.c"
}

static void
chess_application_do_engine_move (ChessApplication* self,
                                  const gchar* move)
{
	ChessPlayer* _tmp0_;
#line 541 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 543 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent;
#line 543 "../src/gnome-chess.vala"
	if (!chess_player_move (_tmp0_, move, TRUE)) {
#line 4134 "gnome-chess.c"
		ChessGame* _tmp1_;
#line 545 "../src/gnome-chess.vala"
		g_warning ("gnome-chess.vala:545: Engine's move %s is illegal! Engine desync?", move);
#line 546 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->game;
#line 546 "../src/gnome-chess.vala"
		chess_game_stop (_tmp1_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4142 "gnome-chess.c"
	}
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 550 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 550 "../src/gnome-chess.vala"
	return _data4_;
#line 4153 "gnome-chess.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 550 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 4163 "gnome-chess.c"
		ChessApplication* self;
#line 550 "../src/gnome-chess.vala"
		self = _data4_->self;
#line 550 "../src/gnome-chess.vala"
		_g_object_unref0 (_data4_->original_state);
#line 550 "../src/gnome-chess.vala"
		_g_object_unref0 (_data4_->original_game);
#line 550 "../src/gnome-chess.vala"
		_g_free0 (_data4_->move);
#line 550 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 550 "../src/gnome-chess.vala"
		g_slice_free (Block4Data, _data4_);
#line 4177 "gnome-chess.c"
	}
}

static gboolean
___lambda32_ (Block4Data* _data4_)
{
	ChessApplication* self;
	ChessGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 568 "../src/gnome-chess.vala"
	self = _data4_->self;
#line 569 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 569 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_is_paused (_tmp0_);
#line 569 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 569 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 571 "../src/gnome-chess.vala"
		result = G_SOURCE_CONTINUE;
#line 571 "../src/gnome-chess.vala"
		return result;
#line 4203 "gnome-chess.c"
	} else {
		ChessGame* _tmp3_;
		ChessGame* _tmp4_;
#line 579 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 579 "../src/gnome-chess.vala"
		_tmp4_ = _data4_->original_game;
#line 579 "../src/gnome-chess.vala"
		if (_tmp3_ == _tmp4_) {
#line 4213 "gnome-chess.c"
			ChessGame* _tmp5_;
			ChessState* _tmp6_;
			ChessState* _tmp7_;
			ChessState* _tmp8_;
#line 581 "../src/gnome-chess.vala"
			_tmp5_ = self->priv->game;
#line 581 "../src/gnome-chess.vala"
			_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 581 "../src/gnome-chess.vala"
			_tmp7_ = _tmp6_;
#line 581 "../src/gnome-chess.vala"
			_tmp8_ = _data4_->original_state;
#line 581 "../src/gnome-chess.vala"
			_vala_assert (_tmp7_ == _tmp8_, "game.current_state == original_state");
#line 582 "../src/gnome-chess.vala"
			chess_application_do_engine_move (self, _data4_->move);
#line 4230 "gnome-chess.c"
		}
#line 584 "../src/gnome-chess.vala"
		result = G_SOURCE_REMOVE;
#line 584 "../src/gnome-chess.vala"
		return result;
#line 4236 "gnome-chess.c"
	}
}

static gboolean
____lambda32__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda32_ (self);
#line 568 "../src/gnome-chess.vala"
	return result;
#line 4247 "gnome-chess.c"
}

static void
chess_application_engine_move_cb (ChessApplication* self,
                                  ChessEngine* engine,
                                  const gchar* move)
{
	Block4Data* _data4_;
	gchar* _tmp0_;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessState* _tmp4_;
	ChessState* _tmp5_;
	ChessState* _tmp6_;
	ChessGame* _tmp7_;
	ChessGame* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 550 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 550 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 550 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 550 "../src/gnome-chess.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 550 "../src/gnome-chess.vala"
	_data4_->_ref_count_ = 1;
#line 550 "../src/gnome-chess.vala"
	_data4_->self = g_object_ref (self);
#line 550 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup (move);
#line 550 "../src/gnome-chess.vala"
	_g_free0 (_data4_->move);
#line 550 "../src/gnome-chess.vala"
	_data4_->move = _tmp0_;
#line 552 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 552 "../src/gnome-chess.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 552 "../src/gnome-chess.vala"
	_data4_->original_game = _tmp2_;
#line 553 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->game;
#line 553 "../src/gnome-chess.vala"
	_tmp4_ = chess_game_get_current_state (_tmp3_);
#line 553 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 553 "../src/gnome-chess.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 553 "../src/gnome-chess.vala"
	_data4_->original_state = _tmp6_;
#line 559 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->game;
#line 559 "../src/gnome-chess.vala"
	if (!_tmp7_->is_started) {
#line 560 "../src/gnome-chess.vala"
		block4_data_unref (_data4_);
#line 560 "../src/gnome-chess.vala"
		_data4_ = NULL;
#line 560 "../src/gnome-chess.vala"
		return;
#line 4311 "gnome-chess.c"
	}
#line 562 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 562 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_is_paused (_tmp8_);
#line 562 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 562 "../src/gnome-chess.vala"
	if (!_tmp10_) {
#line 564 "../src/gnome-chess.vala"
		chess_application_do_engine_move (self, _data4_->move);
#line 4323 "gnome-chess.c"
	} else {
#line 568 "../src/gnome-chess.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, ____lambda32__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 4327 "gnome-chess.c"
	}
#line 550 "../src/gnome-chess.vala"
	block4_data_unref (_data4_);
#line 550 "../src/gnome-chess.vala"
	_data4_ = NULL;
#line 4333 "gnome-chess.c"
}

static void
chess_application_engine_resigned_cb (ChessApplication* self,
                                      ChessEngine* engine)
{
	ChessPlayer* _tmp0_;
#line 590 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 590 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 592 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent;
#line 592 "../src/gnome-chess.vala"
	chess_player_resign (_tmp0_);
#line 4349 "gnome-chess.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 595 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 595 "../src/gnome-chess.vala"
	return _data5_;
#line 4359 "gnome-chess.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 595 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4369 "gnome-chess.c"
		ChessApplication* self;
#line 595 "../src/gnome-chess.vala"
		self = _data5_->self;
#line 595 "../src/gnome-chess.vala"
		_g_object_unref0 (_data5_->original_game);
#line 595 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 595 "../src/gnome-chess.vala"
		g_slice_free (Block5Data, _data5_);
#line 4379 "gnome-chess.c"
	}
}

static gboolean
__lambda33_ (Block5Data* _data5_)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	gboolean result;
#line 610 "../src/gnome-chess.vala"
	self = _data5_->self;
#line 611 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 611 "../src/gnome-chess.vala"
	if (_tmp1_ == _data5_->original_game) {
#line 4396 "gnome-chess.c"
		ChessGame* _tmp2_;
#line 611 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game;
#line 611 "../src/gnome-chess.vala"
		_tmp0_ = _tmp2_->is_started;
#line 4402 "gnome-chess.c"
	} else {
#line 611 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 4406 "gnome-chess.c"
	}
#line 611 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 4410 "gnome-chess.c"
		ChessGame* _tmp3_;
#line 612 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 612 "../src/gnome-chess.vala"
		chess_game_stop (_tmp3_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4416 "gnome-chess.c"
	}
#line 613 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 613 "../src/gnome-chess.vala"
	return result;
#line 4422 "gnome-chess.c"
}

static gboolean
___lambda33__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda33_ (self);
#line 610 "../src/gnome-chess.vala"
	return result;
#line 4432 "gnome-chess.c"
}

static void
chess_application_engine_stopped_unexpectedly_cb (ChessApplication* self,
                                                  ChessEngine* engine)
{
	Block5Data* _data5_;
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
#line 595 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 595 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 595 "../src/gnome-chess.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 595 "../src/gnome-chess.vala"
	_data5_->_ref_count_ = 1;
#line 595 "../src/gnome-chess.vala"
	_data5_->self = g_object_ref (self);
#line 609 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 609 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 609 "../src/gnome-chess.vala"
	_data5_->original_game = _tmp1_;
#line 610 "../src/gnome-chess.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ___lambda33__gsource_func, block5_data_ref (_data5_), block5_data_unref);
#line 595 "../src/gnome-chess.vala"
	block5_data_unref (_data5_);
#line 595 "../src/gnome-chess.vala"
	_data5_ = NULL;
#line 4464 "gnome-chess.c"
}

static void
chess_application_engine_error_cb (ChessApplication* self,
                                   ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 617 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 617 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 619 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 619 "../src/gnome-chess.vala"
	chess_game_stop (_tmp0_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4480 "gnome-chess.c"
}

static void
chess_application_engine_claim_draw_cb (ChessApplication* self,
                                        ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 622 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 624 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 624 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_tmp0_)) {
#line 4496 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 625 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent;
#line 625 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp1_);
#line 4502 "gnome-chess.c"
	} else {
		ChessGame* _tmp2_;
		ChessState* _tmp3_;
		ChessState* _tmp4_;
		ChessGame* _tmp5_;
		ChessState* _tmp6_;
		ChessState* _tmp7_;
		ChessPlayer* _tmp8_;
#line 626 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game;
#line 626 "../src/gnome-chess.vala"
		_tmp3_ = chess_game_get_current_state (_tmp2_);
#line 626 "../src/gnome-chess.vala"
		_tmp4_ = _tmp3_;
#line 626 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game;
#line 626 "../src/gnome-chess.vala"
		_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 626 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 626 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_->current_player;
#line 626 "../src/gnome-chess.vala"
		if (!chess_state_can_move (_tmp4_, _tmp8_)) {
#line 4527 "gnome-chess.c"
			ChessGame* _tmp9_;
#line 627 "../src/gnome-chess.vala"
			_tmp9_ = self->priv->game;
#line 627 "../src/gnome-chess.vala"
			chess_game_stop (_tmp9_, CHESS_RESULT_DRAW, CHESS_RULE_STALEMATE);
#line 4533 "gnome-chess.c"
		} else {
			ChessGame* _tmp10_;
#line 629 "../src/gnome-chess.vala"
			_tmp10_ = self->priv->game;
#line 629 "../src/gnome-chess.vala"
			chess_game_stop (_tmp10_, CHESS_RESULT_BUG, CHESS_RULE_BUG);
#line 4540 "gnome-chess.c"
		}
	}
}

static void
chess_application_engine_offer_draw_cb (ChessApplication* self,
                                        ChessEngine* engine)
{
	ChessGame* _tmp0_;
#line 632 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 632 "../src/gnome-chess.vala"
	g_return_if_fail (engine != NULL);
#line 634 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 634 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_tmp0_)) {
#line 4558 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 635 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent;
#line 635 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp1_);
#line 4564 "gnome-chess.c"
	}
}

static void
chess_application_game_turn_cb (ChessApplication* self,
                                ChessGame* game,
                                ChessPlayer* player)
{
	ChessClock* _tmp0_;
	ChessClock* _tmp1_;
#line 646 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 646 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 646 "../src/gnome-chess.vala"
	g_return_if_fail (player != NULL);
#line 661 "../src/gnome-chess.vala"
	if (!game->is_started) {
#line 662 "../src/gnome-chess.vala"
		return;
#line 4585 "gnome-chess.c"
	}
#line 664 "../src/gnome-chess.vala"
	_tmp0_ = chess_game_get_clock (game);
#line 664 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 664 "../src/gnome-chess.vala"
	if (_tmp1_ != NULL) {
#line 665 "../src/gnome-chess.vala"
		chess_application_enable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 4595 "gnome-chess.c"
	}
}

static gboolean
___lambda29_ (ChessApplication* self)
{
	ChessEngine* _tmp0_;
	gboolean result;
#line 683 "../src/gnome-chess.vala"
	self->priv->engine_timeout_source = (guint) 0;
#line 684 "../src/gnome-chess.vala"
	g_warning ("gnome-chess.vala:684: Engine did not move for 30 seconds! Game over.");
#line 685 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 685 "../src/gnome-chess.vala"
	chess_application_engine_error_cb (self, _tmp0_);
#line 686 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 686 "../src/gnome-chess.vala"
	return result;
#line 4616 "gnome-chess.c"
}

static gboolean
____lambda29__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda29_ ((ChessApplication*) self);
#line 682 "../src/gnome-chess.vala"
	return result;
#line 4626 "gnome-chess.c"
}

static void
chess_application_update_engine_timeout (ChessApplication* self)
{
	ChessGame* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	PGNGame* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 668 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 670 "../src/gnome-chess.vala"
	if (self->priv->engine_timeout_source != ((guint) 0)) {
#line 672 "../src/gnome-chess.vala"
		g_source_remove (self->priv->engine_timeout_source);
#line 673 "../src/gnome-chess.vala"
		self->priv->engine_timeout_source = (guint) 0;
#line 4646 "gnome-chess.c"
	}
#line 676 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 676 "../src/gnome-chess.vala"
	if (!_tmp0_->is_started) {
#line 677 "../src/gnome-chess.vala"
		return;
#line 4654 "gnome-chess.c"
	}
#line 679 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->pgn_game;
#line 679 "../src/gnome-chess.vala"
	_tmp4_ = pgn_game_get_white_ai (_tmp3_);
#line 679 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 679 "../src/gnome-chess.vala"
	if (_tmp5_ != NULL) {
#line 4664 "gnome-chess.c"
		ChessGame* _tmp6_;
		ChessPlayer* _tmp7_;
		ChessPlayer* _tmp8_;
#line 679 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->game;
#line 679 "../src/gnome-chess.vala"
		_tmp7_ = chess_game_get_current_player (_tmp6_);
#line 679 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 679 "../src/gnome-chess.vala"
		_tmp2_ = _tmp8_->color == COLOR_WHITE;
#line 4676 "gnome-chess.c"
	} else {
#line 679 "../src/gnome-chess.vala"
		_tmp2_ = FALSE;
#line 4680 "gnome-chess.c"
	}
#line 679 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 679 "../src/gnome-chess.vala"
		_tmp1_ = TRUE;
#line 4686 "gnome-chess.c"
	} else {
		gboolean _tmp9_ = FALSE;
		PGNGame* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 680 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->pgn_game;
#line 680 "../src/gnome-chess.vala"
		_tmp11_ = pgn_game_get_black_ai (_tmp10_);
#line 680 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 680 "../src/gnome-chess.vala"
		if (_tmp12_ != NULL) {
#line 4700 "gnome-chess.c"
			ChessGame* _tmp13_;
			ChessPlayer* _tmp14_;
			ChessPlayer* _tmp15_;
#line 680 "../src/gnome-chess.vala"
			_tmp13_ = self->priv->game;
#line 680 "../src/gnome-chess.vala"
			_tmp14_ = chess_game_get_current_player (_tmp13_);
#line 680 "../src/gnome-chess.vala"
			_tmp15_ = _tmp14_;
#line 680 "../src/gnome-chess.vala"
			_tmp9_ = _tmp15_->color == COLOR_BLACK;
#line 4712 "gnome-chess.c"
		} else {
#line 680 "../src/gnome-chess.vala"
			_tmp9_ = FALSE;
#line 4716 "gnome-chess.c"
		}
#line 680 "../src/gnome-chess.vala"
		_tmp1_ = _tmp9_;
#line 4720 "gnome-chess.c"
	}
#line 679 "../src/gnome-chess.vala"
	if (_tmp1_) {
#line 682 "../src/gnome-chess.vala"
		self->priv->engine_timeout_source = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 30, ____lambda29__gsource_func, g_object_ref (self), g_object_unref);
#line 4726 "gnome-chess.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 691 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 691 "../src/gnome-chess.vala"
	return _data6_;
#line 4737 "gnome-chess.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 691 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 4747 "gnome-chess.c"
		ChessApplication* self;
#line 691 "../src/gnome-chess.vala"
		self = _data6_->self;
#line 691 "../src/gnome-chess.vala"
		_g_object_unref0 (_data6_->game);
#line 691 "../src/gnome-chess.vala"
		_g_object_unref0 (_data6_->move);
#line 691 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 691 "../src/gnome-chess.vala"
		g_slice_free (Block6Data, _data6_);
#line 4759 "gnome-chess.c"
	}
}

static gboolean
__lambda27_ (Block6Data* _data6_)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
	ChessEngine* _tmp1_;
	gboolean result;
#line 719 "../src/gnome-chess.vala"
	self = _data6_->self;
#line 720 "../src/gnome-chess.vala"
	if (chess_game_can_claim_draw (_data6_->game)) {
#line 720 "../src/gnome-chess.vala"
		_tmp0_ = _data6_->started;
#line 4776 "gnome-chess.c"
	} else {
#line 720 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 4780 "gnome-chess.c"
	}
#line 720 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 721 "../src/gnome-chess.vala"
		chess_application_present_claim_draw_dialog (self);
#line 4786 "gnome-chess.c"
	}
#line 723 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->opponent_engine;
#line 723 "../src/gnome-chess.vala"
	if (_tmp1_ != NULL) {
#line 4792 "gnome-chess.c"
		ChessEngine* _tmp2_;
		gboolean _tmp3_ = FALSE;
		ChessPiece* _tmp4_;
		Color _tmp5_;
		Color _tmp6_;
		ChessPlayer* _tmp7_;
#line 725 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->opponent_engine;
#line 725 "../src/gnome-chess.vala"
		chess_engine_report_move (_tmp2_, _data6_->move);
#line 727 "../src/gnome-chess.vala"
		_tmp4_ = _data6_->move->piece;
#line 727 "../src/gnome-chess.vala"
		_tmp5_ = chess_piece_get_color (_tmp4_);
#line 727 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 727 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->opponent;
#line 727 "../src/gnome-chess.vala"
		if (_tmp6_ != _tmp7_->color) {
#line 727 "../src/gnome-chess.vala"
			_tmp3_ = _data6_->started;
#line 4815 "gnome-chess.c"
		} else {
#line 727 "../src/gnome-chess.vala"
			_tmp3_ = FALSE;
#line 4819 "gnome-chess.c"
		}
#line 727 "../src/gnome-chess.vala"
		if (_tmp3_) {
#line 4823 "gnome-chess.c"
			ChessEngine* _tmp8_;
#line 728 "../src/gnome-chess.vala"
			_tmp8_ = self->priv->opponent_engine;
#line 728 "../src/gnome-chess.vala"
			chess_engine_move (_tmp8_);
#line 4829 "gnome-chess.c"
		}
	}
#line 731 "../src/gnome-chess.vala"
	result = G_SOURCE_REMOVE;
#line 731 "../src/gnome-chess.vala"
	return result;
#line 4836 "gnome-chess.c"
}

static gboolean
___lambda27__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda27_ (self);
#line 719 "../src/gnome-chess.vala"
	return result;
#line 4846 "gnome-chess.c"
}

static void
chess_application_game_move_cb (ChessApplication* self,
                                ChessGame* game,
                                ChessMove* move)
{
	Block6Data* _data6_;
	ChessGame* _tmp0_;
	ChessMove* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	PGNGame* _tmp6_;
	GList* _tmp7_;
	ChessWindow* _tmp10_;
	ChessWindow* _tmp11_;
	ChessWindow* _tmp12_;
	ChessView* _tmp13_;
	ChessView* _tmp14_;
	gboolean _tmp15_ = FALSE;
#line 691 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 691 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 691 "../src/gnome-chess.vala"
	g_return_if_fail (move != NULL);
#line 691 "../src/gnome-chess.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 691 "../src/gnome-chess.vala"
	_data6_->_ref_count_ = 1;
#line 691 "../src/gnome-chess.vala"
	_data6_->self = g_object_ref (self);
#line 691 "../src/gnome-chess.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 691 "../src/gnome-chess.vala"
	_g_object_unref0 (_data6_->game);
#line 691 "../src/gnome-chess.vala"
	_data6_->game = _tmp0_;
#line 691 "../src/gnome-chess.vala"
	_tmp1_ = _g_object_ref0 (move);
#line 691 "../src/gnome-chess.vala"
	_g_object_unref0 (_data6_->move);
#line 691 "../src/gnome-chess.vala"
	_data6_->move = _tmp1_;
#line 696 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = TRUE;
#line 699 "../src/gnome-chess.vala"
	if (_data6_->move->number == 1) {
#line 4895 "gnome-chess.c"
		ChessPlayer* _tmp4_;
#line 699 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->opponent;
#line 699 "../src/gnome-chess.vala"
		_tmp3_ = _tmp4_ != NULL;
#line 4901 "gnome-chess.c"
	} else {
#line 699 "../src/gnome-chess.vala"
		_tmp3_ = FALSE;
#line 4905 "gnome-chess.c"
	}
#line 699 "../src/gnome-chess.vala"
	if (_tmp3_) {
#line 4909 "gnome-chess.c"
		ChessPlayer* _tmp5_;
#line 699 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->opponent;
#line 699 "../src/gnome-chess.vala"
		_tmp2_ = _tmp5_->color == COLOR_WHITE;
#line 4915 "gnome-chess.c"
	} else {
#line 699 "../src/gnome-chess.vala"
		_tmp2_ = FALSE;
#line 4919 "gnome-chess.c"
	}
#line 699 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 700 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 4925 "gnome-chess.c"
	}
#line 702 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 702 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_->moves;
#line 702 "../src/gnome-chess.vala"
	if (((guint) _data6_->move->number) > g_list_length (_tmp7_)) {
#line 4933 "gnome-chess.c"
		PGNGame* _tmp8_;
		gchar* _tmp9_;
#line 703 "../src/gnome-chess.vala"
		_tmp8_ = self->priv->pgn_game;
#line 703 "../src/gnome-chess.vala"
		_tmp9_ = chess_move_get_san (_data6_->move);
#line 703 "../src/gnome-chess.vala"
		_tmp8_->moves = g_list_append (_tmp8_->moves, _tmp9_);
#line 4942 "gnome-chess.c"
	}
#line 705 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->_window;
#line 705 "../src/gnome-chess.vala"
	chess_window_move (_tmp10_, _data6_->move);
#line 707 "../src/gnome-chess.vala"
	chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 708 "../src/gnome-chess.vala"
	chess_application_enable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 709 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 710 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->_window;
#line 710 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp11_);
#line 711 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 711 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp12_, NULL, NULL);
#line 713 "../src/gnome-chess.vala"
	_tmp13_ = chess_application_get_view (self);
#line 713 "../src/gnome-chess.vala"
	_tmp14_ = _tmp13_;
#line 713 "../src/gnome-chess.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp14_);
#line 718 "../src/gnome-chess.vala"
	if (!self->priv->starting) {
#line 718 "../src/gnome-chess.vala"
		_tmp15_ = _data6_->game->is_started;
#line 4972 "gnome-chess.c"
	} else {
#line 718 "../src/gnome-chess.vala"
		_tmp15_ = FALSE;
#line 4976 "gnome-chess.c"
	}
#line 718 "../src/gnome-chess.vala"
	_data6_->started = _tmp15_;
#line 719 "../src/gnome-chess.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda27__gsource_func, block6_data_ref (_data6_), block6_data_unref);
#line 734 "../src/gnome-chess.vala"
	if (_data6_->started) {
#line 735 "../src/gnome-chess.vala"
		chess_application_update_engine_timeout (self);
#line 4986 "gnome-chess.c"
	}
#line 691 "../src/gnome-chess.vala"
	block6_data_unref (_data6_);
#line 691 "../src/gnome-chess.vala"
	_data6_ = NULL;
#line 4992 "gnome-chess.c"
}

static void
chess_application_game_undo_cb (ChessApplication* self,
                                ChessGame* game)
{
	ChessEngine* _tmp0_;
	PGNGame* _tmp2_;
	PGNGame* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	PGNGame* _tmp6_;
	const gchar* _tmp7_;
	ChessWindow* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	ChessWindow* _tmp11_;
	ChessWindow* _tmp12_;
#line 738 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 738 "../src/gnome-chess.vala"
	g_return_if_fail (game != NULL);
#line 741 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->opponent_engine;
#line 741 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 5019 "gnome-chess.c"
		ChessEngine* _tmp1_;
#line 742 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->opponent_engine;
#line 742 "../src/gnome-chess.vala"
		chess_engine_undo (_tmp1_);
#line 5025 "gnome-chess.c"
	}
#line 745 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->pgn_game;
#line 745 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->pgn_game;
#line 745 "../src/gnome-chess.vala"
	_tmp4_ = _tmp3_->moves;
#line 745 "../src/gnome-chess.vala"
	_tmp5_ = g_list_last (_tmp4_);
#line 745 "../src/gnome-chess.vala"
	_tmp2_->moves = g_list_remove_link (_tmp2_->moves, _tmp5_);
#line 746 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 746 "../src/gnome-chess.vala"
	_tmp7_ = pgn_game_RESULT_IN_PROGRESS;
#line 746 "../src/gnome-chess.vala"
	pgn_game_set_result (_tmp6_, _tmp7_);
#line 748 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 748 "../src/gnome-chess.vala"
	chess_window_undo (_tmp8_);
#line 750 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (game);
#line 750 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 750 "../src/gnome-chess.vala"
	if (_tmp10_ > ((guint) 0)) {
#line 752 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = TRUE;
#line 753 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_ACTION_NAME);
#line 754 "../src/gnome-chess.vala"
		chess_application_enable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 5059 "gnome-chess.c"
	} else {
#line 758 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 759 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 760 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 5067 "gnome-chess.c"
	}
#line 763 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 764 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->_window;
#line 764 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp11_);
#line 765 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->_window;
#line 765 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp12_, NULL, NULL);
#line 5079 "gnome-chess.c"
}

static void
chess_application_update_action_status (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gboolean can_resign = FALSE;
	gboolean _tmp7_ = FALSE;
	ChessGame* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	gboolean can_undo = FALSE;
	gboolean _tmp14_ = FALSE;
	ChessPlayer* _tmp15_;
#line 768 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 770 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 770 "../src/gnome-chess.vala"
	_tmp2_ = chess_game_get_n_moves (_tmp1_);
#line 770 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 770 "../src/gnome-chess.vala"
	if (_tmp3_ > ((guint) 0)) {
#line 5107 "gnome-chess.c"
		ChessGame* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 770 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 770 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_is_paused (_tmp4_);
#line 770 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 770 "../src/gnome-chess.vala"
		_tmp0_ = !_tmp6_;
#line 5119 "gnome-chess.c"
	} else {
#line 770 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5123 "gnome-chess.c"
	}
#line 770 "../src/gnome-chess.vala"
	can_resign = _tmp0_;
#line 771 "../src/gnome-chess.vala"
	if (can_resign) {
#line 772 "../src/gnome-chess.vala"
		chess_application_enable_action (self, RESIGN_ACTION_NAME);
#line 5131 "gnome-chess.c"
	} else {
#line 774 "../src/gnome-chess.vala"
		chess_application_disable_action (self, RESIGN_ACTION_NAME);
#line 5135 "gnome-chess.c"
	}
#line 777 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 777 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (_tmp8_);
#line 777 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 777 "../src/gnome-chess.vala"
	if (_tmp10_ > ((guint) 0)) {
#line 5145 "gnome-chess.c"
		ChessGame* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
#line 777 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->game;
#line 777 "../src/gnome-chess.vala"
		_tmp12_ = chess_game_get_is_paused (_tmp11_);
#line 777 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 777 "../src/gnome-chess.vala"
		_tmp7_ = !_tmp13_;
#line 5157 "gnome-chess.c"
	} else {
#line 777 "../src/gnome-chess.vala"
		_tmp7_ = FALSE;
#line 5161 "gnome-chess.c"
	}
#line 777 "../src/gnome-chess.vala"
	can_undo = _tmp7_;
#line 778 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->opponent;
#line 778 "../src/gnome-chess.vala"
	if (_tmp15_ != NULL) {
#line 5169 "gnome-chess.c"
		ChessPlayer* _tmp16_;
#line 778 "../src/gnome-chess.vala"
		_tmp16_ = self->priv->opponent;
#line 778 "../src/gnome-chess.vala"
		_tmp14_ = _tmp16_->color == COLOR_WHITE;
#line 5175 "gnome-chess.c"
	} else {
#line 778 "../src/gnome-chess.vala"
		_tmp14_ = FALSE;
#line 5179 "gnome-chess.c"
	}
#line 778 "../src/gnome-chess.vala"
	if (_tmp14_) {
#line 5183 "gnome-chess.c"
		gboolean _tmp17_ = FALSE;
		ChessGame* _tmp18_;
		guint _tmp19_;
		guint _tmp20_;
#line 779 "../src/gnome-chess.vala"
		_tmp18_ = self->priv->game;
#line 779 "../src/gnome-chess.vala"
		_tmp19_ = chess_game_get_n_moves (_tmp18_);
#line 779 "../src/gnome-chess.vala"
		_tmp20_ = _tmp19_;
#line 779 "../src/gnome-chess.vala"
		if (_tmp20_ > ((guint) 1)) {
#line 5196 "gnome-chess.c"
			ChessGame* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
#line 779 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game;
#line 779 "../src/gnome-chess.vala"
			_tmp22_ = chess_game_get_is_paused (_tmp21_);
#line 779 "../src/gnome-chess.vala"
			_tmp23_ = _tmp22_;
#line 779 "../src/gnome-chess.vala"
			_tmp17_ = !_tmp23_;
#line 5208 "gnome-chess.c"
		} else {
#line 779 "../src/gnome-chess.vala"
			_tmp17_ = FALSE;
#line 5212 "gnome-chess.c"
		}
#line 779 "../src/gnome-chess.vala"
		can_undo = _tmp17_;
#line 5216 "gnome-chess.c"
	}
#line 781 "../src/gnome-chess.vala"
	if (can_undo) {
#line 782 "../src/gnome-chess.vala"
		chess_application_enable_action (self, UNDO_MOVE_ACTION_NAME);
#line 5222 "gnome-chess.c"
	} else {
#line 784 "../src/gnome-chess.vala"
		chess_application_disable_action (self, UNDO_MOVE_ACTION_NAME);
#line 5226 "gnome-chess.c"
	}
}

gchar*
chess_application_compute_current_title (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessPlayer* _tmp2_;
	gchar* result;
#line 787 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 789 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->human_player;
#line 789 "../src/gnome-chess.vala"
	if (_tmp2_ != NULL) {
#line 5243 "gnome-chess.c"
		ChessPlayer* _tmp3_;
		ChessGame* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
#line 790 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->human_player;
#line 790 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 790 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_current_player (_tmp4_);
#line 790 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 790 "../src/gnome-chess.vala"
		_tmp1_ = _tmp3_->color == _tmp6_->color;
#line 5258 "gnome-chess.c"
	} else {
#line 789 "../src/gnome-chess.vala"
		_tmp1_ = FALSE;
#line 5262 "gnome-chess.c"
	}
#line 789 "../src/gnome-chess.vala"
	if (_tmp1_) {
#line 5266 "gnome-chess.c"
		ChessGame* _tmp7_;
		ChessState* _tmp8_;
		ChessState* _tmp9_;
		ChessGame* _tmp10_;
		ChessPlayer* _tmp11_;
		ChessPlayer* _tmp12_;
#line 791 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->game;
#line 791 "../src/gnome-chess.vala"
		_tmp8_ = chess_game_get_current_state (_tmp7_);
#line 791 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_;
#line 791 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->game;
#line 791 "../src/gnome-chess.vala"
		_tmp11_ = chess_game_get_current_player (_tmp10_);
#line 791 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 791 "../src/gnome-chess.vala"
		_tmp0_ = chess_state_is_in_check (_tmp9_, _tmp12_);
#line 5287 "gnome-chess.c"
	} else {
#line 789 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5291 "gnome-chess.c"
	}
#line 789 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 5295 "gnome-chess.c"
		ChessGame* _tmp13_;
		ChessPlayer* _tmp14_;
		ChessPlayer* _tmp15_;
#line 793 "../src/gnome-chess.vala"
		_tmp13_ = self->priv->game;
#line 793 "../src/gnome-chess.vala"
		_tmp14_ = chess_game_get_current_player (_tmp13_);
#line 793 "../src/gnome-chess.vala"
		_tmp15_ = _tmp14_;
#line 793 "../src/gnome-chess.vala"
		if (_tmp15_->color == COLOR_WHITE) {
#line 5307 "gnome-chess.c"
			gchar* _tmp16_;
#line 795 "../src/gnome-chess.vala"
			_tmp16_ = g_strdup (_ ("White is in Check"));
#line 795 "../src/gnome-chess.vala"
			result = _tmp16_;
#line 795 "../src/gnome-chess.vala"
			return result;
#line 5315 "gnome-chess.c"
		} else {
			gchar* _tmp17_;
#line 798 "../src/gnome-chess.vala"
			_tmp17_ = g_strdup (_ ("Black is in Check"));
#line 798 "../src/gnome-chess.vala"
			result = _tmp17_;
#line 798 "../src/gnome-chess.vala"
			return result;
#line 5324 "gnome-chess.c"
		}
	} else {
		ChessGame* _tmp18_;
		ChessPlayer* _tmp19_;
		ChessPlayer* _tmp20_;
#line 800 "../src/gnome-chess.vala"
		_tmp18_ = self->priv->game;
#line 800 "../src/gnome-chess.vala"
		_tmp19_ = chess_game_get_current_player (_tmp18_);
#line 800 "../src/gnome-chess.vala"
		_tmp20_ = _tmp19_;
#line 800 "../src/gnome-chess.vala"
		if (_tmp20_->color == COLOR_WHITE) {
#line 5338 "gnome-chess.c"
			gboolean _tmp21_ = FALSE;
			ChessPlayer* _tmp22_;
#line 802 "../src/gnome-chess.vala"
			_tmp22_ = self->priv->human_player;
#line 802 "../src/gnome-chess.vala"
			if (_tmp22_ == NULL) {
#line 802 "../src/gnome-chess.vala"
				_tmp21_ = TRUE;
#line 5347 "gnome-chess.c"
			} else {
				ChessPlayer* _tmp23_;
#line 802 "../src/gnome-chess.vala"
				_tmp23_ = self->priv->human_player;
#line 802 "../src/gnome-chess.vala"
				_tmp21_ = _tmp23_->color == COLOR_WHITE;
#line 5354 "gnome-chess.c"
			}
#line 802 "../src/gnome-chess.vala"
			if (_tmp21_) {
#line 5358 "gnome-chess.c"
				gchar* _tmp24_;
#line 804 "../src/gnome-chess.vala"
				_tmp24_ = g_strdup (_ ("White to Move"));
#line 804 "../src/gnome-chess.vala"
				result = _tmp24_;
#line 804 "../src/gnome-chess.vala"
				return result;
#line 5366 "gnome-chess.c"
			} else {
				gchar* _tmp25_;
#line 807 "../src/gnome-chess.vala"
				_tmp25_ = g_strdup (_ ("White is Thinking…"));
#line 807 "../src/gnome-chess.vala"
				result = _tmp25_;
#line 807 "../src/gnome-chess.vala"
				return result;
#line 5375 "gnome-chess.c"
			}
		} else {
			gboolean _tmp26_ = FALSE;
			ChessPlayer* _tmp27_;
#line 811 "../src/gnome-chess.vala"
			_tmp27_ = self->priv->human_player;
#line 811 "../src/gnome-chess.vala"
			if (_tmp27_ == NULL) {
#line 811 "../src/gnome-chess.vala"
				_tmp26_ = TRUE;
#line 5386 "gnome-chess.c"
			} else {
				ChessPlayer* _tmp28_;
#line 811 "../src/gnome-chess.vala"
				_tmp28_ = self->priv->human_player;
#line 811 "../src/gnome-chess.vala"
				_tmp26_ = _tmp28_->color == COLOR_BLACK;
#line 5393 "gnome-chess.c"
			}
#line 811 "../src/gnome-chess.vala"
			if (_tmp26_) {
#line 5397 "gnome-chess.c"
				gchar* _tmp29_;
#line 813 "../src/gnome-chess.vala"
				_tmp29_ = g_strdup (_ ("Black to Move"));
#line 813 "../src/gnome-chess.vala"
				result = _tmp29_;
#line 813 "../src/gnome-chess.vala"
				return result;
#line 5405 "gnome-chess.c"
			} else {
				gchar* _tmp30_;
#line 816 "../src/gnome-chess.vala"
				_tmp30_ = g_strdup (_ ("Black is Thinking…"));
#line 816 "../src/gnome-chess.vala"
				result = _tmp30_;
#line 816 "../src/gnome-chess.vala"
				return result;
#line 5414 "gnome-chess.c"
			}
		}
	}
}

gchar*
chess_application_compute_status_info (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessState* _tmp2_;
	ChessState* _tmp3_;
	ChessMove* _tmp4_;
	gchar* result;
#line 820 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 822 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 822 "../src/gnome-chess.vala"
	_tmp2_ = chess_game_get_current_state (_tmp1_);
#line 822 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 822 "../src/gnome-chess.vala"
	_tmp4_ = _tmp3_->last_move;
#line 822 "../src/gnome-chess.vala"
	if (_tmp4_ != NULL) {
#line 5441 "gnome-chess.c"
		ChessGame* _tmp5_;
		ChessState* _tmp6_;
		ChessState* _tmp7_;
		ChessMove* _tmp8_;
#line 823 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->game;
#line 823 "../src/gnome-chess.vala"
		_tmp6_ = chess_game_get_current_state (_tmp5_);
#line 823 "../src/gnome-chess.vala"
		_tmp7_ = _tmp6_;
#line 823 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_->last_move;
#line 823 "../src/gnome-chess.vala"
		_tmp0_ = _tmp8_->en_passant;
#line 5456 "gnome-chess.c"
	} else {
#line 822 "../src/gnome-chess.vala"
		_tmp0_ = FALSE;
#line 5460 "gnome-chess.c"
	}
#line 822 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 5464 "gnome-chess.c"
		ChessGame* _tmp9_;
		ChessPlayer* _tmp10_;
		ChessPlayer* _tmp11_;
#line 825 "../src/gnome-chess.vala"
		_tmp9_ = self->priv->game;
#line 825 "../src/gnome-chess.vala"
		_tmp10_ = chess_game_get_current_player (_tmp9_);
#line 825 "../src/gnome-chess.vala"
		_tmp11_ = _tmp10_;
#line 825 "../src/gnome-chess.vala"
		if (_tmp11_->color == COLOR_WHITE) {
#line 5476 "gnome-chess.c"
			gchar* _tmp12_;
#line 827 "../src/gnome-chess.vala"
			_tmp12_ = g_strdup (_ ("Black captured White's pawn <span font_style='italic'>en passant</span" \
">."));
#line 827 "../src/gnome-chess.vala"
			result = _tmp12_;
#line 827 "../src/gnome-chess.vala"
			return result;
#line 5484 "gnome-chess.c"
		} else {
			gchar* _tmp13_;
#line 830 "../src/gnome-chess.vala"
			_tmp13_ = g_strdup (_ ("White captured Black's pawn <span font_style='italic'>en passant</span" \
">."));
#line 830 "../src/gnome-chess.vala"
			result = _tmp13_;
#line 830 "../src/gnome-chess.vala"
			return result;
#line 5493 "gnome-chess.c"
		}
	}
#line 833 "../src/gnome-chess.vala"
	result = NULL;
#line 833 "../src/gnome-chess.vala"
	return result;
#line 5500 "gnome-chess.c"
}

static void
chess_application_game_end_cb (ChessApplication* self)
{
	gchar* what = NULL;
	gchar* _tmp0_;
	ChessGame* _tmp1_;
	gchar* why = NULL;
	gchar* _tmp12_;
	ChessGame* _tmp13_;
	ChessWindow* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	ChessWindow* _tmp44_;
#line 836 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 838 "../src/gnome-chess.vala"
	chess_application_disable_action (self, RESIGN_ACTION_NAME);
#line 839 "../src/gnome-chess.vala"
	chess_application_disable_action (self, PAUSE_RESUME_ACTION_NAME);
#line 841 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = FALSE;
#line 843 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup ("");
#line 843 "../src/gnome-chess.vala"
	what = _tmp0_;
#line 844 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 844 "../src/gnome-chess.vala"
	switch (_tmp1_->result) {
#line 844 "../src/gnome-chess.vala"
		case CHESS_RESULT_WHITE_WON:
#line 5534 "gnome-chess.c"
		{
			gchar* _tmp2_;
			PGNGame* _tmp3_;
			const gchar* _tmp4_;
#line 848 "../src/gnome-chess.vala"
			_tmp2_ = g_strdup (_ ("White Wins"));
#line 848 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 848 "../src/gnome-chess.vala"
			what = _tmp2_;
#line 849 "../src/gnome-chess.vala"
			_tmp3_ = self->priv->pgn_game;
#line 849 "../src/gnome-chess.vala"
			_tmp4_ = pgn_game_RESULT_WHITE;
#line 849 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp3_, _tmp4_);
#line 850 "../src/gnome-chess.vala"
			break;
#line 5553 "gnome-chess.c"
		}
#line 844 "../src/gnome-chess.vala"
		case CHESS_RESULT_BLACK_WON:
#line 5557 "gnome-chess.c"
		{
			gchar* _tmp5_;
			PGNGame* _tmp6_;
			const gchar* _tmp7_;
#line 853 "../src/gnome-chess.vala"
			_tmp5_ = g_strdup (_ ("Black Wins"));
#line 853 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 853 "../src/gnome-chess.vala"
			what = _tmp5_;
#line 854 "../src/gnome-chess.vala"
			_tmp6_ = self->priv->pgn_game;
#line 854 "../src/gnome-chess.vala"
			_tmp7_ = pgn_game_RESULT_BLACK;
#line 854 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp6_, _tmp7_);
#line 855 "../src/gnome-chess.vala"
			break;
#line 5576 "gnome-chess.c"
		}
#line 844 "../src/gnome-chess.vala"
		case CHESS_RESULT_DRAW:
#line 5580 "gnome-chess.c"
		{
			gchar* _tmp8_;
			PGNGame* _tmp9_;
			const gchar* _tmp10_;
#line 858 "../src/gnome-chess.vala"
			_tmp8_ = g_strdup (_ ("Game is Drawn"));
#line 858 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 858 "../src/gnome-chess.vala"
			what = _tmp8_;
#line 859 "../src/gnome-chess.vala"
			_tmp9_ = self->priv->pgn_game;
#line 859 "../src/gnome-chess.vala"
			_tmp10_ = pgn_game_RESULT_DRAW;
#line 859 "../src/gnome-chess.vala"
			pgn_game_set_result (_tmp9_, _tmp10_);
#line 860 "../src/gnome-chess.vala"
			break;
#line 5599 "gnome-chess.c"
		}
#line 844 "../src/gnome-chess.vala"
		case CHESS_RESULT_BUG:
#line 5603 "gnome-chess.c"
		{
			gchar* _tmp11_;
#line 863 "../src/gnome-chess.vala"
			_tmp11_ = g_strdup (_ ("Oops!"));
#line 863 "../src/gnome-chess.vala"
			_g_free0 (what);
#line 863 "../src/gnome-chess.vala"
			what = _tmp11_;
#line 865 "../src/gnome-chess.vala"
			break;
#line 5614 "gnome-chess.c"
		}
		default:
		{
#line 867 "../src/gnome-chess.vala"
			break;
#line 5620 "gnome-chess.c"
		}
	}
#line 870 "../src/gnome-chess.vala"
	_tmp12_ = g_strdup ("");
#line 870 "../src/gnome-chess.vala"
	why = _tmp12_;
#line 871 "../src/gnome-chess.vala"
	_tmp13_ = self->priv->game;
#line 871 "../src/gnome-chess.vala"
	switch (_tmp13_->rule) {
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_CHECKMATE:
#line 5633 "gnome-chess.c"
		{
			ChessGame* _tmp14_;
#line 874 "../src/gnome-chess.vala"
			_tmp14_ = self->priv->game;
#line 874 "../src/gnome-chess.vala"
			if (_tmp14_->result == CHESS_RESULT_WHITE_WON) {
#line 5640 "gnome-chess.c"
				gchar* _tmp15_;
#line 876 "../src/gnome-chess.vala"
				_tmp15_ = g_strdup (_ ("Black is in check and cannot move."));
#line 876 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 876 "../src/gnome-chess.vala"
				why = _tmp15_;
#line 5648 "gnome-chess.c"
			} else {
				ChessGame* _tmp16_;
#line 877 "../src/gnome-chess.vala"
				_tmp16_ = self->priv->game;
#line 877 "../src/gnome-chess.vala"
				if (_tmp16_->result == CHESS_RESULT_BLACK_WON) {
#line 5655 "gnome-chess.c"
					gchar* _tmp17_;
#line 879 "../src/gnome-chess.vala"
					_tmp17_ = g_strdup (_ ("White is in check and cannot move."));
#line 879 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 879 "../src/gnome-chess.vala"
					why = _tmp17_;
#line 5663 "gnome-chess.c"
				} else {
#line 881 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5667 "gnome-chess.c"
				}
			}
#line 882 "../src/gnome-chess.vala"
			break;
#line 5672 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_STALEMATE:
#line 5676 "gnome-chess.c"
		{
			gchar* _tmp18_;
#line 885 "../src/gnome-chess.vala"
			_tmp18_ = g_strdup (_ ("Player cannot move."));
#line 885 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 885 "../src/gnome-chess.vala"
			why = _tmp18_;
#line 886 "../src/gnome-chess.vala"
			break;
#line 5687 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_FIFTY_MOVES:
#line 5691 "gnome-chess.c"
		{
			gchar* _tmp19_;
#line 889 "../src/gnome-chess.vala"
			_tmp19_ = g_strdup (_ ("No piece was taken or pawn moved in fifty moves."));
#line 889 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 889 "../src/gnome-chess.vala"
			why = _tmp19_;
#line 890 "../src/gnome-chess.vala"
			break;
#line 5702 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_SEVENTY_FIVE_MOVES:
#line 5706 "gnome-chess.c"
		{
			gchar* _tmp20_;
#line 893 "../src/gnome-chess.vala"
			_tmp20_ = g_strdup (_ ("No piece was taken or pawn moved in 75 moves."));
#line 893 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 893 "../src/gnome-chess.vala"
			why = _tmp20_;
#line 894 "../src/gnome-chess.vala"
			break;
#line 5717 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_TIMEOUT:
#line 5721 "gnome-chess.c"
		{
			ChessGame* _tmp21_;
#line 896 "../src/gnome-chess.vala"
			_tmp21_ = self->priv->game;
#line 896 "../src/gnome-chess.vala"
			if (_tmp21_->result == CHESS_RESULT_WHITE_WON) {
#line 5728 "gnome-chess.c"
				gchar* _tmp22_;
#line 898 "../src/gnome-chess.vala"
				_tmp22_ = g_strdup (_ ("Black has run out of time."));
#line 898 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 898 "../src/gnome-chess.vala"
				why = _tmp22_;
#line 5736 "gnome-chess.c"
			} else {
				ChessGame* _tmp23_;
#line 899 "../src/gnome-chess.vala"
				_tmp23_ = self->priv->game;
#line 899 "../src/gnome-chess.vala"
				if (_tmp23_->result == CHESS_RESULT_BLACK_WON) {
#line 5743 "gnome-chess.c"
					gchar* _tmp24_;
#line 901 "../src/gnome-chess.vala"
					_tmp24_ = g_strdup (_ ("White has run out of time."));
#line 901 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 901 "../src/gnome-chess.vala"
					why = _tmp24_;
#line 5751 "gnome-chess.c"
				} else {
#line 903 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5755 "gnome-chess.c"
				}
			}
#line 904 "../src/gnome-chess.vala"
			break;
#line 5760 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_THREE_FOLD_REPETITION:
#line 5764 "gnome-chess.c"
		{
			gchar* _tmp25_;
#line 907 "../src/gnome-chess.vala"
			_tmp25_ = g_strdup (_ ("The same board state has occurred three times."));
#line 907 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 907 "../src/gnome-chess.vala"
			why = _tmp25_;
#line 908 "../src/gnome-chess.vala"
			break;
#line 5775 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_FIVE_FOLD_REPETITION:
#line 5779 "gnome-chess.c"
		{
			gchar* _tmp26_;
#line 911 "../src/gnome-chess.vala"
			_tmp26_ = g_strdup (_ ("The same board state has occurred five times."));
#line 911 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 911 "../src/gnome-chess.vala"
			why = _tmp26_;
#line 912 "../src/gnome-chess.vala"
			break;
#line 5790 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_INSUFFICIENT_MATERIAL:
#line 5794 "gnome-chess.c"
		{
			gchar* _tmp27_;
#line 915 "../src/gnome-chess.vala"
			_tmp27_ = g_strdup (_ ("Neither player can checkmate."));
#line 915 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 915 "../src/gnome-chess.vala"
			why = _tmp27_;
#line 916 "../src/gnome-chess.vala"
			break;
#line 5805 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_RESIGN:
#line 5809 "gnome-chess.c"
		{
			ChessGame* _tmp28_;
#line 918 "../src/gnome-chess.vala"
			_tmp28_ = self->priv->game;
#line 918 "../src/gnome-chess.vala"
			if (_tmp28_->result == CHESS_RESULT_WHITE_WON) {
#line 5816 "gnome-chess.c"
				gchar* _tmp29_;
#line 920 "../src/gnome-chess.vala"
				_tmp29_ = g_strdup (_ ("Black has resigned."));
#line 920 "../src/gnome-chess.vala"
				_g_free0 (why);
#line 920 "../src/gnome-chess.vala"
				why = _tmp29_;
#line 5824 "gnome-chess.c"
			} else {
				ChessGame* _tmp30_;
#line 921 "../src/gnome-chess.vala"
				_tmp30_ = self->priv->game;
#line 921 "../src/gnome-chess.vala"
				if (_tmp30_->result == CHESS_RESULT_BLACK_WON) {
#line 5831 "gnome-chess.c"
					gchar* _tmp31_;
#line 923 "../src/gnome-chess.vala"
					_tmp31_ = g_strdup (_ ("White has resigned."));
#line 923 "../src/gnome-chess.vala"
					_g_free0 (why);
#line 923 "../src/gnome-chess.vala"
					why = _tmp31_;
#line 5839 "gnome-chess.c"
				} else {
#line 925 "../src/gnome-chess.vala"
					g_assert_not_reached ();
#line 5843 "gnome-chess.c"
				}
			}
#line 926 "../src/gnome-chess.vala"
			break;
#line 5848 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_ABANDONMENT:
#line 5852 "gnome-chess.c"
		{
			gchar* _tmp32_;
			PGNGame* _tmp33_;
			const gchar* _tmp34_;
#line 929 "../src/gnome-chess.vala"
			_tmp32_ = g_strdup (_ ("The game has been abandoned."));
#line 929 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 929 "../src/gnome-chess.vala"
			why = _tmp32_;
#line 930 "../src/gnome-chess.vala"
			_tmp33_ = self->priv->pgn_game;
#line 930 "../src/gnome-chess.vala"
			_tmp34_ = pgn_game_TERMINATE_ABANDONED;
#line 930 "../src/gnome-chess.vala"
			pgn_game_set_termination (_tmp33_, _tmp34_);
#line 931 "../src/gnome-chess.vala"
			break;
#line 5871 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_DEATH:
#line 5875 "gnome-chess.c"
		{
			gchar* _tmp35_;
			PGNGame* _tmp36_;
			const gchar* _tmp37_;
#line 934 "../src/gnome-chess.vala"
			_tmp35_ = g_strdup (_ ("The game log says a player died!"));
#line 934 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 934 "../src/gnome-chess.vala"
			why = _tmp35_;
#line 935 "../src/gnome-chess.vala"
			_tmp36_ = self->priv->pgn_game;
#line 935 "../src/gnome-chess.vala"
			_tmp37_ = pgn_game_TERMINATE_DEATH;
#line 935 "../src/gnome-chess.vala"
			pgn_game_set_termination (_tmp36_, _tmp37_);
#line 936 "../src/gnome-chess.vala"
			break;
#line 5894 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_BUG:
#line 5898 "gnome-chess.c"
		{
			gchar* _tmp38_;
#line 939 "../src/gnome-chess.vala"
			_tmp38_ = g_strdup (_ ("The computer player is confused. The game cannot continue."));
#line 939 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 939 "../src/gnome-chess.vala"
			why = _tmp38_;
#line 941 "../src/gnome-chess.vala"
			break;
#line 5909 "gnome-chess.c"
		}
#line 871 "../src/gnome-chess.vala"
		case CHESS_RULE_UNKNOWN:
#line 5913 "gnome-chess.c"
		{
			GFile* _tmp39_;
			gchar* _tmp40_;
#line 946 "../src/gnome-chess.vala"
			_tmp39_ = self->priv->game_file;
#line 946 "../src/gnome-chess.vala"
			_tmp40_ = g_file_get_basename (_tmp39_);
#line 946 "../src/gnome-chess.vala"
			_g_free0 (why);
#line 946 "../src/gnome-chess.vala"
			why = _tmp40_;
#line 947 "../src/gnome-chess.vala"
			break;
#line 5927 "gnome-chess.c"
		}
		default:
#line 871 "../src/gnome-chess.vala"
		break;
#line 5932 "gnome-chess.c"
	}
#line 950 "../src/gnome-chess.vala"
	_tmp41_ = self->priv->_window;
#line 950 "../src/gnome-chess.vala"
	_tmp42_ = what;
#line 950 "../src/gnome-chess.vala"
	_tmp43_ = why;
#line 950 "../src/gnome-chess.vala"
	chess_window_update_game_status (_tmp41_, _tmp42_, _tmp43_);
#line 951 "../src/gnome-chess.vala"
	_tmp44_ = self->priv->_window;
#line 951 "../src/gnome-chess.vala"
	chess_window_end_game (_tmp44_);
#line 952 "../src/gnome-chess.vala"
	chess_application_update_engine_timeout (self);
#line 836 "../src/gnome-chess.vala"
	_g_free0 (why);
#line 836 "../src/gnome-chess.vala"
	_g_free0 (what);
#line 5952 "gnome-chess.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 956 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 956 "../src/gnome-chess.vala"
	return _data7_;
#line 5962 "gnome-chess.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 956 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 5972 "gnome-chess.c"
		ChessApplication* self;
#line 956 "../src/gnome-chess.vala"
		self = _data7_->self;
#line 956 "../src/gnome-chess.vala"
		_g_object_unref0 (_data7_->prompt_save_game_dialog);
#line 956 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 956 "../src/gnome-chess.vala"
		g_slice_free (Block7Data, _data7_);
#line 5982 "gnome-chess.c"
	}
}

static void
____lambda24_ (Block7Data* _data7_,
               gboolean saved)
{
	ChessApplication* self;
#line 989 "../src/gnome-chess.vala"
	self = _data7_->self;
#line 990 "../src/gnome-chess.vala"
	_data7_->callback (!saved, _data7_->callback_target);
#line 5995 "gnome-chess.c"
}

static void
_____lambda24__chess_application_present_save_dialog_callback (gboolean saved,
                                                               gpointer self)
{
#line 989 "../src/gnome-chess.vala"
	____lambda24_ (self, saved);
#line 6004 "gnome-chess.c"
}

static void
__lambda21_ (Block7Data* _data7_,
             gint response_id)
{
	ChessApplication* self;
	gboolean _tmp0_ = FALSE;
	GtkMessageDialog* _tmp1_;
#line 982 "../src/gnome-chess.vala"
	self = _data7_->self;
#line 983 "../src/gnome-chess.vala"
	if (response_id == ((gint) GTK_RESPONSE_CANCEL)) {
#line 983 "../src/gnome-chess.vala"
		_tmp0_ = TRUE;
#line 6020 "gnome-chess.c"
	} else {
#line 983 "../src/gnome-chess.vala"
		_tmp0_ = response_id == ((gint) GTK_RESPONSE_DELETE_EVENT);
#line 6024 "gnome-chess.c"
	}
#line 983 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 985 "../src/gnome-chess.vala"
		_data7_->callback (TRUE, _data7_->callback_target);
#line 6030 "gnome-chess.c"
	} else {
#line 987 "../src/gnome-chess.vala"
		if (response_id == ((gint) GTK_RESPONSE_YES)) {
#line 989 "../src/gnome-chess.vala"
			chess_application_present_save_dialog (self, _____lambda24__chess_application_present_save_dialog_callback, _data7_);
#line 6036 "gnome-chess.c"
		} else {
#line 995 "../src/gnome-chess.vala"
			g_warn_if_fail (response_id == ((gint) GTK_RESPONSE_NO));
#line 998 "../src/gnome-chess.vala"
			self->priv->game_needs_saving = FALSE;
#line 999 "../src/gnome-chess.vala"
			chess_application_autosave (self);
#line 1001 "../src/gnome-chess.vala"
			_data7_->callback (FALSE, _data7_->callback_target);
#line 6046 "gnome-chess.c"
		}
	}
#line 1004 "../src/gnome-chess.vala"
	_tmp1_ = _data7_->prompt_save_game_dialog;
#line 1004 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _tmp1_);
#line 6053 "gnome-chess.c"
}

static void
___lambda21__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 982 "../src/gnome-chess.vala"
	__lambda21_ (self, response_id);
#line 6063 "gnome-chess.c"
}

static void
chess_application_prompt_save_game (ChessApplication* self,
                                    const gchar* prompt_text,
                                    ChessApplicationPromptSaveGameCallback callback,
                                    gpointer callback_target)
{
	Block7Data* _data7_;
	ChessWindow* _tmp0_;
	GtkMessageDialog* _tmp1_;
	GtkMessageDialog* _tmp2_;
	ChessGame* _tmp3_;
	GtkMessageDialog* _tmp8_;
	GtkMessageDialog* _tmp9_;
#line 956 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 956 "../src/gnome-chess.vala"
	g_return_if_fail (prompt_text != NULL);
#line 956 "../src/gnome-chess.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 956 "../src/gnome-chess.vala"
	_data7_->_ref_count_ = 1;
#line 956 "../src/gnome-chess.vala"
	_data7_->self = g_object_ref (self);
#line 956 "../src/gnome-chess.vala"
	_data7_->callback = callback;
#line 956 "../src/gnome-chess.vala"
	_data7_->callback_target = callback_target;
#line 958 "../src/gnome-chess.vala"
	if (!self->priv->game_needs_saving) {
#line 960 "../src/gnome-chess.vala"
		_data7_->callback (FALSE, _data7_->callback_target);
#line 961 "../src/gnome-chess.vala"
		block7_data_unref (_data7_);
#line 961 "../src/gnome-chess.vala"
		_data7_ = NULL;
#line 961 "../src/gnome-chess.vala"
		return;
#line 6103 "gnome-chess.c"
	}
#line 964 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 964 "../src/gnome-chess.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", prompt_text);
#line 964 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp1_);
#line 964 "../src/gnome-chess.vala"
	_data7_->prompt_save_game_dialog = _tmp1_;
#line 969 "../src/gnome-chess.vala"
	_tmp2_ = _data7_->prompt_save_game_dialog;
#line 969 "../src/gnome-chess.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp2_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 971 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->game;
#line 971 "../src/gnome-chess.vala"
	if (_tmp3_->result == CHESS_RESULT_IN_PROGRESS) {
#line 6121 "gnome-chess.c"
		GtkMessageDialog* _tmp4_;
		GtkMessageDialog* _tmp5_;
#line 973 "../src/gnome-chess.vala"
		_tmp4_ = _data7_->prompt_save_game_dialog;
#line 973 "../src/gnome-chess.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp4_, _ ("_Abandon game"), (gint) GTK_RESPONSE_NO);
#line 974 "../src/gnome-chess.vala"
		_tmp5_ = _data7_->prompt_save_game_dialog;
#line 974 "../src/gnome-chess.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp5_, _ ("_Save game for later"), (gint) GTK_RESPONSE_YES);
#line 6132 "gnome-chess.c"
	} else {
		GtkMessageDialog* _tmp6_;
		GtkMessageDialog* _tmp7_;
#line 978 "../src/gnome-chess.vala"
		_tmp6_ = _data7_->prompt_save_game_dialog;
#line 978 "../src/gnome-chess.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp6_, _ ("_Discard game"), (gint) GTK_RESPONSE_NO);
#line 979 "../src/gnome-chess.vala"
		_tmp7_ = _data7_->prompt_save_game_dialog;
#line 979 "../src/gnome-chess.vala"
		gtk_dialog_add_button ((GtkDialog*) _tmp7_, _ ("_Save game log"), (gint) GTK_RESPONSE_YES);
#line 6144 "gnome-chess.c"
	}
#line 982 "../src/gnome-chess.vala"
	_tmp8_ = _data7_->prompt_save_game_dialog;
#line 982 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _tmp8_, "response", (GCallback) ___lambda21__gtk_dialog_response, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 1007 "../src/gnome-chess.vala"
	_tmp9_ = _data7_->prompt_save_game_dialog;
#line 1007 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _tmp9_);
#line 956 "../src/gnome-chess.vala"
	block7_data_unref (_data7_);
#line 956 "../src/gnome-chess.vala"
	_data7_ = NULL;
#line 6158 "gnome-chess.c"
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 1010 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 1010 "../src/gnome-chess.vala"
	return _data8_;
#line 6168 "gnome-chess.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 1010 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 6178 "gnome-chess.c"
		ChessApplication* self;
#line 1010 "../src/gnome-chess.vala"
		self = _data8_->self;
#line 1010 "../src/gnome-chess.vala"
		_g_object_unref0 (_data8_->claim_draw_dialog);
#line 1010 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1010 "../src/gnome-chess.vala"
		g_slice_free (Block8Data, _data8_);
#line 6188 "gnome-chess.c"
	}
}

static void
__lambda28_ (Block8Data* _data8_,
             gint response_id)
{
	ChessApplication* self;
	ChessGame* _tmp0_;
	GtkMessageDialog* _tmp4_;
#line 1044 "../src/gnome-chess.vala"
	self = _data8_->self;
#line 1045 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1045 "../src/gnome-chess.vala"
	chess_game_unpause (_tmp0_);
#line 1047 "../src/gnome-chess.vala"
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 6207 "gnome-chess.c"
		ChessGame* _tmp1_;
		ChessPlayer* _tmp2_;
		ChessPlayer* _tmp3_;
#line 1048 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->game;
#line 1048 "../src/gnome-chess.vala"
		_tmp2_ = chess_game_get_current_player (_tmp1_);
#line 1048 "../src/gnome-chess.vala"
		_tmp3_ = _tmp2_;
#line 1048 "../src/gnome-chess.vala"
		chess_player_claim_draw (_tmp3_);
#line 6219 "gnome-chess.c"
	}
#line 1050 "../src/gnome-chess.vala"
	_tmp4_ = _data8_->claim_draw_dialog;
#line 1050 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _tmp4_);
#line 6225 "gnome-chess.c"
}

static void
___lambda28__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 1044 "../src/gnome-chess.vala"
	__lambda28_ (self, response_id);
#line 6235 "gnome-chess.c"
}

static void
chess_application_present_claim_draw_dialog (ChessApplication* self)
{
	ChessGame* _tmp0_;
	Block8Data* _data8_;
	ChessGame* _tmp1_;
	ChessWindow* _tmp2_;
	GtkMessageDialog* _tmp3_;
	gchar* reason = NULL;
	ChessGame* _tmp4_;
	GtkMessageDialog* _tmp8_;
	const gchar* _tmp9_;
	GtkMessageDialog* _tmp10_;
	GtkMessageDialog* _tmp11_;
	GtkMessageDialog* _tmp12_;
#line 1010 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1010 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1010 "../src/gnome-chess.vala"
	_vala_return_if_fail (chess_game_can_claim_draw (_tmp0_), "game.can_claim_draw ()");
#line 1010 "../src/gnome-chess.vala"
	_data8_ = g_slice_new0 (Block8Data);
#line 1010 "../src/gnome-chess.vala"
	_data8_->_ref_count_ = 1;
#line 1010 "../src/gnome-chess.vala"
	_data8_->self = g_object_ref (self);
#line 1013 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 1013 "../src/gnome-chess.vala"
	chess_game_pause (_tmp1_, FALSE);
#line 1015 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->_window;
#line 1015 "../src/gnome-chess.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp2_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _ ("Would you like to claim a draw?"));
#line 1015 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp3_);
#line 1015 "../src/gnome-chess.vala"
	_data8_->claim_draw_dialog = _tmp3_;
#line 1023 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->game;
#line 1023 "../src/gnome-chess.vala"
	if (chess_game_is_fifty_move_rule_fulfilled (_tmp4_)) {
#line 6281 "gnome-chess.c"
		gchar* _tmp5_;
#line 1026 "../src/gnome-chess.vala"
		_tmp5_ = g_strdup (_ ("You may claim a draw because fifty moves have passed without a capture" \
" or pawn advancement. (The computer player may still choose to claim a" \
" draw even if you choose to keep playing.)"));
#line 1026 "../src/gnome-chess.vala"
		_g_free0 (reason);
#line 1026 "../src/gnome-chess.vala"
		reason = _tmp5_;
#line 6289 "gnome-chess.c"
	} else {
		ChessGame* _tmp6_;
#line 1028 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->game;
#line 1028 "../src/gnome-chess.vala"
		if (chess_game_is_three_fold_repeat (_tmp6_)) {
#line 6296 "gnome-chess.c"
			gchar* _tmp7_;
#line 1031 "../src/gnome-chess.vala"
			_tmp7_ = g_strdup (_ ("You may claim a draw because the current board position has occurred t" \
"hree times. (The computer player may still choose to claim a draw even" \
" if you choose to keep playing.)"));
#line 1031 "../src/gnome-chess.vala"
			_g_free0 (reason);
#line 1031 "../src/gnome-chess.vala"
			reason = _tmp7_;
#line 6304 "gnome-chess.c"
		} else {
#line 1034 "../src/gnome-chess.vala"
			g_assert_not_reached ();
#line 6308 "gnome-chess.c"
		}
	}
#line 1036 "../src/gnome-chess.vala"
	_tmp8_ = _data8_->claim_draw_dialog;
#line 1036 "../src/gnome-chess.vala"
	_tmp9_ = reason;
#line 1036 "../src/gnome-chess.vala"
	g_object_set (_tmp8_, "secondary-text", _tmp9_, NULL);
#line 1038 "../src/gnome-chess.vala"
	_tmp10_ = _data8_->claim_draw_dialog;
#line 1038 "../src/gnome-chess.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _tmp10_, _ ("_Keep Playing"), GTK_RESPONSE_REJECT, _ ("_Claim Draw"), GTK_RESPONSE_ACCEPT, NULL, NULL);
#line 1044 "../src/gnome-chess.vala"
	_tmp11_ = _data8_->claim_draw_dialog;
#line 1044 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _tmp11_, "response", (GCallback) ___lambda28__gtk_dialog_response, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 1053 "../src/gnome-chess.vala"
	_tmp12_ = _data8_->claim_draw_dialog;
#line 1053 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _tmp12_);
#line 1010 "../src/gnome-chess.vala"
	_g_free0 (reason);
#line 1010 "../src/gnome-chess.vala"
	block8_data_unref (_data8_);
#line 1010 "../src/gnome-chess.vala"
	_data8_ = NULL;
#line 6335 "gnome-chess.c"
}

static void
__lambda25_ (ChessApplication* self,
             gboolean cancelled)
{
#line 1059 "../src/gnome-chess.vala"
	if (!cancelled) {
#line 1060 "../src/gnome-chess.vala"
		chess_application_configure_new_game (self);
#line 6346 "gnome-chess.c"
	}
}

static void
___lambda25__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                          gpointer self)
{
#line 1058 "../src/gnome-chess.vala"
	__lambda25_ ((ChessApplication*) self, cancelled);
#line 6356 "gnome-chess.c"
}

void
chess_application_new_game_cb (ChessApplication* self)
{
#line 1056 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1058 "../src/gnome-chess.vala"
	chess_application_prompt_save_game (self, _ ("Save this game before starting a new one?"), ___lambda25__chess_application_prompt_save_game_callback, self);
#line 6366 "gnome-chess.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 1064 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 1064 "../src/gnome-chess.vala"
	return _data9_;
#line 6376 "gnome-chess.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 1064 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 6386 "gnome-chess.c"
		ChessApplication* self;
#line 1064 "../src/gnome-chess.vala"
		self = _data9_->self;
#line 1064 "../src/gnome-chess.vala"
		_g_object_unref0 (_data9_->resign_dialog);
#line 1064 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1064 "../src/gnome-chess.vala"
		g_slice_free (Block9Data, _data9_);
#line 6396 "gnome-chess.c"
	}
}

static void
__lambda37_ (Block9Data* _data9_,
             gint response_id)
{
	ChessApplication* self;
	ChessGame* _tmp0_;
#line 1083 "../src/gnome-chess.vala"
	self = _data9_->self;
#line 1084 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1084 "../src/gnome-chess.vala"
	chess_game_unpause (_tmp0_);
#line 1086 "../src/gnome-chess.vala"
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 6414 "gnome-chess.c"
		ChessPlayer* _tmp1_;
#line 1088 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->human_player;
#line 1088 "../src/gnome-chess.vala"
		if (_tmp1_ != NULL) {
#line 6420 "gnome-chess.c"
			ChessPlayer* _tmp2_;
#line 1089 "../src/gnome-chess.vala"
			_tmp2_ = self->priv->human_player;
#line 1089 "../src/gnome-chess.vala"
			chess_player_resign (_tmp2_);
#line 6426 "gnome-chess.c"
		} else {
			ChessGame* _tmp3_;
			ChessPlayer* _tmp4_;
			ChessPlayer* _tmp5_;
#line 1091 "../src/gnome-chess.vala"
			_tmp3_ = self->priv->game;
#line 1091 "../src/gnome-chess.vala"
			_tmp4_ = chess_game_get_current_player (_tmp3_);
#line 1091 "../src/gnome-chess.vala"
			_tmp5_ = _tmp4_;
#line 1091 "../src/gnome-chess.vala"
			chess_player_resign (_tmp5_);
#line 6439 "gnome-chess.c"
		}
	}
#line 1094 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _data9_->resign_dialog);
#line 6444 "gnome-chess.c"
}

static void
___lambda37__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 1083 "../src/gnome-chess.vala"
	__lambda37_ (self, response_id);
#line 6454 "gnome-chess.c"
}

void
chess_application_resign_cb (ChessApplication* self)
{
	Block9Data* _data9_;
	ChessGame* _tmp0_;
	ChessWindow* _tmp1_;
	GtkMessageDialog* _tmp2_;
#line 1064 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1064 "../src/gnome-chess.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 1064 "../src/gnome-chess.vala"
	_data9_->_ref_count_ = 1;
#line 1064 "../src/gnome-chess.vala"
	_data9_->self = g_object_ref (self);
#line 1066 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1066 "../src/gnome-chess.vala"
	chess_game_pause (_tmp0_, FALSE);
#line 1068 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->_window;
#line 1068 "../src/gnome-chess.vala"
	_tmp2_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp1_, GTK_DIALOG_MODAL, GTK_MESSAGE_QUESTION, GTK_BUTTONS_NONE, "%s", _ ("Are you sure you want to resign?"));
#line 1068 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp2_);
#line 1068 "../src/gnome-chess.vala"
	_data9_->resign_dialog = _tmp2_;
#line 1074 "../src/gnome-chess.vala"
	gtk_message_dialog_format_secondary_text (_data9_->resign_dialog, "%s", _ ("This makes sense if you plan to save the game as a record of your loss" \
"."));
#line 1077 "../src/gnome-chess.vala"
	gtk_dialog_add_buttons ((GtkDialog*) _data9_->resign_dialog, _ ("_Keep Playing"), GTK_RESPONSE_REJECT, _ ("_Resign"), GTK_RESPONSE_ACCEPT, NULL, NULL);
#line 1083 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _data9_->resign_dialog, "response", (GCallback) ___lambda37__gtk_dialog_response, block9_data_ref (_data9_), (GClosureNotify) block9_data_unref, 0);
#line 1097 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _data9_->resign_dialog);
#line 1064 "../src/gnome-chess.vala"
	block9_data_unref (_data9_);
#line 1064 "../src/gnome-chess.vala"
	_data9_ = NULL;
#line 6496 "gnome-chess.c"
}

void
chess_application_undo_move_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	ChessPlayer* _tmp4_;
#line 1100 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1103 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1103 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1103 "../src/gnome-chess.vala"
	_tmp1_->selected_rank = -1;
#line 1104 "../src/gnome-chess.vala"
	_tmp2_ = chess_application_get_scene (self);
#line 1104 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1104 "../src/gnome-chess.vala"
	_tmp3_->selected_file = -1;
#line 1106 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->opponent;
#line 1106 "../src/gnome-chess.vala"
	if (_tmp4_ != NULL) {
#line 6525 "gnome-chess.c"
		ChessPlayer* _tmp5_;
#line 1107 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->human_player;
#line 1107 "../src/gnome-chess.vala"
		chess_player_undo (_tmp5_);
#line 6531 "gnome-chess.c"
	} else {
		ChessGame* _tmp6_;
		ChessPlayer* _tmp7_;
		ChessPlayer* _tmp8_;
#line 1109 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->game;
#line 1109 "../src/gnome-chess.vala"
		_tmp7_ = chess_game_get_opponent (_tmp6_);
#line 1109 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 1109 "../src/gnome-chess.vala"
		chess_player_undo (_tmp8_);
#line 6544 "gnome-chess.c"
	}
}

void
chess_application_pause_resume_cb (ChessApplication* self)
{
	ChessGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ChessWindow* _tmp5_;
	ChessWindow* _tmp6_;
#line 1112 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1114 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1114 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_is_paused (_tmp0_);
#line 1114 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 1114 "../src/gnome-chess.vala"
	if (_tmp2_) {
#line 6566 "gnome-chess.c"
		ChessGame* _tmp3_;
#line 1115 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game;
#line 1115 "../src/gnome-chess.vala"
		chess_game_unpause (_tmp3_);
#line 6572 "gnome-chess.c"
	} else {
		ChessGame* _tmp4_;
#line 1117 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 1117 "../src/gnome-chess.vala"
		chess_game_pause (_tmp4_, TRUE);
#line 6579 "gnome-chess.c"
	}
#line 1119 "../src/gnome-chess.vala"
	chess_application_update_action_status (self);
#line 1120 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->_window;
#line 1120 "../src/gnome-chess.vala"
	chess_window_update_history_panel (_tmp5_);
#line 1121 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->_window;
#line 1121 "../src/gnome-chess.vala"
	chess_window_update_pause_resume_button (_tmp6_);
#line 6591 "gnome-chess.c"
}

void
chess_application_quit_cb (ChessApplication* self)
{
#line 1124 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1126 "../src/gnome-chess.vala"
	chess_application_quit_game (self);
#line 6601 "gnome-chess.c"
}

static void
chess_application_history_go_first_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 1129 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1131 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1131 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1131 "../src/gnome-chess.vala"
	chess_scene_set_move_number (_tmp1_, 0);
#line 6617 "gnome-chess.c"
}

static void
chess_application_history_go_previous_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 1134 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1136 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1136 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1136 "../src/gnome-chess.vala"
	_tmp2_ = chess_scene_get_move_number (_tmp1_);
#line 1136 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1136 "../src/gnome-chess.vala"
	if (_tmp3_ == 0) {
#line 1137 "../src/gnome-chess.vala"
		return;
#line 6645 "gnome-chess.c"
	}
#line 1139 "../src/gnome-chess.vala"
	_tmp4_ = chess_application_get_scene (self);
#line 1139 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1139 "../src/gnome-chess.vala"
	_tmp6_ = chess_scene_get_move_number (_tmp5_);
#line 1139 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_;
#line 1139 "../src/gnome-chess.vala"
	if (_tmp7_ == -1) {
#line 6657 "gnome-chess.c"
		ChessScene* _tmp8_;
		ChessScene* _tmp9_;
		ChessGame* _tmp10_;
		guint _tmp11_;
		guint _tmp12_;
#line 1140 "../src/gnome-chess.vala"
		_tmp8_ = chess_application_get_scene (self);
#line 1140 "../src/gnome-chess.vala"
		_tmp9_ = _tmp8_;
#line 1140 "../src/gnome-chess.vala"
		_tmp10_ = self->priv->game;
#line 1140 "../src/gnome-chess.vala"
		_tmp11_ = chess_game_get_n_moves (_tmp10_);
#line 1140 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 1140 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp9_, ((gint) _tmp12_) - 1);
#line 6675 "gnome-chess.c"
	} else {
		ChessScene* _tmp13_;
		ChessScene* _tmp14_;
		ChessScene* _tmp15_;
		ChessScene* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1142 "../src/gnome-chess.vala"
		_tmp13_ = chess_application_get_scene (self);
#line 1142 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1142 "../src/gnome-chess.vala"
		_tmp15_ = chess_application_get_scene (self);
#line 1142 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1142 "../src/gnome-chess.vala"
		_tmp17_ = chess_scene_get_move_number (_tmp16_);
#line 1142 "../src/gnome-chess.vala"
		_tmp18_ = _tmp17_;
#line 1142 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp14_, _tmp18_ - 1);
#line 6697 "gnome-chess.c"
	}
}

static void
chess_application_history_go_next_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint move_number = 0;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	ChessGame* _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
#line 1145 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1147 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1147 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1147 "../src/gnome-chess.vala"
	_tmp2_ = chess_scene_get_move_number (_tmp1_);
#line 1147 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1147 "../src/gnome-chess.vala"
	if (_tmp3_ == -1) {
#line 1148 "../src/gnome-chess.vala"
		return;
#line 6730 "gnome-chess.c"
	}
#line 1150 "../src/gnome-chess.vala"
	_tmp4_ = chess_application_get_scene (self);
#line 1150 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1150 "../src/gnome-chess.vala"
	_tmp6_ = chess_scene_get_move_number (_tmp5_);
#line 1150 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_;
#line 1150 "../src/gnome-chess.vala"
	move_number = _tmp7_ + 1;
#line 1151 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->game;
#line 1151 "../src/gnome-chess.vala"
	_tmp9_ = chess_game_get_n_moves (_tmp8_);
#line 1151 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 1151 "../src/gnome-chess.vala"
	if (((guint) move_number) >= _tmp10_) {
#line 6750 "gnome-chess.c"
		ChessScene* _tmp11_;
		ChessScene* _tmp12_;
#line 1152 "../src/gnome-chess.vala"
		_tmp11_ = chess_application_get_scene (self);
#line 1152 "../src/gnome-chess.vala"
		_tmp12_ = _tmp11_;
#line 1152 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp12_, -1);
#line 6759 "gnome-chess.c"
	} else {
		ChessScene* _tmp13_;
		ChessScene* _tmp14_;
#line 1154 "../src/gnome-chess.vala"
		_tmp13_ = chess_application_get_scene (self);
#line 1154 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1154 "../src/gnome-chess.vala"
		chess_scene_set_move_number (_tmp14_, move_number);
#line 6769 "gnome-chess.c"
	}
}

static void
chess_application_history_go_last_cb (ChessApplication* self)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
#line 1157 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1159 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_scene (self);
#line 1159 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1159 "../src/gnome-chess.vala"
	chess_scene_set_move_number (_tmp1_, -1);
#line 6786 "gnome-chess.c"
}

static void
__lambda26_ (ChessApplication* self)
{
#line 1171 "../src/gnome-chess.vala"
	chess_application_start_new_game (self);
#line 6794 "gnome-chess.c"
}

static void
___lambda26__new_game_window_new_game_requested (NewGameWindow* _sender,
                                                 gpointer self)
{
#line 1171 "../src/gnome-chess.vala"
	__lambda26_ ((ChessApplication*) self);
#line 6803 "gnome-chess.c"
}

static void
chess_application_configure_new_game (ChessApplication* self)
{
	NewGameWindow* _tmp0_;
	ChessWindow* _tmp2_;
	Preferences* _tmp3_;
	GList* _tmp4_;
	NewGameWindow* _tmp5_;
	NewGameWindow* _tmp6_;
	NewGameWindow* _tmp7_;
#line 1162 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1164 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->new_game_window;
#line 1164 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6822 "gnome-chess.c"
		NewGameWindow* _tmp1_;
#line 1166 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->new_game_window;
#line 1166 "../src/gnome-chess.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 1167 "../src/gnome-chess.vala"
		return;
#line 6830 "gnome-chess.c"
	}
#line 1170 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->_window;
#line 1170 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->preferences;
#line 1170 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->ai_profiles;
#line 1170 "../src/gnome-chess.vala"
	_tmp5_ = new_game_window_new ((GtkWindow*) _tmp2_, _tmp3_, _tmp4_);
#line 1170 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp5_);
#line 1170 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->new_game_window);
#line 1170 "../src/gnome-chess.vala"
	self->priv->new_game_window = _tmp5_;
#line 1171 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->new_game_window;
#line 1171 "../src/gnome-chess.vala"
	g_signal_connect_object (_tmp6_, "new-game-requested", (GCallback) ___lambda26__new_game_window_new_game_requested, self, 0);
#line 1172 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->new_game_window;
#line 1172 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _tmp7_);
#line 6854 "gnome-chess.c"
}

static void
chess_application_preferences_cb (ChessApplication* self)
{
	PreferencesWindow* _tmp0_;
	ChessWindow* _tmp2_;
	Preferences* _tmp3_;
	PreferencesWindow* _tmp4_;
	PreferencesWindow* _tmp5_;
#line 1175 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1177 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->preferences_window;
#line 1177 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6871 "gnome-chess.c"
		PreferencesWindow* _tmp1_;
#line 1179 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->preferences_window;
#line 1179 "../src/gnome-chess.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 1180 "../src/gnome-chess.vala"
		return;
#line 6879 "gnome-chess.c"
	}
#line 1183 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->_window;
#line 1183 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->preferences;
#line 1183 "../src/gnome-chess.vala"
	_tmp4_ = preferences_window_new ((GtkWindow*) _tmp2_, _tmp3_);
#line 1183 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp4_);
#line 1183 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences_window);
#line 1183 "../src/gnome-chess.vala"
	self->priv->preferences_window = _tmp4_;
#line 1184 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->preferences_window;
#line 1184 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _tmp5_);
#line 6897 "gnome-chess.c"
}

void
chess_application_help_cb (ChessApplication* self)
{
	ChessWindow* _tmp0_;
#line 1187 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1189 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 1189 "../src/gnome-chess.vala"
	gtk_show_uri ((GtkWindow*) _tmp0_, "help:gnome-chess", (guint32) GDK_CURRENT_TIME);
#line 6910 "gnome-chess.c"
}

void
chess_application_about_cb (ChessApplication* self)
{
	GtkAboutDialog* _tmp0_;
	GtkAboutDialog* _tmp2_;
	GtkAboutDialog* _tmp3_;
	ChessWindow* _tmp4_;
	GtkAboutDialog* _tmp5_;
	GtkAboutDialog* _tmp6_;
	GtkAboutDialog* _tmp7_;
	GtkAboutDialog* _tmp8_;
	const gchar* _tmp9_;
	GtkAboutDialog* _tmp10_;
	GtkAboutDialog* _tmp11_;
	GtkAboutDialog* _tmp12_;
	GtkAboutDialog* _tmp13_;
	GtkAboutDialog* _tmp14_;
	GtkAboutDialog* _tmp15_;
	GtkAboutDialog* _tmp16_;
	GtkAboutDialog* _tmp17_;
	GtkAboutDialog* _tmp18_;
#line 1195 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1197 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->about_dialog;
#line 1197 "../src/gnome-chess.vala"
	if (_tmp0_ != NULL) {
#line 6940 "gnome-chess.c"
		GtkAboutDialog* _tmp1_;
#line 1199 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->about_dialog;
#line 1199 "../src/gnome-chess.vala"
		gtk_widget_show ((GtkWidget*) _tmp1_);
#line 1200 "../src/gnome-chess.vala"
		return;
#line 6948 "gnome-chess.c"
	}
#line 1203 "../src/gnome-chess.vala"
	_tmp2_ = (GtkAboutDialog*) gtk_about_dialog_new ();
#line 1203 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp2_);
#line 1203 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->about_dialog);
#line 1203 "../src/gnome-chess.vala"
	self->priv->about_dialog = _tmp2_;
#line 1204 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->about_dialog;
#line 1204 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->_window;
#line 1204 "../src/gnome-chess.vala"
	gtk_window_set_transient_for ((GtkWindow*) _tmp3_, (GtkWindow*) _tmp4_);
#line 1205 "../src/gnome-chess.vala"
	_tmp5_ = self->priv->about_dialog;
#line 1205 "../src/gnome-chess.vala"
	gtk_window_set_modal ((GtkWindow*) _tmp5_, TRUE);
#line 1206 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->about_dialog;
#line 1206 "../src/gnome-chess.vala"
	gtk_about_dialog_set_program_name (_tmp6_, _ ("Chess"));
#line 1207 "../src/gnome-chess.vala"
	_tmp7_ = self->priv->about_dialog;
#line 1207 "../src/gnome-chess.vala"
	gtk_about_dialog_set_version (_tmp7_, VERSION);
#line 1208 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->about_dialog;
#line 1208 "../src/gnome-chess.vala"
	_tmp9_ = self->priv->copyrights;
#line 1208 "../src/gnome-chess.vala"
	gtk_about_dialog_set_copyright (_tmp8_, _tmp9_);
#line 1209 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->about_dialog;
#line 1209 "../src/gnome-chess.vala"
	gtk_about_dialog_set_license_type (_tmp10_, GTK_LICENSE_GPL_3_0);
#line 1210 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->about_dialog;
#line 1210 "../src/gnome-chess.vala"
	gtk_about_dialog_set_comments (_tmp11_, _ ("A classic game of positional strategy"));
#line 1211 "../src/gnome-chess.vala"
	_tmp12_ = self->priv->about_dialog;
#line 1211 "../src/gnome-chess.vala"
	gtk_about_dialog_set_authors (_tmp12_, CHESS_APPLICATION_authors);
#line 1212 "../src/gnome-chess.vala"
	_tmp13_ = self->priv->about_dialog;
#line 1212 "../src/gnome-chess.vala"
	gtk_about_dialog_set_artists (_tmp13_, CHESS_APPLICATION_artists);
#line 1213 "../src/gnome-chess.vala"
	_tmp14_ = self->priv->about_dialog;
#line 1213 "../src/gnome-chess.vala"
	gtk_about_dialog_set_translator_credits (_tmp14_, _ ("translator-credits"));
#line 1214 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->about_dialog;
#line 1214 "../src/gnome-chess.vala"
	gtk_about_dialog_set_website (_tmp15_, "https://wiki.gnome.org/Apps/Chess");
#line 1215 "../src/gnome-chess.vala"
	_tmp16_ = self->priv->about_dialog;
#line 1215 "../src/gnome-chess.vala"
	gtk_about_dialog_set_logo_icon_name (_tmp16_, "org.gnome.Chess");
#line 1216 "../src/gnome-chess.vala"
	_tmp17_ = self->priv->about_dialog;
#line 1216 "../src/gnome-chess.vala"
	gtk_window_set_hide_on_close ((GtkWindow*) _tmp17_, TRUE);
#line 1217 "../src/gnome-chess.vala"
	_tmp18_ = self->priv->about_dialog;
#line 1217 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _tmp18_);
#line 7018 "gnome-chess.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 1220 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 1220 "../src/gnome-chess.vala"
	return _data10_;
#line 7028 "gnome-chess.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 1220 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 7038 "gnome-chess.c"
		ChessApplication* self;
#line 1220 "../src/gnome-chess.vala"
		self = _data10_->self;
#line 1220 "../src/gnome-chess.vala"
		_g_object_unref0 (_data10_->promotion_type_selector_dialog);
#line 1220 "../src/gnome-chess.vala"
		(_data10_->handler_target_destroy_notify == NULL) ? NULL : (_data10_->handler_target_destroy_notify (_data10_->handler_target), NULL);
#line 1220 "../src/gnome-chess.vala"
		_data10_->handler = NULL;
#line 1220 "../src/gnome-chess.vala"
		_data10_->handler_target = NULL;
#line 1220 "../src/gnome-chess.vala"
		_data10_->handler_target_destroy_notify = NULL;
#line 1220 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1220 "../src/gnome-chess.vala"
		g_slice_free (Block10Data, _data10_);
#line 7056 "gnome-chess.c"
	}
}

static void
__lambda40_ (Block10Data* _data10_,
             gint response_id)
{
	ChessApplication* self;
#line 1228 "../src/gnome-chess.vala"
	self = _data10_->self;
#line 1229 "../src/gnome-chess.vala"
	switch (response_id) {
#line 1229 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_QUEEN:
#line 7071 "gnome-chess.c"
		{
			PieceType _tmp0_;
#line 1232 "../src/gnome-chess.vala"
			_tmp0_ = PIECE_TYPE_QUEEN;
#line 1232 "../src/gnome-chess.vala"
			_data10_->handler (&_tmp0_, _data10_->handler_target);
#line 1233 "../src/gnome-chess.vala"
			break;
#line 7080 "gnome-chess.c"
		}
#line 1229 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_KNIGHT:
#line 7084 "gnome-chess.c"
		{
			PieceType _tmp1_;
#line 1235 "../src/gnome-chess.vala"
			_tmp1_ = PIECE_TYPE_KNIGHT;
#line 1235 "../src/gnome-chess.vala"
			_data10_->handler (&_tmp1_, _data10_->handler_target);
#line 1236 "../src/gnome-chess.vala"
			break;
#line 7093 "gnome-chess.c"
		}
#line 1229 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_ROOK:
#line 7097 "gnome-chess.c"
		{
			PieceType _tmp2_;
#line 1238 "../src/gnome-chess.vala"
			_tmp2_ = PIECE_TYPE_ROOK;
#line 1238 "../src/gnome-chess.vala"
			_data10_->handler (&_tmp2_, _data10_->handler_target);
#line 1239 "../src/gnome-chess.vala"
			break;
#line 7106 "gnome-chess.c"
		}
#line 1229 "../src/gnome-chess.vala"
		case PROMOTION_TYPE_SELECTOR_DIALOG_SELECTED_TYPE_BISHOP:
#line 7110 "gnome-chess.c"
		{
			PieceType _tmp3_;
#line 1241 "../src/gnome-chess.vala"
			_tmp3_ = PIECE_TYPE_BISHOP;
#line 1241 "../src/gnome-chess.vala"
			_data10_->handler (&_tmp3_, _data10_->handler_target);
#line 1242 "../src/gnome-chess.vala"
			break;
#line 7119 "gnome-chess.c"
		}
		default:
		{
#line 1244 "../src/gnome-chess.vala"
			_data10_->handler (NULL, _data10_->handler_target);
#line 1245 "../src/gnome-chess.vala"
			break;
#line 7127 "gnome-chess.c"
		}
	}
#line 1248 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _data10_->promotion_type_selector_dialog);
#line 1249 "../src/gnome-chess.vala"
	_g_object_unref0 (_data10_->promotion_type_selector_dialog);
#line 1249 "../src/gnome-chess.vala"
	_data10_->promotion_type_selector_dialog = NULL;
#line 7136 "gnome-chess.c"
}

static void
___lambda40__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 1228 "../src/gnome-chess.vala"
	__lambda40_ (self, response_id);
#line 7146 "gnome-chess.c"
}

static void
chess_application_show_promotion_type_selector (ChessApplication* self,
                                                ChessScenePromotionTypeCompletionHandler handler,
                                                gpointer handler_target,
                                                GDestroyNotify handler_target_destroy_notify)
{
	Block10Data* _data10_;
	ChessWindow* _tmp0_;
	ChessGame* _tmp1_;
	ChessPlayer* _tmp2_;
	ChessPlayer* _tmp3_;
	ChessScene* _tmp4_;
	ChessScene* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	ChessWindow* _tmp8_;
	ChessWindowLayoutMode _tmp9_;
	ChessWindowLayoutMode _tmp10_;
	PromotionTypeSelectorDialog* _tmp11_;
#line 1220 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1220 "../src/gnome-chess.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 1220 "../src/gnome-chess.vala"
	_data10_->_ref_count_ = 1;
#line 1220 "../src/gnome-chess.vala"
	_data10_->self = g_object_ref (self);
#line 1220 "../src/gnome-chess.vala"
	(_data10_->handler_target_destroy_notify == NULL) ? NULL : (_data10_->handler_target_destroy_notify (_data10_->handler_target), NULL);
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler = NULL;
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler_target = NULL;
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler_target_destroy_notify = NULL;
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler = handler;
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler_target = handler_target;
#line 1220 "../src/gnome-chess.vala"
	_data10_->handler_target_destroy_notify = handler_target_destroy_notify;
#line 1223 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 1223 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game;
#line 1223 "../src/gnome-chess.vala"
	_tmp2_ = chess_game_get_current_player (_tmp1_);
#line 1223 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 1223 "../src/gnome-chess.vala"
	_tmp4_ = chess_application_get_scene (self);
#line 1223 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1223 "../src/gnome-chess.vala"
	_tmp6_ = chess_scene_get_theme_name (_tmp5_);
#line 1223 "../src/gnome-chess.vala"
	_tmp7_ = _tmp6_;
#line 1223 "../src/gnome-chess.vala"
	_tmp8_ = self->priv->_window;
#line 1223 "../src/gnome-chess.vala"
	_tmp9_ = chess_window_get_layout_mode (_tmp8_);
#line 1223 "../src/gnome-chess.vala"
	_tmp10_ = _tmp9_;
#line 1223 "../src/gnome-chess.vala"
	_tmp11_ = promotion_type_selector_dialog_new ((GtkWindow*) _tmp0_, _tmp3_->color, _tmp7_, _tmp10_);
#line 1223 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp11_);
#line 1223 "../src/gnome-chess.vala"
	_data10_->promotion_type_selector_dialog = _tmp11_;
#line 1228 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _data10_->promotion_type_selector_dialog, "response", (GCallback) ___lambda40__gtk_dialog_response, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 1252 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _data10_->promotion_type_selector_dialog);
#line 1220 "../src/gnome-chess.vala"
	block10_data_unref (_data10_);
#line 1220 "../src/gnome-chess.vala"
	_data10_ = NULL;
#line 7226 "gnome-chess.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 1255 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 1255 "../src/gnome-chess.vala"
	return _data11_;
#line 7236 "gnome-chess.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 1255 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 7246 "gnome-chess.c"
		ChessApplication* self;
#line 1255 "../src/gnome-chess.vala"
		self = _data11_->self;
#line 1255 "../src/gnome-chess.vala"
		_g_object_unref0 (_data11_->invalid_pgn_dialog);
#line 1255 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1255 "../src/gnome-chess.vala"
		g_slice_free (Block11Data, _data11_);
#line 7256 "gnome-chess.c"
	}
}

static void
__lambda36_ (Block11Data* _data11_)
{
	ChessApplication* self;
#line 1264 "../src/gnome-chess.vala"
	self = _data11_->self;
#line 1264 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _data11_->invalid_pgn_dialog);
#line 7268 "gnome-chess.c"
}

static void
___lambda36__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 1264 "../src/gnome-chess.vala"
	__lambda36_ (self);
#line 7278 "gnome-chess.c"
}

static void
chess_application_run_invalid_pgn_dialog (ChessApplication* self)
{
	Block11Data* _data11_;
	ChessWindow* _tmp0_;
	GtkMessageDialog* _tmp1_;
#line 1255 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1255 "../src/gnome-chess.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 1255 "../src/gnome-chess.vala"
	_data11_->_ref_count_ = 1;
#line 1255 "../src/gnome-chess.vala"
	_data11_->self = g_object_ref (self);
#line 1257 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 1257 "../src/gnome-chess.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, "%s", _ ("This does not look like a valid PGN game."));
#line 1257 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp1_);
#line 1257 "../src/gnome-chess.vala"
	_data11_->invalid_pgn_dialog = _tmp1_;
#line 1262 "../src/gnome-chess.vala"
	gtk_dialog_add_button ((GtkDialog*) _data11_->invalid_pgn_dialog, _ ("_OK"), (gint) GTK_RESPONSE_OK);
#line 1264 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _data11_->invalid_pgn_dialog, "response", (GCallback) ___lambda36__gtk_dialog_response, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 1265 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _data11_->invalid_pgn_dialog);
#line 1255 "../src/gnome-chess.vala"
	block11_data_unref (_data11_);
#line 1255 "../src/gnome-chess.vala"
	_data11_ = NULL;
#line 7313 "gnome-chess.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 1268 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 1268 "../src/gnome-chess.vala"
	return _data12_;
#line 7323 "gnome-chess.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 1268 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 7333 "gnome-chess.c"
		ChessApplication* self;
#line 1268 "../src/gnome-chess.vala"
		self = _data12_->self;
#line 1268 "../src/gnome-chess.vala"
		_g_object_unref0 (_data12_->invalid_move_dialog);
#line 1268 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1268 "../src/gnome-chess.vala"
		g_slice_free (Block12Data, _data12_);
#line 7343 "gnome-chess.c"
	}
}

static void
__lambda30_ (Block12Data* _data12_)
{
	ChessApplication* self;
#line 1277 "../src/gnome-chess.vala"
	self = _data12_->self;
#line 1277 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _data12_->invalid_move_dialog);
#line 7355 "gnome-chess.c"
}

static void
___lambda30__gtk_dialog_response (GtkDialog* _sender,
                                  gint response_id,
                                  gpointer self)
{
#line 1277 "../src/gnome-chess.vala"
	__lambda30_ (self);
#line 7365 "gnome-chess.c"
}

static void
chess_application_show_invalid_move_dialog (ChessApplication* self,
                                            const gchar* error_message)
{
	Block12Data* _data12_;
	ChessWindow* _tmp0_;
	GtkMessageDialog* _tmp1_;
#line 1268 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1268 "../src/gnome-chess.vala"
	g_return_if_fail (error_message != NULL);
#line 1268 "../src/gnome-chess.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 1268 "../src/gnome-chess.vala"
	_data12_->_ref_count_ = 1;
#line 1268 "../src/gnome-chess.vala"
	_data12_->self = g_object_ref (self);
#line 1270 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 1270 "../src/gnome-chess.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp0_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, "%s", error_message);
#line 1270 "../src/gnome-chess.vala"
	g_object_ref_sink (_tmp1_);
#line 1270 "../src/gnome-chess.vala"
	_data12_->invalid_move_dialog = _tmp1_;
#line 1275 "../src/gnome-chess.vala"
	gtk_dialog_add_button ((GtkDialog*) _data12_->invalid_move_dialog, _ ("_OK"), (gint) GTK_RESPONSE_OK);
#line 1277 "../src/gnome-chess.vala"
	g_signal_connect_data ((GtkDialog*) _data12_->invalid_move_dialog, "response", (GCallback) ___lambda30__gtk_dialog_response, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 1278 "../src/gnome-chess.vala"
	gtk_widget_show ((GtkWidget*) _data12_->invalid_move_dialog);
#line 1268 "../src/gnome-chess.vala"
	block12_data_unref (_data12_);
#line 1268 "../src/gnome-chess.vala"
	_data12_ = NULL;
#line 7403 "gnome-chess.c"
}

static void
chess_application_update_pgn_time_remaining (ChessApplication* self)
{
	ChessGame* _tmp0_;
	ChessClock* _tmp1_;
	ChessClock* _tmp2_;
#line 1281 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1283 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->game;
#line 1283 "../src/gnome-chess.vala"
	_tmp1_ = chess_game_get_clock (_tmp0_);
#line 1283 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 1283 "../src/gnome-chess.vala"
	if (_tmp2_ != NULL) {
#line 7422 "gnome-chess.c"
		PGNGame* _tmp3_;
		ChessGame* _tmp4_;
		ChessClock* _tmp5_;
		ChessClock* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		PGNGame* _tmp11_;
		ChessGame* _tmp12_;
		ChessClock* _tmp13_;
		ChessClock* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 1286 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->pgn_game;
#line 1286 "../src/gnome-chess.vala"
		_tmp4_ = self->priv->game;
#line 1286 "../src/gnome-chess.vala"
		_tmp5_ = chess_game_get_clock (_tmp4_);
#line 1286 "../src/gnome-chess.vala"
		_tmp6_ = _tmp5_;
#line 1286 "../src/gnome-chess.vala"
		_tmp7_ = chess_clock_get_white_remaining_seconds (_tmp6_);
#line 1286 "../src/gnome-chess.vala"
		_tmp8_ = _tmp7_;
#line 1286 "../src/gnome-chess.vala"
		_tmp9_ = g_strdup_printf ("%i", _tmp8_);
#line 1286 "../src/gnome-chess.vala"
		_tmp10_ = _tmp9_;
#line 1286 "../src/gnome-chess.vala"
		pgn_game_set_white_time_left (_tmp3_, _tmp10_);
#line 1286 "../src/gnome-chess.vala"
		_g_free0 (_tmp10_);
#line 1287 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->pgn_game;
#line 1287 "../src/gnome-chess.vala"
		_tmp12_ = self->priv->game;
#line 1287 "../src/gnome-chess.vala"
		_tmp13_ = chess_game_get_clock (_tmp12_);
#line 1287 "../src/gnome-chess.vala"
		_tmp14_ = _tmp13_;
#line 1287 "../src/gnome-chess.vala"
		_tmp15_ = chess_clock_get_black_remaining_seconds (_tmp14_);
#line 1287 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1287 "../src/gnome-chess.vala"
		_tmp17_ = g_strdup_printf ("%i", _tmp16_);
#line 1287 "../src/gnome-chess.vala"
		_tmp18_ = _tmp17_;
#line 1287 "../src/gnome-chess.vala"
		pgn_game_set_black_time_left (_tmp11_, _tmp18_);
#line 1287 "../src/gnome-chess.vala"
		_g_free0 (_tmp18_);
#line 7479 "gnome-chess.c"
	}
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 1292 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 1292 "../src/gnome-chess.vala"
	return _data13_;
#line 7490 "gnome-chess.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 1292 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 7500 "gnome-chess.c"
		ChessApplication* self;
#line 1292 "../src/gnome-chess.vala"
		self = _data13_->self;
#line 1292 "../src/gnome-chess.vala"
		_g_object_unref0 (self);
#line 1292 "../src/gnome-chess.vala"
		g_slice_free (Block13Data, _data13_);
#line 7508 "gnome-chess.c"
	}
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 1361 "../src/gnome-chess.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 1361 "../src/gnome-chess.vala"
	return _data14_;
#line 7519 "gnome-chess.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 1361 "../src/gnome-chess.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 7529 "gnome-chess.c"
		ChessApplication* self;
#line 1361 "../src/gnome-chess.vala"
		self = _data14_->_data13_->self;
#line 1361 "../src/gnome-chess.vala"
		_g_object_unref0 (_data14_->save_error_dialog);
#line 1361 "../src/gnome-chess.vala"
		block13_data_unref (_data14_->_data13_);
#line 1361 "../src/gnome-chess.vala"
		_data14_->_data13_ = NULL;
#line 1361 "../src/gnome-chess.vala"
		g_slice_free (Block14Data, _data14_);
#line 7541 "gnome-chess.c"
	}
}

static void
____lambda23_ (Block14Data* _data14_)
{
	Block13Data* _data13_;
	ChessApplication* self;
	GtkMessageDialog* _tmp0_;
#line 1381 "../src/gnome-chess.vala"
	_data13_ = _data14_->_data13_;
#line 1381 "../src/gnome-chess.vala"
	self = _data13_->self;
#line 1382 "../src/gnome-chess.vala"
	_tmp0_ = _data14_->save_error_dialog;
#line 1382 "../src/gnome-chess.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 1383 "../src/gnome-chess.vala"
	if (_data13_->callback != NULL) {
#line 1384 "../src/gnome-chess.vala"
		_data13_->callback (FALSE, _data13_->callback_target);
#line 7563 "gnome-chess.c"
	}
}

static void
_____lambda23__gtk_dialog_response (GtkDialog* _sender,
                                    gint response_id,
                                    gpointer self)
{
#line 1381 "../src/gnome-chess.vala"
	____lambda23_ (self);
#line 7574 "gnome-chess.c"
}

static void
__lambda22_ (Block13Data* _data13_,
             gint response_id)
{
	ChessApplication* self;
	GtkFileChooserNative* _tmp11_;
	GError* _inner_error0_ = NULL;
#line 1356 "../src/gnome-chess.vala"
	self = _data13_->self;
#line 1357 "../src/gnome-chess.vala"
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1359 "../src/gnome-chess.vala"
		chess_application_update_pgn_time_remaining (self);
#line 7590 "gnome-chess.c"
		{
			GtkFileChooserNative* _tmp0_;
			GFile* _tmp1_;
			PGNGame* _tmp2_;
			GFile* _tmp3_;
#line 1363 "../src/gnome-chess.vala"
			_tmp0_ = self->priv->save_dialog;
#line 1363 "../src/gnome-chess.vala"
			_tmp1_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp0_);
#line 1363 "../src/gnome-chess.vala"
			_g_object_unref0 (self->priv->game_file);
#line 1363 "../src/gnome-chess.vala"
			self->priv->game_file = _tmp1_;
#line 1364 "../src/gnome-chess.vala"
			_tmp2_ = self->priv->pgn_game;
#line 1364 "../src/gnome-chess.vala"
			_tmp3_ = self->priv->game_file;
#line 1364 "../src/gnome-chess.vala"
			pgn_game_write (_tmp2_, _tmp3_, &_inner_error0_);
#line 1364 "../src/gnome-chess.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7612 "gnome-chess.c"
				goto __catch0_g_error;
			}
#line 1366 "../src/gnome-chess.vala"
			chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 1367 "../src/gnome-chess.vala"
			self->priv->game_needs_saving = FALSE;
#line 1369 "../src/gnome-chess.vala"
			if (_data13_->callback != NULL) {
#line 1370 "../src/gnome-chess.vala"
				_data13_->callback (TRUE, _data13_->callback_target);
#line 7623 "gnome-chess.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			Block14Data* _data14_;
			ChessWindow* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GtkMessageDialog* _tmp7_;
			GtkMessageDialog* _tmp8_;
			GtkMessageDialog* _tmp9_;
			GtkMessageDialog* _tmp10_;
#line 1361 "../src/gnome-chess.vala"
			e = _inner_error0_;
#line 1361 "../src/gnome-chess.vala"
			_inner_error0_ = NULL;
#line 1361 "../src/gnome-chess.vala"
			_data14_ = g_slice_new0 (Block14Data);
#line 1361 "../src/gnome-chess.vala"
			_data14_->_ref_count_ = 1;
#line 1361 "../src/gnome-chess.vala"
			_data14_->_data13_ = block13_data_ref (_data13_);
#line 1374 "../src/gnome-chess.vala"
			_tmp4_ = self->priv->_window;
#line 1374 "../src/gnome-chess.vala"
			_tmp5_ = e;
#line 1374 "../src/gnome-chess.vala"
			_tmp6_ = _tmp5_->message;
#line 1374 "../src/gnome-chess.vala"
			_tmp7_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp4_, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, _ ("Failed to save game: %s"), _tmp6_);
#line 1374 "../src/gnome-chess.vala"
			g_object_ref_sink (_tmp7_);
#line 1374 "../src/gnome-chess.vala"
			_data14_->save_error_dialog = _tmp7_;
#line 1380 "../src/gnome-chess.vala"
			_tmp8_ = _data14_->save_error_dialog;
#line 1380 "../src/gnome-chess.vala"
			gtk_dialog_add_button ((GtkDialog*) _tmp8_, _ ("_OK"), (gint) GTK_RESPONSE_OK);
#line 1381 "../src/gnome-chess.vala"
			_tmp9_ = _data14_->save_error_dialog;
#line 1381 "../src/gnome-chess.vala"
			g_signal_connect_data ((GtkDialog*) _tmp9_, "response", (GCallback) _____lambda23__gtk_dialog_response, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 1387 "../src/gnome-chess.vala"
			_tmp10_ = _data14_->save_error_dialog;
#line 1387 "../src/gnome-chess.vala"
			gtk_widget_show ((GtkWidget*) _tmp10_);
#line 1361 "../src/gnome-chess.vala"
			_g_error_free0 (e);
#line 1361 "../src/gnome-chess.vala"
			block14_data_unref (_data14_);
#line 1361 "../src/gnome-chess.vala"
			_data14_ = NULL;
#line 7678 "gnome-chess.c"
		}
		__finally0:
#line 1361 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1361 "../src/gnome-chess.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1361 "../src/gnome-chess.vala"
			g_clear_error (&_inner_error0_);
#line 1361 "../src/gnome-chess.vala"
			return;
#line 7689 "gnome-chess.c"
		}
	} else {
#line 1390 "../src/gnome-chess.vala"
		if (_data13_->callback != NULL) {
#line 1392 "../src/gnome-chess.vala"
			_data13_->callback (FALSE, _data13_->callback_target);
#line 7696 "gnome-chess.c"
		}
	}
#line 1395 "../src/gnome-chess.vala"
	_tmp11_ = self->priv->save_dialog;
#line 1395 "../src/gnome-chess.vala"
	gtk_native_dialog_hide ((GtkNativeDialog*) _tmp11_);
#line 7703 "gnome-chess.c"
}

static void
___lambda22__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 1356 "../src/gnome-chess.vala"
	__lambda22_ (self, response_id);
#line 7713 "gnome-chess.c"
}

static void
chess_application_present_save_dialog (ChessApplication* self,
                                       ChessApplicationPresentSaveDialogCallback callback,
                                       gpointer callback_target)
{
	Block13Data* _data13_;
	GtkFileChooserNative* _tmp0_;
	GtkFileChooserNative* _tmp29_;
	gulong _tmp30_;
	GtkFileChooserNative* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1292 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1292 "../src/gnome-chess.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 1292 "../src/gnome-chess.vala"
	_data13_->_ref_count_ = 1;
#line 1292 "../src/gnome-chess.vala"
	_data13_->self = g_object_ref (self);
#line 1292 "../src/gnome-chess.vala"
	_data13_->callback = callback;
#line 1292 "../src/gnome-chess.vala"
	_data13_->callback_target = callback_target;
#line 1294 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->save_dialog;
#line 1294 "../src/gnome-chess.vala"
	if (_tmp0_ == NULL) {
#line 7743 "gnome-chess.c"
		ChessWindow* _tmp1_;
		GtkFileChooserNative* _tmp2_;
		gboolean set_file = FALSE;
		GFile* _tmp3_;
		GtkFileFilter* pgn_filter = NULL;
		GtkFileFilter* _tmp17_;
		GtkFileFilter* _tmp18_;
		GtkFileFilter* _tmp19_;
		GtkFileChooserNative* _tmp20_;
		GtkFileFilter* _tmp21_;
		GtkFileFilter* all_filter = NULL;
		GtkFileFilter* _tmp22_;
		GtkFileFilter* _tmp23_;
		GtkFileFilter* _tmp24_;
		GtkFileChooserNative* _tmp25_;
		GtkFileFilter* _tmp26_;
		GtkFileChooserNative* _tmp27_;
#line 1296 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->_window;
#line 1296 "../src/gnome-chess.vala"
		_tmp2_ = gtk_file_chooser_native_new (_ ("Save Chess Game"), (GtkWindow*) _tmp1_, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Save"), _ ("_Cancel"));
#line 1296 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->save_dialog);
#line 1296 "../src/gnome-chess.vala"
		self->priv->save_dialog = _tmp2_;
#line 1302 "../src/gnome-chess.vala"
		set_file = FALSE;
#line 1303 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->game_file;
#line 1303 "../src/gnome-chess.vala"
		if (_tmp3_ != NULL) {
#line 7775 "gnome-chess.c"
			gchar* path = NULL;
			GFile* _tmp4_;
			gchar* _tmp5_;
			gboolean _tmp6_ = FALSE;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
#line 1313 "../src/gnome-chess.vala"
			_tmp4_ = self->priv->game_file;
#line 1313 "../src/gnome-chess.vala"
			_tmp5_ = g_file_get_path (_tmp4_);
#line 1313 "../src/gnome-chess.vala"
			path = _tmp5_;
#line 1314 "../src/gnome-chess.vala"
			_tmp7_ = path;
#line 1314 "../src/gnome-chess.vala"
			_tmp8_ = self->priv->autosave_filename;
#line 1314 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp7_, _tmp8_) != 0) {
#line 7794 "gnome-chess.c"
				const gchar* _tmp9_;
#line 1314 "../src/gnome-chess.vala"
				_tmp9_ = path;
#line 1314 "../src/gnome-chess.vala"
				_tmp6_ = !g_str_has_prefix (_tmp9_, "/run");
#line 7800 "gnome-chess.c"
			} else {
#line 1314 "../src/gnome-chess.vala"
				_tmp6_ = FALSE;
#line 7804 "gnome-chess.c"
			}
#line 1314 "../src/gnome-chess.vala"
			if (_tmp6_) {
#line 7808 "gnome-chess.c"
				{
					GtkFileChooserNative* _tmp10_;
					GFile* _tmp11_;
#line 1318 "../src/gnome-chess.vala"
					_tmp10_ = self->priv->save_dialog;
#line 1318 "../src/gnome-chess.vala"
					_tmp11_ = self->priv->game_file;
#line 1318 "../src/gnome-chess.vala"
					gtk_file_chooser_set_file ((GtkFileChooser*) _tmp10_, _tmp11_, &_inner_error0_);
#line 1318 "../src/gnome-chess.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7820 "gnome-chess.c"
						goto __catch0_g_error;
					}
#line 1319 "../src/gnome-chess.vala"
					set_file = TRUE;
#line 7825 "gnome-chess.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp12_;
					const gchar* _tmp13_;
#line 1316 "../src/gnome-chess.vala"
					e = _inner_error0_;
#line 1316 "../src/gnome-chess.vala"
					_inner_error0_ = NULL;
#line 1323 "../src/gnome-chess.vala"
					_tmp12_ = e;
#line 1323 "../src/gnome-chess.vala"
					_tmp13_ = _tmp12_->message;
#line 1323 "../src/gnome-chess.vala"
					g_warning ("gnome-chess.vala:1323: Failed to set file chooser default file: %s", _tmp13_);
#line 1316 "../src/gnome-chess.vala"
					_g_error_free0 (e);
#line 7845 "gnome-chess.c"
				}
				__finally0:
#line 1316 "../src/gnome-chess.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1316 "../src/gnome-chess.vala"
					_g_free0 (path);
#line 1316 "../src/gnome-chess.vala"
					block13_data_unref (_data13_);
#line 1316 "../src/gnome-chess.vala"
					_data13_ = NULL;
#line 1316 "../src/gnome-chess.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1316 "../src/gnome-chess.vala"
					g_clear_error (&_inner_error0_);
#line 1316 "../src/gnome-chess.vala"
					return;
#line 7862 "gnome-chess.c"
				}
			}
#line 1303 "../src/gnome-chess.vala"
			_g_free0 (path);
#line 7867 "gnome-chess.c"
		}
#line 1328 "../src/gnome-chess.vala"
		if (!set_file) {
#line 7871 "gnome-chess.c"
			GtkFileChooserNative* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1330 "../src/gnome-chess.vala"
			_tmp14_ = self->priv->save_dialog;
#line 1330 "../src/gnome-chess.vala"
			_tmp15_ = g_strconcat (_ ("Untitled Chess Game"), ".pgn", NULL);
#line 1330 "../src/gnome-chess.vala"
			_tmp16_ = _tmp15_;
#line 1330 "../src/gnome-chess.vala"
			gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp14_, _tmp16_);
#line 1330 "../src/gnome-chess.vala"
			_g_free0 (_tmp16_);
#line 7885 "gnome-chess.c"
		}
#line 1335 "../src/gnome-chess.vala"
		_tmp17_ = gtk_file_filter_new ();
#line 1335 "../src/gnome-chess.vala"
		pgn_filter = _tmp17_;
#line 1337 "../src/gnome-chess.vala"
		_tmp18_ = pgn_filter;
#line 1337 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp18_, _ ("PGN files"));
#line 1338 "../src/gnome-chess.vala"
		_tmp19_ = pgn_filter;
#line 1338 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp19_, "*.pgn");
#line 1339 "../src/gnome-chess.vala"
		_tmp20_ = self->priv->save_dialog;
#line 1339 "../src/gnome-chess.vala"
		_tmp21_ = pgn_filter;
#line 1339 "../src/gnome-chess.vala"
		gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp20_, _tmp21_);
#line 1341 "../src/gnome-chess.vala"
		_tmp22_ = gtk_file_filter_new ();
#line 1341 "../src/gnome-chess.vala"
		all_filter = _tmp22_;
#line 1343 "../src/gnome-chess.vala"
		_tmp23_ = all_filter;
#line 1343 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp23_, _ ("All files"));
#line 1344 "../src/gnome-chess.vala"
		_tmp24_ = all_filter;
#line 1344 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp24_, "*");
#line 1345 "../src/gnome-chess.vala"
		_tmp25_ = self->priv->save_dialog;
#line 1345 "../src/gnome-chess.vala"
		_tmp26_ = all_filter;
#line 1345 "../src/gnome-chess.vala"
		gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp25_, _tmp26_);
#line 1347 "../src/gnome-chess.vala"
		_tmp27_ = self->priv->save_dialog;
#line 1347 "../src/gnome-chess.vala"
		gtk_native_dialog_set_modal ((GtkNativeDialog*) _tmp27_, TRUE);
#line 1294 "../src/gnome-chess.vala"
		_g_object_unref0 (all_filter);
#line 1294 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn_filter);
#line 7931 "gnome-chess.c"
	}
#line 1353 "../src/gnome-chess.vala"
	if (self->priv->save_dialog_response_id != ((gulong) 0)) {
#line 7935 "gnome-chess.c"
		GtkFileChooserNative* _tmp28_;
#line 1354 "../src/gnome-chess.vala"
		_tmp28_ = self->priv->save_dialog;
#line 1354 "../src/gnome-chess.vala"
		g_signal_handler_disconnect ((GObject*) _tmp28_, self->priv->save_dialog_response_id);
#line 7941 "gnome-chess.c"
	}
#line 1356 "../src/gnome-chess.vala"
	_tmp29_ = self->priv->save_dialog;
#line 1356 "../src/gnome-chess.vala"
	_tmp30_ = g_signal_connect_data ((GtkNativeDialog*) _tmp29_, "response", (GCallback) ___lambda22__gtk_native_dialog_response, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 1356 "../src/gnome-chess.vala"
	self->priv->save_dialog_response_id = _tmp30_;
#line 1398 "../src/gnome-chess.vala"
	_tmp31_ = self->priv->save_dialog;
#line 1398 "../src/gnome-chess.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _tmp31_);
#line 1292 "../src/gnome-chess.vala"
	block13_data_unref (_data13_);
#line 1292 "../src/gnome-chess.vala"
	_data13_ = NULL;
#line 7957 "gnome-chess.c"
}

void
chess_application_save_game_cb (ChessApplication* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 1401 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1403 "../src/gnome-chess.vala"
	_tmp1_ = self->priv->game_file;
#line 1403 "../src/gnome-chess.vala"
	if (_tmp1_ == NULL) {
#line 1403 "../src/gnome-chess.vala"
		_tmp0_ = TRUE;
#line 7974 "gnome-chess.c"
	} else {
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 1403 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game_file;
#line 1403 "../src/gnome-chess.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1403 "../src/gnome-chess.vala"
		_tmp4_ = _tmp3_;
#line 1403 "../src/gnome-chess.vala"
		_tmp5_ = self->priv->autosave_filename;
#line 1403 "../src/gnome-chess.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, _tmp5_) == 0;
#line 1403 "../src/gnome-chess.vala"
		_g_free0 (_tmp4_);
#line 7992 "gnome-chess.c"
	}
#line 1403 "../src/gnome-chess.vala"
	if (_tmp0_) {
#line 1405 "../src/gnome-chess.vala"
		chess_application_present_save_dialog (self, NULL, NULL);
#line 1406 "../src/gnome-chess.vala"
		return;
#line 8000 "gnome-chess.c"
	}
#line 1409 "../src/gnome-chess.vala"
	chess_application_update_pgn_time_remaining (self);
#line 8004 "gnome-chess.c"
	{
		PGNGame* _tmp6_;
		GFile* _tmp7_;
#line 1413 "../src/gnome-chess.vala"
		_tmp6_ = self->priv->pgn_game;
#line 1413 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->game_file;
#line 1413 "../src/gnome-chess.vala"
		pgn_game_write (_tmp6_, _tmp7_, &_inner_error0_);
#line 1413 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8016 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1414 "../src/gnome-chess.vala"
		self->priv->game_needs_saving = FALSE;
#line 1415 "../src/gnome-chess.vala"
		chess_application_disable_action (self, SAVE_GAME_ACTION_NAME);
#line 8023 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1411 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1419 "../src/gnome-chess.vala"
		chess_application_present_save_dialog (self, NULL, NULL);
#line 8032 "gnome-chess.c"
	}
	__finally0:
#line 1411 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1411 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1411 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1411 "../src/gnome-chess.vala"
		return;
#line 8043 "gnome-chess.c"
	}
}

void
chess_application_save_game_as_cb (ChessApplication* self)
{
#line 1423 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1425 "../src/gnome-chess.vala"
	chess_application_present_save_dialog (self, NULL, NULL);
#line 8054 "gnome-chess.c"
}

static void
___lambda35_ (ChessApplication* self,
              gint response_id)
{
	GtkFileChooserNative* _tmp3_;
#line 1457 "../src/gnome-chess.vala"
	if (response_id == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 8064 "gnome-chess.c"
		GtkFileChooserNative* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 1459 "../src/gnome-chess.vala"
		_tmp0_ = self->priv->open_dialog;
#line 1459 "../src/gnome-chess.vala"
		_tmp1_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp0_);
#line 1459 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1459 "../src/gnome-chess.vala"
		self->priv->game_file = _tmp1_;
#line 1460 "../src/gnome-chess.vala"
		_tmp2_ = self->priv->game_file;
#line 1460 "../src/gnome-chess.vala"
		chess_application_load_game (self, _tmp2_);
#line 8080 "gnome-chess.c"
	}
#line 1463 "../src/gnome-chess.vala"
	_tmp3_ = self->priv->open_dialog;
#line 1463 "../src/gnome-chess.vala"
	gtk_native_dialog_hide ((GtkNativeDialog*) _tmp3_);
#line 8086 "gnome-chess.c"
}

static void
____lambda35__gtk_native_dialog_response (GtkNativeDialog* _sender,
                                          gint response_id,
                                          gpointer self)
{
#line 1456 "../src/gnome-chess.vala"
	___lambda35_ ((ChessApplication*) self, response_id);
#line 8096 "gnome-chess.c"
}

static void
__lambda34_ (ChessApplication* self,
             gboolean cancelled)
{
	GtkFileChooserNative* _tmp0_;
	GtkFileChooserNative* _tmp15_;
#line 1431 "../src/gnome-chess.vala"
	if (cancelled) {
#line 1432 "../src/gnome-chess.vala"
		return;
#line 8109 "gnome-chess.c"
	}
#line 1434 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->open_dialog;
#line 1434 "../src/gnome-chess.vala"
	if (_tmp0_ == NULL) {
#line 8115 "gnome-chess.c"
		ChessWindow* _tmp1_;
		GtkFileChooserNative* _tmp2_;
		GtkFileChooserNative* _tmp3_;
		GtkFileFilter* pgn_filter = NULL;
		GtkFileFilter* _tmp4_;
		GtkFileFilter* _tmp5_;
		GtkFileFilter* _tmp6_;
		GtkFileChooserNative* _tmp7_;
		GtkFileFilter* _tmp8_;
		GtkFileFilter* all_filter = NULL;
		GtkFileFilter* _tmp9_;
		GtkFileFilter* _tmp10_;
		GtkFileFilter* _tmp11_;
		GtkFileChooserNative* _tmp12_;
		GtkFileFilter* _tmp13_;
		GtkFileChooserNative* _tmp14_;
#line 1436 "../src/gnome-chess.vala"
		_tmp1_ = self->priv->_window;
#line 1436 "../src/gnome-chess.vala"
		_tmp2_ = gtk_file_chooser_native_new (_ ("Load Chess Game"), (GtkWindow*) _tmp1_, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Open"), _ ("_Cancel"));
#line 1436 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->open_dialog);
#line 1436 "../src/gnome-chess.vala"
		self->priv->open_dialog = _tmp2_;
#line 1441 "../src/gnome-chess.vala"
		_tmp3_ = self->priv->open_dialog;
#line 1441 "../src/gnome-chess.vala"
		gtk_native_dialog_set_modal ((GtkNativeDialog*) _tmp3_, TRUE);
#line 1444 "../src/gnome-chess.vala"
		_tmp4_ = gtk_file_filter_new ();
#line 1444 "../src/gnome-chess.vala"
		pgn_filter = _tmp4_;
#line 1446 "../src/gnome-chess.vala"
		_tmp5_ = pgn_filter;
#line 1446 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp5_, _ ("PGN files"));
#line 1447 "../src/gnome-chess.vala"
		_tmp6_ = pgn_filter;
#line 1447 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp6_, "*.pgn");
#line 1448 "../src/gnome-chess.vala"
		_tmp7_ = self->priv->open_dialog;
#line 1448 "../src/gnome-chess.vala"
		_tmp8_ = pgn_filter;
#line 1448 "../src/gnome-chess.vala"
		gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp7_, _tmp8_);
#line 1450 "../src/gnome-chess.vala"
		_tmp9_ = gtk_file_filter_new ();
#line 1450 "../src/gnome-chess.vala"
		all_filter = _tmp9_;
#line 1452 "../src/gnome-chess.vala"
		_tmp10_ = all_filter;
#line 1452 "../src/gnome-chess.vala"
		gtk_file_filter_set_name (_tmp10_, _ ("All files"));
#line 1453 "../src/gnome-chess.vala"
		_tmp11_ = all_filter;
#line 1453 "../src/gnome-chess.vala"
		gtk_file_filter_add_pattern (_tmp11_, "*");
#line 1454 "../src/gnome-chess.vala"
		_tmp12_ = self->priv->open_dialog;
#line 1454 "../src/gnome-chess.vala"
		_tmp13_ = all_filter;
#line 1454 "../src/gnome-chess.vala"
		gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp12_, _tmp13_);
#line 1456 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->open_dialog;
#line 1456 "../src/gnome-chess.vala"
		g_signal_connect_object ((GtkNativeDialog*) _tmp14_, "response", (GCallback) ____lambda35__gtk_native_dialog_response, self, 0);
#line 1434 "../src/gnome-chess.vala"
		_g_object_unref0 (all_filter);
#line 1434 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn_filter);
#line 8188 "gnome-chess.c"
	}
#line 1467 "../src/gnome-chess.vala"
	_tmp15_ = self->priv->open_dialog;
#line 1467 "../src/gnome-chess.vala"
	gtk_native_dialog_show ((GtkNativeDialog*) _tmp15_);
#line 8194 "gnome-chess.c"
}

static void
___lambda34__chess_application_prompt_save_game_callback (gboolean cancelled,
                                                          gpointer self)
{
#line 1430 "../src/gnome-chess.vala"
	__lambda34_ ((ChessApplication*) self, cancelled);
#line 8203 "gnome-chess.c"
}

void
chess_application_open_game_cb (ChessApplication* self)
{
#line 1428 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1430 "../src/gnome-chess.vala"
	chess_application_prompt_save_game (self, _ ("Save this game before loading another one?"), ___lambda34__chess_application_prompt_save_game_callback, self);
#line 8213 "gnome-chess.c"
}

static void
chess_application_start_new_game (ChessApplication* self)
{
	PGNGame* _tmp0_;
	GDateTime* now = NULL;
	GDateTime* _tmp1_;
	PGNGame* _tmp2_;
	GDateTime* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	PGNGame* _tmp6_;
	GDateTime* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint duration = 0;
	GSettings* _tmp10_;
	gchar* engine_name = NULL;
	GSettings* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* engine_level = NULL;
	GSettings* _tmp30_;
	gchar* _tmp31_;
	gboolean _tmp32_ = FALSE;
	const gchar* _tmp33_;
#line 1471 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1473 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 1473 "../src/gnome-chess.vala"
	self->priv->game_file = NULL;
#line 1475 "../src/gnome-chess.vala"
	chess_application_disable_action (self, SAVE_GAME_AS_ACTION_NAME);
#line 1477 "../src/gnome-chess.vala"
	_tmp0_ = pgn_game_new ();
#line 1477 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->pgn_game);
#line 1477 "../src/gnome-chess.vala"
	self->priv->pgn_game = _tmp0_;
#line 1478 "../src/gnome-chess.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 1478 "../src/gnome-chess.vala"
	now = _tmp1_;
#line 1479 "../src/gnome-chess.vala"
	_tmp2_ = self->priv->pgn_game;
#line 1479 "../src/gnome-chess.vala"
	_tmp3_ = now;
#line 1479 "../src/gnome-chess.vala"
	_tmp4_ = g_date_time_format (_tmp3_, "%Y.%m.%d");
#line 1479 "../src/gnome-chess.vala"
	_tmp5_ = _tmp4_;
#line 1479 "../src/gnome-chess.vala"
	pgn_game_set_date (_tmp2_, _tmp5_);
#line 1479 "../src/gnome-chess.vala"
	_g_free0 (_tmp5_);
#line 1480 "../src/gnome-chess.vala"
	_tmp6_ = self->priv->pgn_game;
#line 1480 "../src/gnome-chess.vala"
	_tmp7_ = now;
#line 1480 "../src/gnome-chess.vala"
	_tmp8_ = g_date_time_format (_tmp7_, "%H:%M:%S");
#line 1480 "../src/gnome-chess.vala"
	_tmp9_ = _tmp8_;
#line 1480 "../src/gnome-chess.vala"
	pgn_game_set_time (_tmp6_, _tmp9_);
#line 1480 "../src/gnome-chess.vala"
	_g_free0 (_tmp9_);
#line 1481 "../src/gnome-chess.vala"
	_tmp10_ = self->priv->settings;
#line 1481 "../src/gnome-chess.vala"
	duration = g_settings_get_int (_tmp10_, DURATION_SETTINGS_KEY);
#line 1482 "../src/gnome-chess.vala"
	if (duration > 0) {
#line 8289 "gnome-chess.c"
		PGNGame* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PGNGame* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		PGNGame* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
#line 1484 "../src/gnome-chess.vala"
		_tmp11_ = self->priv->pgn_game;
#line 1484 "../src/gnome-chess.vala"
		_tmp12_ = g_strdup_printf ("%i", duration);
#line 1484 "../src/gnome-chess.vala"
		_tmp13_ = _tmp12_;
#line 1484 "../src/gnome-chess.vala"
		pgn_game_set_time_control (_tmp11_, _tmp13_);
#line 1484 "../src/gnome-chess.vala"
		_g_free0 (_tmp13_);
#line 1485 "../src/gnome-chess.vala"
		_tmp14_ = self->priv->pgn_game;
#line 1485 "../src/gnome-chess.vala"
		_tmp15_ = g_strdup_printf ("%i", duration);
#line 1485 "../src/gnome-chess.vala"
		_tmp16_ = _tmp15_;
#line 1485 "../src/gnome-chess.vala"
		pgn_game_set_white_time_left (_tmp14_, _tmp16_);
#line 1485 "../src/gnome-chess.vala"
		_g_free0 (_tmp16_);
#line 1486 "../src/gnome-chess.vala"
		_tmp17_ = self->priv->pgn_game;
#line 1486 "../src/gnome-chess.vala"
		_tmp18_ = g_strdup_printf ("%i", duration);
#line 1486 "../src/gnome-chess.vala"
		_tmp19_ = _tmp18_;
#line 1486 "../src/gnome-chess.vala"
		pgn_game_set_black_time_left (_tmp17_, _tmp19_);
#line 1486 "../src/gnome-chess.vala"
		_g_free0 (_tmp19_);
#line 8329 "gnome-chess.c"
	}
#line 1488 "../src/gnome-chess.vala"
	_tmp20_ = self->priv->settings;
#line 1488 "../src/gnome-chess.vala"
	_tmp21_ = g_settings_get_string (_tmp20_, OPPONENT_SETTINGS_KEY);
#line 1488 "../src/gnome-chess.vala"
	engine_name = _tmp21_;
#line 1489 "../src/gnome-chess.vala"
	_tmp22_ = engine_name;
#line 1489 "../src/gnome-chess.vala"
	if (g_strcmp0 (_tmp22_, "") == 0) {
#line 8341 "gnome-chess.c"
		GList* _tmp23_;
#line 1491 "../src/gnome-chess.vala"
		_tmp23_ = self->priv->ai_profiles;
#line 1491 "../src/gnome-chess.vala"
		if (_tmp23_ != NULL) {
#line 8347 "gnome-chess.c"
			GList* _tmp24_;
			gconstpointer _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 1492 "../src/gnome-chess.vala"
			_tmp24_ = self->priv->ai_profiles;
#line 1492 "../src/gnome-chess.vala"
			_tmp25_ = _tmp24_->data;
#line 1492 "../src/gnome-chess.vala"
			_tmp26_ = ai_profile_get_name ((AIProfile*) _tmp25_);
#line 1492 "../src/gnome-chess.vala"
			_tmp27_ = _tmp26_;
#line 1492 "../src/gnome-chess.vala"
			_tmp28_ = g_strdup (_tmp27_);
#line 1492 "../src/gnome-chess.vala"
			_g_free0 (engine_name);
#line 1492 "../src/gnome-chess.vala"
			engine_name = _tmp28_;
#line 8367 "gnome-chess.c"
		} else {
			gchar* _tmp29_;
#line 1494 "../src/gnome-chess.vala"
			_tmp29_ = g_strdup ("human");
#line 1494 "../src/gnome-chess.vala"
			_g_free0 (engine_name);
#line 1494 "../src/gnome-chess.vala"
			engine_name = _tmp29_;
#line 8376 "gnome-chess.c"
		}
	}
#line 1496 "../src/gnome-chess.vala"
	_tmp30_ = self->priv->settings;
#line 1496 "../src/gnome-chess.vala"
	_tmp31_ = g_settings_get_string (_tmp30_, DIFFICULTY_SETTINGS_KEY);
#line 1496 "../src/gnome-chess.vala"
	engine_level = _tmp31_;
#line 1497 "../src/gnome-chess.vala"
	_tmp33_ = engine_name;
#line 1497 "../src/gnome-chess.vala"
	if (_tmp33_ != NULL) {
#line 8389 "gnome-chess.c"
		const gchar* _tmp34_;
#line 1497 "../src/gnome-chess.vala"
		_tmp34_ = engine_name;
#line 1497 "../src/gnome-chess.vala"
		_tmp32_ = g_strcmp0 (_tmp34_, "human") != 0;
#line 8395 "gnome-chess.c"
	} else {
#line 1497 "../src/gnome-chess.vala"
		_tmp32_ = FALSE;
#line 8399 "gnome-chess.c"
	}
#line 1497 "../src/gnome-chess.vala"
	if (_tmp32_) {
#line 8403 "gnome-chess.c"
		gchar* play_as = NULL;
		GSettings* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		const gchar* _tmp43_;
		GSettings* _tmp53_;
		const gchar* _tmp54_;
#line 1499 "../src/gnome-chess.vala"
		_tmp35_ = self->priv->settings;
#line 1499 "../src/gnome-chess.vala"
		_tmp36_ = g_settings_get_string (_tmp35_, PLAY_AS_SETTINGS_KEY);
#line 1499 "../src/gnome-chess.vala"
		play_as = _tmp36_;
#line 1501 "../src/gnome-chess.vala"
		_tmp37_ = play_as;
#line 1501 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp37_, "alternate") == 0) {
#line 8421 "gnome-chess.c"
			gchar* last_side = NULL;
			GSettings* _tmp38_;
			gchar* _tmp39_;
			const gchar* _tmp40_ = NULL;
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1503 "../src/gnome-chess.vala"
			_tmp38_ = self->priv->settings;
#line 1503 "../src/gnome-chess.vala"
			_tmp39_ = g_settings_get_string (_tmp38_, LAST_PLAYED_AS_SETTINGS_KEY);
#line 1503 "../src/gnome-chess.vala"
			last_side = _tmp39_;
#line 1504 "../src/gnome-chess.vala"
			_tmp41_ = last_side;
#line 1504 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp41_, "white") == 0) {
#line 1504 "../src/gnome-chess.vala"
				_tmp40_ = "black";
#line 8440 "gnome-chess.c"
			} else {
#line 1504 "../src/gnome-chess.vala"
				_tmp40_ = "white";
#line 8444 "gnome-chess.c"
			}
#line 1504 "../src/gnome-chess.vala"
			_tmp42_ = g_strdup (_tmp40_);
#line 1504 "../src/gnome-chess.vala"
			_g_free0 (play_as);
#line 1504 "../src/gnome-chess.vala"
			play_as = _tmp42_;
#line 1501 "../src/gnome-chess.vala"
			_g_free0 (last_side);
#line 8454 "gnome-chess.c"
		}
#line 1507 "../src/gnome-chess.vala"
		_tmp43_ = play_as;
#line 1507 "../src/gnome-chess.vala"
		if (g_strcmp0 (_tmp43_, "white") == 0) {
#line 8460 "gnome-chess.c"
			PGNGame* _tmp44_;
			const gchar* _tmp45_;
			PGNGame* _tmp46_;
			const gchar* _tmp47_;
#line 1509 "../src/gnome-chess.vala"
			_tmp44_ = self->priv->pgn_game;
#line 1509 "../src/gnome-chess.vala"
			_tmp45_ = engine_name;
#line 1509 "../src/gnome-chess.vala"
			pgn_game_set_black_ai (_tmp44_, _tmp45_);
#line 1510 "../src/gnome-chess.vala"
			_tmp46_ = self->priv->pgn_game;
#line 1510 "../src/gnome-chess.vala"
			_tmp47_ = engine_level;
#line 1510 "../src/gnome-chess.vala"
			pgn_game_set_black_level (_tmp46_, _tmp47_);
#line 8477 "gnome-chess.c"
		} else {
			const gchar* _tmp48_;
#line 1512 "../src/gnome-chess.vala"
			_tmp48_ = play_as;
#line 1512 "../src/gnome-chess.vala"
			if (g_strcmp0 (_tmp48_, "black") == 0) {
#line 8484 "gnome-chess.c"
				PGNGame* _tmp49_;
				const gchar* _tmp50_;
				PGNGame* _tmp51_;
				const gchar* _tmp52_;
#line 1514 "../src/gnome-chess.vala"
				_tmp49_ = self->priv->pgn_game;
#line 1514 "../src/gnome-chess.vala"
				_tmp50_ = engine_name;
#line 1514 "../src/gnome-chess.vala"
				pgn_game_set_white_ai (_tmp49_, _tmp50_);
#line 1515 "../src/gnome-chess.vala"
				_tmp51_ = self->priv->pgn_game;
#line 1515 "../src/gnome-chess.vala"
				_tmp52_ = engine_level;
#line 1515 "../src/gnome-chess.vala"
				pgn_game_set_white_level (_tmp51_, _tmp52_);
#line 8501 "gnome-chess.c"
			} else {
#line 1519 "../src/gnome-chess.vala"
				g_assert_not_reached ();
#line 8505 "gnome-chess.c"
			}
		}
#line 1522 "../src/gnome-chess.vala"
		_tmp53_ = self->priv->settings;
#line 1522 "../src/gnome-chess.vala"
		_tmp54_ = play_as;
#line 1522 "../src/gnome-chess.vala"
		g_settings_set_string (_tmp53_, LAST_PLAYED_AS_SETTINGS_KEY, _tmp54_);
#line 1497 "../src/gnome-chess.vala"
		_g_free0 (play_as);
#line 8516 "gnome-chess.c"
	}
#line 1525 "../src/gnome-chess.vala"
	chess_application_start_game (self);
#line 1471 "../src/gnome-chess.vala"
	_g_free0 (engine_level);
#line 1471 "../src/gnome-chess.vala"
	_g_free0 (engine_name);
#line 1471 "../src/gnome-chess.vala"
	_g_date_time_unref0 (now);
#line 8526 "gnome-chess.c"
}

static void
chess_application_load_game (ChessApplication* self,
                             GFile* file)
{
	PGNGame* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 1528 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1528 "../src/gnome-chess.vala"
	g_return_if_fail (file != NULL);
#line 8539 "gnome-chess.c"
	{
		PGN* pgn = NULL;
		PGN* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
		PGNGame* _tmp3_;
#line 1532 "../src/gnome-chess.vala"
		_tmp0_ = pgn_new_from_file (file, &_inner_error0_);
#line 1532 "../src/gnome-chess.vala"
		pgn = _tmp0_;
#line 1532 "../src/gnome-chess.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8552 "gnome-chess.c"
			goto __catch0_g_error;
		}
#line 1533 "../src/gnome-chess.vala"
		_tmp1_ = pgn->games;
#line 1533 "../src/gnome-chess.vala"
		_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
#line 1533 "../src/gnome-chess.vala"
		_tmp3_ = _g_object_ref0 ((PGNGame*) _tmp2_);
#line 1533 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1533 "../src/gnome-chess.vala"
		self->priv->pgn_game = _tmp3_;
#line 1530 "../src/gnome-chess.vala"
		_g_object_unref0 (pgn);
#line 8567 "gnome-chess.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 1530 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1537 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1537 "../src/gnome-chess.vala"
		self->priv->pgn_game = NULL;
#line 8578 "gnome-chess.c"
	}
	__finally0:
#line 1530 "../src/gnome-chess.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1530 "../src/gnome-chess.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1530 "../src/gnome-chess.vala"
		g_clear_error (&_inner_error0_);
#line 1530 "../src/gnome-chess.vala"
		return;
#line 8589 "gnome-chess.c"
	}
#line 1540 "../src/gnome-chess.vala"
	_tmp4_ = self->priv->pgn_game;
#line 1540 "../src/gnome-chess.vala"
	if (_tmp4_ == NULL) {
#line 8595 "gnome-chess.c"
		PGNGame* _tmp5_;
#line 1542 "../src/gnome-chess.vala"
		chess_application_run_invalid_pgn_dialog (self);
#line 1543 "../src/gnome-chess.vala"
		_tmp5_ = pgn_game_new ();
#line 1543 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->pgn_game);
#line 1543 "../src/gnome-chess.vala"
		self->priv->pgn_game = _tmp5_;
#line 1544 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1544 "../src/gnome-chess.vala"
		self->priv->game_file = NULL;
#line 8609 "gnome-chess.c"
	} else {
		GFile* _tmp6_;
#line 1548 "../src/gnome-chess.vala"
		_tmp6_ = _g_object_ref0 (file);
#line 1548 "../src/gnome-chess.vala"
		_g_object_unref0 (self->priv->game_file);
#line 1548 "../src/gnome-chess.vala"
		self->priv->game_file = _tmp6_;
#line 1549 "../src/gnome-chess.vala"
		chess_application_start_game (self);
#line 8620 "gnome-chess.c"
	}
}

void
chess_application_enable_action (ChessApplication* self,
                                 const gchar* name)
{
	GAction* _tmp0_;
#line 1553 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1553 "../src/gnome-chess.vala"
	g_return_if_fail (name != NULL);
#line 1555 "../src/gnome-chess.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 1555 "../src/gnome-chess.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), TRUE);
#line 8637 "gnome-chess.c"
}

void
chess_application_disable_action (ChessApplication* self,
                                  const gchar* name)
{
	GAction* _tmp0_;
#line 1558 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 1558 "../src/gnome-chess.vala"
	g_return_if_fail (name != NULL);
#line 1560 "../src/gnome-chess.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, name);
#line 1560 "../src/gnome-chess.vala"
	g_simple_action_set_enabled (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, g_simple_action_get_type (), GSimpleAction), FALSE);
#line 8653 "gnome-chess.c"
}

static gint
chess_application_main (gchar** args,
                        gint args_length1)
{
	ChessApplication* _tmp0_;
	ChessApplication* _tmp1_;
	gint _tmp2_;
	gint result;
#line 1565 "../src/gnome-chess.vala"
	setlocale (LC_ALL, "");
#line 1566 "../src/gnome-chess.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 1567 "../src/gnome-chess.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 1568 "../src/gnome-chess.vala"
	textdomain (GETTEXT_PACKAGE);
#line 1570 "../src/gnome-chess.vala"
	g_set_application_name (_ ("Chess"));
#line 1571 "../src/gnome-chess.vala"
	gtk_window_set_default_icon_name ("org.gnome.Chess");
#line 1573 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_new ();
#line 1573 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 1573 "../src/gnome-chess.vala"
	_tmp2_ = g_application_run ((GApplication*) _tmp1_, (gint) args_length1, args);
#line 1573 "../src/gnome-chess.vala"
	_g_object_unref0 (_tmp1_);
#line 1573 "../src/gnome-chess.vala"
	result = _tmp2_;
#line 1573 "../src/gnome-chess.vala"
	return result;
#line 8688 "gnome-chess.c"
}

int
main (int argc,
      char ** argv)
{
#line 1563 "../src/gnome-chess.vala"
	return chess_application_main (argv, argc);
#line 8697 "gnome-chess.c"
}

ChessWindow*
chess_application_get_window (ChessApplication* self)
{
	ChessWindow* result;
	ChessWindow* _tmp0_;
#line 37 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 37 "../src/gnome-chess.vala"
	result = _tmp0_;
#line 37 "../src/gnome-chess.vala"
	return result;
#line 8713 "gnome-chess.c"
}

static void
chess_application_set_window (ChessApplication* self,
                              ChessWindow* value)
{
	ChessWindow* old_value;
#line 37 "../src/gnome-chess.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/gnome-chess.vala"
	old_value = chess_application_get_window (self);
#line 37 "../src/gnome-chess.vala"
	if (old_value != value) {
#line 37 "../src/gnome-chess.vala"
		self->priv->_window = value;
#line 37 "../src/gnome-chess.vala"
		g_object_notify_by_pspec ((GObject *) self, chess_application_properties[CHESS_APPLICATION_WINDOW_PROPERTY]);
#line 8731 "gnome-chess.c"
	}
}

ChessView*
chess_application_get_view (ChessApplication* self)
{
	ChessView* result;
	ChessWindow* _tmp0_;
	ChessView* _tmp1_;
	ChessView* _tmp2_;
#line 42 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/gnome-chess.vala"
	_tmp0_ = self->priv->_window;
#line 42 "../src/gnome-chess.vala"
	_tmp1_ = chess_window_get_view (_tmp0_);
#line 42 "../src/gnome-chess.vala"
	_tmp2_ = _tmp1_;
#line 42 "../src/gnome-chess.vala"
	result = _tmp2_;
#line 42 "../src/gnome-chess.vala"
	return result;
#line 8754 "gnome-chess.c"
}

ChessScene*
chess_application_get_scene (ChessApplication* self)
{
	ChessScene* result;
	ChessView* _tmp0_;
	ChessView* _tmp1_;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
#line 47 "../src/gnome-chess.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/gnome-chess.vala"
	_tmp0_ = chess_application_get_view (self);
#line 47 "../src/gnome-chess.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/gnome-chess.vala"
	_tmp2_ = chess_view_get_scene (_tmp1_);
#line 47 "../src/gnome-chess.vala"
	_tmp3_ = _tmp2_;
#line 47 "../src/gnome-chess.vala"
	result = _tmp3_;
#line 47 "../src/gnome-chess.vala"
	return result;
#line 8779 "gnome-chess.c"
}

static void
chess_application_class_init (ChessApplicationClass * klass,
                              gpointer klass_data)
{
#line 30 "../src/gnome-chess.vala"
	chess_application_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/gnome-chess.vala"
	g_type_class_adjust_private_offset (klass, &ChessApplication_private_offset);
#line 30 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) chess_application_real_handle_local_options;
#line 30 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) chess_application_real_startup;
#line 30 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) chess_application_real_open;
#line 30 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) chess_application_real_activate;
#line 30 "../src/gnome-chess.vala"
	((GApplicationClass *) klass)->shutdown = (void (*) (GApplication*)) chess_application_real_shutdown;
#line 30 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_application_get_property;
#line 30 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_application_set_property;
#line 30 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (klass)->finalize = chess_application_finalize;
#line 30 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_WINDOW_PROPERTY, chess_application_properties[CHESS_APPLICATION_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TYPE_CHESS_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_VIEW_PROPERTY, chess_application_properties[CHESS_APPLICATION_VIEW_PROPERTY] = g_param_spec_object ("view", "view", "view", TYPE_CHESS_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 30 "../src/gnome-chess.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_APPLICATION_SCENE_PROPERTY, chess_application_properties[CHESS_APPLICATION_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8812 "gnome-chess.c"
}

static void
chess_application_instance_init (ChessApplication * self,
                                 gpointer klass)
{
	gchar* _tmp0_;
#line 30 "../src/gnome-chess.vala"
	self->priv = chess_application_get_instance_private (self);
#line 50 "../src/gnome-chess.vala"
	self->priv->new_game_window = NULL;
#line 51 "../src/gnome-chess.vala"
	self->priv->preferences_window = NULL;
#line 52 "../src/gnome-chess.vala"
	self->priv->about_dialog = NULL;
#line 53 "../src/gnome-chess.vala"
	self->priv->open_dialog = NULL;
#line 54 "../src/gnome-chess.vala"
	self->priv->save_dialog = NULL;
#line 55 "../src/gnome-chess.vala"
	self->priv->save_dialog_response_id = (gulong) 0;
#line 58 "../src/gnome-chess.vala"
	self->priv->game = NULL;
#line 61 "../src/gnome-chess.vala"
	self->priv->game_needs_saving = FALSE;
#line 62 "../src/gnome-chess.vala"
	self->priv->starting = TRUE;
#line 64 "../src/gnome-chess.vala"
	self->priv->opponent = NULL;
#line 65 "../src/gnome-chess.vala"
	self->priv->human_player = NULL;
#line 66 "../src/gnome-chess.vala"
	self->priv->opponent_engine = NULL;
#line 67 "../src/gnome-chess.vala"
	self->priv->engine_timeout_source = (guint) 0;
#line 68 "../src/gnome-chess.vala"
	_tmp0_ = g_strdup ("Copyright \302\251 2010\342\200\2232013 Robert Ancell\n" \
"Copyright \302\251 2013\342\200\2232020 Michael Catanzaro\n" \
"Copyright \302\251 2015\342\200\2232016 Sahil Sareen");
#line 68 "../src/gnome-chess.vala"
	self->priv->copyrights = _tmp0_;
#line 8852 "gnome-chess.c"
}

static void
chess_application_finalize (GObject * obj)
{
	ChessApplication * self;
#line 30 "../src/gnome-chess.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_APPLICATION, ChessApplication);
#line 32 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->settings);
#line 33 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences);
#line 50 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->new_game_window);
#line 51 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->preferences_window);
#line 52 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->about_dialog);
#line 53 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->open_dialog);
#line 54 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->save_dialog);
#line 57 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->pgn_game);
#line 58 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game);
#line 59 "../src/gnome-chess.vala"
	_g_free0 (self->priv->autosave_filename);
#line 60 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->game_file);
#line 63 "../src/gnome-chess.vala"
	(self->priv->ai_profiles == NULL) ? NULL : (self->priv->ai_profiles = (_g_list_free__g_object_unref0_ (self->priv->ai_profiles), NULL));
#line 64 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent);
#line 65 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->human_player);
#line 66 "../src/gnome-chess.vala"
	_g_object_unref0 (self->priv->opponent_engine);
#line 68 "../src/gnome-chess.vala"
	_g_free0 (self->priv->copyrights);
#line 30 "../src/gnome-chess.vala"
	G_OBJECT_CLASS (chess_application_parent_class)->finalize (obj);
#line 8895 "gnome-chess.c"
}

static GType
chess_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ChessApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessApplication), 0, (GInstanceInitFunc) chess_application_instance_init, NULL };
	GType chess_application_type_id;
	chess_application_type_id = g_type_register_static (adw_application_get_type (), "ChessApplication", &g_define_type_info, 0);
	ChessApplication_private_offset = g_type_add_instance_private (chess_application_type_id, sizeof (ChessApplicationPrivate));
	return chess_application_type_id;
}

GType
chess_application_get_type (void)
{
	static volatile gsize chess_application_type_id__once = 0;
	if (g_once_init_enter (&chess_application_type_id__once)) {
		GType chess_application_type_id;
		chess_application_type_id = chess_application_get_type_once ();
		g_once_init_leave (&chess_application_type_id__once, chess_application_type_id);
	}
	return chess_application_type_id__once;
}

static void
_vala_chess_application_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	ChessApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_APPLICATION, ChessApplication);
#line 30 "../src/gnome-chess.vala"
	switch (property_id) {
#line 30 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_WINDOW_PROPERTY:
#line 30 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_window (self));
#line 30 "../src/gnome-chess.vala"
		break;
#line 30 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_VIEW_PROPERTY:
#line 30 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_view (self));
#line 30 "../src/gnome-chess.vala"
		break;
#line 30 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_SCENE_PROPERTY:
#line 30 "../src/gnome-chess.vala"
		g_value_set_object (value, chess_application_get_scene (self));
#line 30 "../src/gnome-chess.vala"
		break;
#line 8948 "gnome-chess.c"
		default:
#line 30 "../src/gnome-chess.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/gnome-chess.vala"
		break;
#line 8954 "gnome-chess.c"
	}
}

static void
_vala_chess_application_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	ChessApplication * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_APPLICATION, ChessApplication);
#line 30 "../src/gnome-chess.vala"
	switch (property_id) {
#line 30 "../src/gnome-chess.vala"
		case CHESS_APPLICATION_WINDOW_PROPERTY:
#line 30 "../src/gnome-chess.vala"
		chess_application_set_window (self, g_value_get_object (value));
#line 30 "../src/gnome-chess.vala"
		break;
#line 8974 "gnome-chess.c"
		default:
#line 30 "../src/gnome-chess.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/gnome-chess.vala"
		break;
#line 8980 "gnome-chess.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

